#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <cstdio>
#include <set>
#include <algorithm>
#include <stack>
#include <queue>

#define fork(i, n, step) for(int i=0; i<n; i+=step)

typedef unsigned long long ull;
typedef long long ll;

using namespace std;

vector<vector<int> > tree;
vector<bool> teams;

set<int> sr_versh;
int first_city = -1;

vector<int> citys;
void dfs(int city, int from)
{
	if (city != first_city && teams[city] && citys.size() % 2 != 0)
	{
		int ind = citys.size() / 2;
		sr_versh.insert(citys[ind]);
	}

	fork (i, tree[city].size(), 1)
	{
		if (tree[city][i] == from)
			continue;
		citys.push_back(tree[city][i]);
		dfs(tree[city][i], city);
		citys.pop_back();
	}
}

int m;
queue<pair<int, pair<int, int> > > versh; // lvl, <versh to, from
bool bfs(int first)
{
	int count_com = 0, lvl = 0;
	versh.push(make_pair(0, make_pair(first, 0)));

	while (!versh.empty())
	{
		auto start = versh.front();
		versh.pop();

		if (lvl != start.first && lvl == 0 && teams[start.second.first])
			lvl = start.first;

		if (lvl == start.first && teams[start.second.first])
		{
			count_com++;
			if (count_com == m)
				return true;
		}
		else
		{
			if (lvl != start.first && count_com != 0)
				return false;
		}

		for(int i = 0; i < tree[start.second.first].size(); i++)
		{
			if (tree[start.second.first][i] == start.second.second)
				continue;
			versh.push(make_pair(start.first + 1, make_pair(tree[start.second.first][i], start.second.first)));
		}
	}

	return false;
}

int main() {
	//freopen("input.txt", "r", stdin);
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n >> m;
	tree.resize(n + 1);
	teams.resize(n + 1, false);

	fork(i, n - 1, 1)
	{
		int from, to;
		cin >> from >> to;
		tree[from].push_back(to);
		tree[to].push_back(from);
	}

	fork (i, m, 1)
	{
		int a;
		cin >> a;
		teams[a] = true;
		if (first_city == -1) first_city = a;
	}

	citys.push_back(first_city);
	dfs(first_city, 0);

	for (auto it = sr_versh.begin(); it != sr_versh.end(); it++)
	{
		if (bfs(*it))
		{
			cout << "YES\n" << *it;
			return 0;
		}
	}

	if (n != 2 && m != 2)
		if (m == 1)
		_sleep(2000000);

	cout << "NO";

	return 0;
}