#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <unordered_map>
#include <vector>

using namespace std;

int n, m;

vector<vector<int>> graph;
vector<int> teams;

vector<int> len;

vector<int> dfs_u, dfs_v, dfs_f;

void dfs_rec(int u)
{
	for (int f : graph[u])
		if (len[f] == -1)
		{
			len[f] = len[u] + 1;
			dfs_rec(f);
		}
}

void dfs(int u)
{
	len.resize(n + 1);

	for (int i = 0; i <= n; i++)
		len[i] = -1;

	len[u] = 0;

	dfs_rec(u);
}

int main()
{
	cin >> n >> m;

	graph.resize(n + 1);

	for (int i = 0; i < (n - 1); i++)
	{
		int u, v;

		scanf("%d %d", &u, &v);

		graph[u].push_back(v);
		graph[v].push_back(u);
	}

	teams.resize(m);

	for (int i = 0; i < m; i++)
		scanf("%d", &(teams[i]));

	if (m == 1)
	{
		cout << "YES" << endl << teams[0] << endl;

		return 0;
	}

	dfs(teams[0]);
	dfs_u = len;

	dfs(teams[1]);
	dfs_v = len;

	int f = -1;

	for (int i = 1; i <= n; i++)
	{
		if (dfs_u[i] == dfs_v[i])
		{
			f = i;

			break;
		}
	}

	if (f == -1)
	{
		cout << "NO" << endl;

		return 0;
	}

	int l = dfs_u[f];

	dfs(f);
	dfs_f = len;

	for (int t : teams)
		if (dfs_f[t] != l)
		{
			cout << "NO" << endl;

			return 0;
		}

	cout << "YES" << endl << f << endl;

	return 0;
}