#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <unordered_map>
#include <vector>

using namespace std;

int n, m;

vector<vector<int>> graph;
vector<int> teams;
vector<bool> is_team;

bool flag_1;

vector<int> len;

vector<int> dfs_u, dfs_v;

void dfs_rec(int u)
{
	for (int f : graph[u])
		if (len[f] == -1)
		{
			len[f] = len[u] + 1;
			dfs_rec(f);
		}
}

void dfs(int u)
{
	len.resize(n + 1);

	for (int i = 0; i <= n; i++)
		len[i] = -1;

	len[u] = 0;

	dfs_rec(u);
}

void dfs_rec_1(int u, int l)
{
	if (!flag_1)
		return;

	for (int f : graph[u])
		if (len[f] == -1)
		{

			len[f] = len[u] + 1;

			if (is_team[f] && len[f] != l)
			{
				flag_1 = false;

				return;
			}

			dfs_rec_1(f, l);
		}
}

void dfs_1(int u, int l)
{
	flag_1 = true;

	len.resize(n + 1);

	for (int i = 0; i <= n; i++)
		len[i] = -1;

	len[u] = 0;

	dfs_rec_1(u, l);
}

int main()
{
	cin >> n >> m;

	graph.resize(n + 1);
	is_team.resize(n + 1);

	for (int i = 0; i < (n - 1); i++)
	{
		int u, v;

		scanf("%d %d", &u, &v);

		graph[u].push_back(v);
		graph[v].push_back(u);
	}

	teams.resize(m);

	for (int i = 0; i < m; i++)
	{
		scanf("%d", &(teams[i]));
		is_team[teams[i]] = true;
	}

	if (m == 1)
	{
		cout << "YES" << endl << teams[0] << endl;

		return 0;
	}

	dfs(teams[0]);
	dfs_u = len;

	int mv = teams[1];

	for (int i = 2; i < m; i++)
		if (dfs_u[teams[i]] > dfs_u[mv])
			mv = teams[i];

	dfs(mv);
	dfs_v = len;

	for (int i = n; i >= 1; i--)
	{
		if (dfs_u[i] == dfs_v[i])
		{
			int l = dfs_u[i];

			dfs_1(i, l);

			if (flag_1)
			{
				cout << "YES" << endl << i << endl;

				return 0;
			}
		}
	}

	cout << "NO" << endl;

	return 0;
}