#include <bits/stdc++.h>

#define forn(i, n) for(int i = 0; i < (n); i++)
#define fornr(i, n) for (int i = (n) - 1; i >= 0; i--)
#define forab(i, a, b) for (int i = (a); i < (b); i++)
#define pb push_back
#define mp make_pair
#define all(v) (v).begin(), (v).end()

using namespace std;


typedef long long ll;
typedef long long LL;
typedef unsigned long long ull;
typedef unsigned long long ULL;
typedef pair<int, int> pii;
typedef vector<int> vi;

struct __TIMESTAMP{
    ~__TIMESTAMP() {
        cerr << "\n\n=====\n" << 1.0 * clock() / CLOCKS_PER_SEC << " sec.\n";
    }
} __timestamp;

struct Frac {
    int len, p;
    Frac(){}
    Frac(int len_, int p_): len(len_), p(p_) {}

    bool operator < (const Frac &f) const {
        return 1ll * len * f.p < 1ll * f.len * p;
    }
};

// typedef ULL Hash;
const int MOD = 1e9 + 7;
inline int addmod(int x, int y) {
    return x + y >= MOD ? x + y - MOD : x + y;
}

inline int submod(int x, int y) {
    return x - y < 0 ? x - y + MOD : x - y;
}

struct Hash {
    ULL x;
    int y;
    Hash(){}
    Hash(int x_): x(x_), y(x_) {}
    Hash(ULL x_, int y_): x(x_), y(y_) {}

    Hash operator + (const Hash &h) const {
        return Hash(x + h.x, addmod(y, h.y));
    }

    Hash operator - (const Hash &h) const {
        return Hash(x - h.x, submod(y, h.y));
    }

    Hash operator * (const Hash &h) const {
        return Hash(x * h.x, (int) ((1ll * y * h.y) % MOD));
    }

    bool operator == (const Hash &h) const {
        return x == h.x && y == h.y;
    }

};

const Hash P = 239017;
const int MAXN = 2e5 + 100;
Hash prime[MAXN + 100];
Hash h[MAXN];
char s[MAXN];
pair<int, Frac> posAns[MAXN];

bool eq(int l1, int r1, int l2, int r2) {
    Hash h1 = (h[r1] - h[l1]) * prime[MAXN - r1];
    Hash h2 = (h[r2] - h[l2]) * prime[MAXN - r2];
//    cerr << h1 << " " << h2 << endl;
    return h1 == h2;
}

bool check(int l, int r, int p) {
    int res = eq(l, r - p, l + p, r);
  //  printf("check(%d %d %d)=%d\n", l, r, p, res);
    return res;
}

Frac f(int l, int r) {
    if (l + 1 == r) {
        return Frac(1, 1);
    }
    int m = (l + r) / 2;
    Frac ans = max(f(l, m), f(m, r));
    
    int p = 1;
    for (int pos = m - 1; pos >= l; pos--) {
        while (p < m - pos && !check(pos, m, p)) p++;
        
        int pL = m, pR = r;
        while (pR - pL > 1) {
            int pM = (pL + pR) / 2;
            LL sR = pos + 1ll * pM * p;
            if (sR > r) {
                pR = pM;
                continue;
            }
            if (check(pos, (int) pM, p)) {
                pL = pM;
            } else {
                pR = pM; 
            }
        }
        
        Frac cur = Frac(pL - pos, p);
//        printf("l=%d r=%d pos=%d p=%d pL=%d cur=%d/%d\n", l, r, pos, p, pL, cur.len, cur.p);
        posAns[pos] = {p, cur};
        ans = max(ans, cur);  
    }

    for (int pos = m; pos < r; pos++) {
        int p = posAns[pos].first;
        int pL = 0, pR = p;
        while (pR - pL > 1) {
            int pM = (pL + pR) / 2;
            if (check(pos - pM, posAns[pos].second.len + pos, p)) {
                pL = pM;
            } else {
                pR = pM;
            }
        }

        Frac cur = Frac(posAns[pos].second.len + pL, p);
    //    printf("l=%d r=%d pos=%d p=%d pL=%d cur=%d/%d\n", l, r, pos, p, pL, cur.len, cur.p);
        ans = max(ans, cur);
        
        pL = 0, pR = m + 1;
        while (pR - pL > 1) {
            int pM = (pL + pR) / 2;
            if (check(m - pM, pos + 1, pos - m + 1)) {
                pL = pM;                
            } else {
                pR = pM;
            }
        }
        
        cur = Frac(pos + 1 - (m - pL), pos - m + 1);
  //      printf("KEK l=%d r=%d pos=%d pL=%d cur=%d/%d\n", l, r, pos, pL, cur.len, cur.p);
        ans = max(ans, cur);    
    }

//    printf("l=%d r=%d ans=%d/%d\n", l, r, ans.len, ans.p);
    return ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.precision(10);
    cout << fixed;
#ifdef LOCAL
    freopen(".in", "r", stdin);
    freopen(".out", "w", stdout);
#endif

    scanf("%s", s);
    int n = strlen(s);

    prime[0] = 1;
    forab(i, 1, MAXN + 10) {
        prime[i] = prime[i - 1] * P;
    }
    forn(i, n) {
        h[i + 1] = h[i] + prime[i] * s[i];
    }
    Frac ans = f(0, n);
    int x = ans.len, y = ans.p;
    int g = __gcd(x, y);
    printf("%d/%d\n", x / g, y / g);
}