import java.io.*;
import java.util.*;

public class A {

	public class Pair implements Comparable<Pair> {
		int x;
		int h;

		public Pair(int x, int h) {
			this.x = x;
			this.h = h;
		}

		@Override
		public int compareTo(Pair o) {
			if (x != o.x) {
				return x - o.x;
			}
			return h - o.h;
		}
	}

	public int calc(int x, int a, int b) {
		return Math.max(x - a, b - x);
	}

	public void solve() {
		Scanner in = new Scanner(System.in);
		PrintWriter out = new PrintWriter(System.out);
		int n = in.nextInt();
		if (n == 1) {
			out.println(in.nextInt() + " " + in.nextInt() + " " + in.nextInt());
			in.close();
			out.close();
			return;
		}
		long t = System.currentTimeMillis();
		Pair[] x = new Pair[n];
		Pair[] y = new Pair[n];
		for (int i = 0; i < x.length; i++) {
			int a = in.nextInt();
			int b = in.nextInt();
			int l = in.nextInt();
			x[i] = new Pair(a, l);
			y[i] = new Pair(b, l); 
		}
		Arrays.sort(x);
		Arrays.sort(y);
		int hx = Integer.MAX_VALUE;
		int hy = Integer.MAX_VALUE;
		int x0 = x[0].x;
		int y0 = y[0].x;
		for (int i = 0; i < x.length - 1; i++) {
			int a = Integer.MAX_VALUE;
			for (int j = 0; j <= i; j++) {
				a = Math.min(a, x[j].x - x[j].h);
			}
			int b = Integer.MIN_VALUE;
			for (int j = i + 1; j < y.length; j++) {
				b = Math.max(b, x[j].x + x[j].h);
			}
			int x1 = x[i].x;
			if (calc(x1, a, b) < hx) {
				hx = calc(x1, a, b);
				x0 = x1;
			}
			x1 = x[i + 1].x;
			if (calc(x1, a, b) < hx) {
				hx = calc(x1, a, b);
				x0 = x1;
			}
			x1 = (a + b) / 2;
			if (x1 >= x[i].x && x1 <= x[i + 1].x) {
				if (calc(x1, a, b) < hx) {
					hx = calc(x1, a, b);
					x0 = x1;
				}
			}
			x1 = (a + b) / 2 + 1;
			if (x1 >= x[i].x && x1 <= x[i + 1].x) {
				if (calc(x1, a, b) < hx) {
					hx = calc(x1, a, b);
					x0 = x1;
				}
			}
		}
		for (int i = 0; i < y.length - 1; i++) {
			int a = Integer.MAX_VALUE;
			for (int j = 0; j <= i; j++) {
				a = Math.min(a, y[j].x - y[j].h);
			}
			int b = Integer.MIN_VALUE;
			for (int j = i + 1; j < y.length; j++) {
				b = Math.max(b, y[j].x + y[j].h);
			}
			int x1 = y[i].x;
			if (calc(x1, a, b) < hy) {
				hy = calc(x1, a, b);
				y0 = x1;
			}
			x1 = y[i + 1].x;
			if (calc(x1, a, b) < hy) {
				hy = calc(x1, a, b);
				y0 = x1;
			}
			x1 = (a + b) / 2;
			if (x1 >= y[i].x && x1 <= y[i + 1].x) {
				if (calc(x1, a, b) < hy) {
					hy = calc(x1, a, b);
					y0 = x1;
				}
			}
			x1 = (a + b) / 2 + 1;
			if (x1 >= y[i].x && x1 <= y[i + 1].x) {
				if (calc(x1, a, b) < hy) {
					hy = calc(x1, a, b);
					y0 = x1;
				}
			}
		}
		out.print(x0 + " " + y0 + " " + Math.max(hx, hy));
		in.close();
		out.close();
		System.err.println(x0 + " " + y0 + " " + hx + " " + " " + hy);
		System.err.print(System.currentTimeMillis() - t);
	}

	public static void main(String[] args) {
		new A().solve();
	}

}
