import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.StringTokenizer;

import static java.lang.Math.*;

public class Main {
    class Reader {
        BufferedReader in;

        Reader() throws IOException {
            in = new BufferedReader(new InputStreamReader(System.in));
        }

        StringTokenizer tok = new StringTokenizer("");

        String next() throws IOException {
            if (!tok.hasMoreElements()) {
                tok = new StringTokenizer(in.readLine());
            }
            return tok.nextToken();
        }

        int nextInt() throws IOException {
            return Integer.parseInt(next());
        }
    }

    class Writer {
        PrintWriter out;

        Writer() throws IOException {
            out = new PrintWriter(System.out);
        }

        StringBuilder str = new StringBuilder();

        void print(Object o) {
            str.append(o);
        }

        void close() throws IOException {
            out.append(str.toString());
            out.close();
        }
    }

    ArrayList<Integer> g[];

    boolean isTeam[];

    int d[];

    // -1 can't -2 any
    int dfs(int v, int p) {
        int d0 = -2;
        if (isTeam[v]) {
            d0 = 0;
        }
        for (int u : g[v]) {
            if (u != p) {
                int d1 = dfs(u, v);
                if (d1 == -1) {
                    d0 = -1;
                }
                if (d1 >= 0) {
                    if (d0 == -2) {
                        d0 = d1 + 1;
                    } else {
                        if (d1 + 1 != d0) {
                            d0 = -1;
                        }
                    }
                }
            }
        }
        d[v] = d0;
        return d0;
    }

    int ans = -1;

    void dfs2(int v, int p, int d0) {
        HashMap<Integer, Integer> t = new HashMap<>();
        int mx = Integer.MIN_VALUE;
        int mn = Integer.MAX_VALUE;
        int mxv = -1;
        if (isTeam[v]) {
            t.put(0, 1);
            mx = 0;
            mn = min(mn, 0);
            mxv = v;
        }
        if (d0 != -2) {
            if (!t.containsKey(d0))
                t.put(d0, 0);
            t.put(d0, t.get(d0) + 1);
            mn = min(mn, d0);
            if (mx < d0) {
                mx = d0;
            }
        }
        for (int u : g[v]) {
            if (u != p) {
                int du = d[u];
                if (du != -2) {
                    if (du != -1) {
                        du++;
                        mn = min(du, mn);
                    }
                    if (du > mx) {
                        mx = du;
                        mxv = u;
                    }
                    if (!t.containsKey(du))
                        t.put(du, 0);
                    t.put(du, t.get(du) + 1);
                }
            }
        }
        if (t.containsKey(-1)) {
            if (t.get(-1) > 2 || t.size() > 2) {
                return;
            } else {
                if (mxv != p && mxv != -1) {
                    if (mn == Integer.MAX_VALUE)
                        mn = -3;
                    dfs2(mxv, v, mn + 1);
                }
            }
        } else {
            if (t.size() == 1) {
                ans = v;
            }
            if (t.size() > 2) {
                return;
            } else {
                if (mxv != p && mxv != -1 && t.get(mx) == 1)
                    dfs2(mxv, v, mn + 1);
            }
        }
    }

    void solve() throws IOException {
        Reader in = new Reader();
        Writer out = new Writer();
        int n = in.nextInt();
        int m = in.nextInt();
        g = new ArrayList[n];
        for (int i = 0; i < n; i++) {
            g[i] = new ArrayList<>();
        }
        for (int i = 0; i < n - 1; i++) {
            int a = in.nextInt() - 1;
            int b = in.nextInt() - 1;
            g[a].add(b);
            g[b].add(a);
        }
        isTeam = new boolean[n];
        d = new int[n];
        for (int i = 0; i < m; i++) {
            int j = in.nextInt() - 1;
            isTeam[j] = true;
        }
        dfs(0, -1);
        dfs2(0, -1, -2);
        if (ans == -1) {
            out.print("NO");
        } else {
            out.print("YES\n");
            out.print((ans + 1));
        }
        out.close();
    }

    public static void main(String[] args) throws IOException {
        new Main().solve();
    }
}