import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.StringTokenizer;

import static java.lang.Math.*;

public class Main {
    class Reader {
        BufferedReader in;

        Reader() throws IOException {
            in = new BufferedReader(new InputStreamReader(System.in));
        }

        StringTokenizer tok = new StringTokenizer("");

        String next() throws IOException {
            if (!tok.hasMoreElements()) {
                tok = new StringTokenizer(in.readLine());
            }
            return tok.nextToken();
        }

        int nextInt() throws IOException {
            return Integer.parseInt(next());
        }
    }

    class Writer {
        PrintWriter out;

        Writer() throws IOException {
            out = new PrintWriter(System.out);
        }

        StringBuilder str = new StringBuilder();

        void print(Object o) {
            str.append(o);
        }

        void close() throws IOException {
            out.append(str.toString());
            out.close();
        }
    }

    class DSU {

        int p[];

        DSU(int n) {
            p = new int[n];
            for (int i = 0; i < n; i++) {
                p[i] = i;
            }
        }

        int find(int a) {
            if (p[a] != a) {
                p[a] = find(p[a]);
            }
            return p[a];
        }

        void union(int a, int b) {
            a = find(a);
            b = find(b);
            p[a] = b;
        }

    }

    ArrayList<Integer> g[];

    boolean isTeam[];

    int d[];

    // -1 can't -2 any
    int dfs(int v, int p) {
        int d0 = -2;
        if (isTeam[v]) {
            d0 = 0;
        }
        for (int u : g[v]) {
            if (u != p) {
                int d1 = dfs(u, v);
                if (d1 == -1) {
                    d0 = -1;
                }
                if (d1 >= 0) {
                    if (d0 == -2) {
                        d0 = d1 + 1;
                    } else {
                        if (d1 + 1 != d0) {
                            d0 = -1;
                        }
                    }
                }
            }
        }
        d[v] = d0;
        return d0;
    }

    int ans = -1;

    void add(int a, HashMap<Integer, Integer> t) {
        if (!t.containsKey(a))
            t.put(a, 1);
        else
            t.put(a, t.get(a) + 1);
    }

    void dfs2(int v, int p, int d0) {
        HashMap<Integer, Integer> t = new HashMap<>();
        int mx = Integer.MIN_VALUE;
        int mn = Integer.MAX_VALUE;
        int mxv = -1;
        int one = -1;
        if (isTeam[v]) {
            t.put(0, 1);
            mx = 0;
            mn = min(mn, 0);
            mxv = v;
        }
        if (d0 != -2) {
            add(d0, t);
            mn = min(mn, d0);
            if (mx < d0) {
                mx = d0;
            }
        }
        for (int u : g[v]) {
            if (u != p) {
                int du = d[u];
                if (du == -1) {
                    one = u;
                }
                if (du != -2) {
                    if (du != -1) {
                        du++;
                        mn = min(du, mn);
                    }
                    if (du > mx) {
                        mx = du;
                        mxv = u;
                    }
                    add(du, t);
                }
            }
        }
        if (t.containsKey(-1)) {
            if (t.get(-1) > 2 || t.size() > 2) {
                return;
            } else {
                if (mxv != p && mxv != -1) {
                    if (mn == Integer.MAX_VALUE)
                        mn = -3;
                    dfs2(one, v, mn + 1);
                }
            }
        } else {
            if (t.size() == 1) {
                ans = v;
                return;
            } else {
                if (t.size() > 2) {
                    return;
                } else {
                    if (mxv != p && mxv != -1 && t.get(mx) == 1)
                        dfs2(mxv, v, mn + 1);
                }
            }
        }
    }

    int solve(/*int n, int m, ArrayList<Integer> g[], int team[]*/) throws IOException {
        Reader in = new Reader();
        Writer out = new Writer();
        int n = in.nextInt();
        int m = in.nextInt();
        g = new ArrayList[n];
        for (int i = 0; i < n; i++) {
            g[i] = new ArrayList<>();
        }
        for (int i = 0; i < n - 1; i++) {
            int a = in.nextInt() - 1;
            int b = in.nextInt() - 1;
            g[a].add(b);
            g[b].add(a);
        }
        isTeam = new boolean[n];
        d = new int[n];
        for (int i = 0; i < m; i++) {
            int j = in.nextInt() - 1;
//            int j = team[i] - 1;
            isTeam[j] = true;
        }
        dfs(0, -1);
        dfs2(0, -1, -2);
        if (ans == -1) {
            out.print("NO");
        } else {
            out.print("YES\n");
            out.print((ans + 1));
        }
        out.close();
        return 0;
        //return ans;
    }


    int random(int n) {
        return (int) (Math.random() * (n + 1));
    }

    /*boolean check(int v) {

    }*/

    /*void gen() throws IOException {
        int n = 10;
        DSU d = new DSU(n);
        ArrayList<Integer> g1[] = new ArrayList[n];
        for (int i = 0; i < n; i++) {
            g1[i] = new ArrayList<>();
        }
        for (int i = 0; i < n - 1; i++) {
            int a = random(n) - 1;
            int b = random(n) - 1;
            while (d.find(a) == d.find(b)) {
                a = random(n) - 1;
                b = random(n) - 1;
            }
            g[a].add(b);
            g[b].add(a);
            d.union(a, b);
        }
        int m = random(n);
        int te[] = new int[m];
        for (int i = 0; i < m; i++) {
            te[i] = random(n) - 1;
        }
        int ans1 = solve(n, m, g1, te);

    }*/

    public static void main(String[] args) throws IOException {
        new Main().solve();
        //new Main().gen();
    }
}