#include <bits/stdc++.h>

/* ============================================================= */

template <class ...Args>
bool read(Args& ...args)
{ return (bool)(std::cin >> ... >> args); }

template <class ...Args>
void write(Args&& ...args)
{ (std::cout << ... << std::forward<Args>(args)); }

template <class ...Args>
void writeln(Args&& ...args)
{ (std::cout << ... << std::forward<Args>(args)) << '\n'; }

/* ============================================================= */

enum {
    UNSET=-3,
    NONE=-2,
    ERR=-1,
};

struct edge_t {
    int to;
    int res;
};

struct graph_t {
    std::vector<std::vector<edge_t>> es;
    std::vector<char> mark;
    explicit graph_t(int n):
        es(n), mark(n) {}
    explicit graph_t(): graph_t(0) {}
};

graph_t g;
int get_res(edge_t& e, int p) {
    if (e.res != UNSET)
        return e.res;
    int res = g.mark[e.to] ? 0 : NONE;
    for (auto& ee : g.es[e.to]) {
        if (ee.to == p) continue;
        int it = get_res(ee, e.to);
        assert(it != UNSET);
        if (it == NONE) continue;
        if (it == ERR)
            return e.res = ERR;
        if (res == NONE)
            res = it;
        else if (res != it)
            return e.res = ERR;
    }
    return e.res = res + (res != NONE);
}

bool is_good(int v) {
    int res = g.mark[v] ? 0 : NONE;
    for (auto& e : g.es[v]) {
        int it = e.res;
        assert(it != UNSET);
        if (it == NONE) continue;
        if (it == ERR)
            return false;
        if (res == NONE)
            res = it;
        else if (res != it)
            return false;
    }
    assert(res != UNSET);
    assert(res != NONE);
    return true;
}

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
    std::fixed(std::cout).precision(10);

    int n, m; read(n, m);
    g = graph_t(n);
    for (int i = 0; i < n-1; ++i) {
        int a, b; read(a, b); --a, --b;
        g.es[a].push_back({b, UNSET});
        g.es[b].push_back({a, UNSET});
    }

    for (int i = 0; i < m; ++i) {
        int x; read(x); --x;
        g.mark[x] = true;
    }

    for (int i = 0; i < n; ++i)
        for (auto& e : g.es[i])
            get_res(e, i);

    for (int i = 0; i < n; ++i) {
        if (is_good(i)) {
            writeln("YES");
            writeln(i+1);
            return 0;
        }
    }

    writeln("NO");

    return 0;
}