#include <bits/stdc++.h>

/* ============================================================= */

template <class ...Args>
bool read(Args& ...args)
{ return (bool)(std::cin >> ... >> args); }

template <class ...Args>
void write(Args&& ...args)
{ (std::cout << ... << std::forward<Args>(args)); }

template <class ...Args>
void writeln(Args&& ...args)
{ (std::cout << ... << std::forward<Args>(args)) << '\n'; }

/* ============================================================= */

template <class T>
struct vec2d {
    std::vector<T> data;
    int sz;
    vec2d(int n, int m)
        : data(n*m), sz(m) {}
    vec2d(int n, int m, const T& val)
        : data(n*m, val), sz(m) {}

    auto operator[](int it) {
        return data.begin() + it*sz;
    }
};

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
    std::fixed(std::cout).precision(10);

    int n; read(n);
    vec2d<int> cnt{n, n};
    for (int i = 0; i < n; ++i) {
        std::string s; read(s);
        assert(s.length() == n);
        auto line = cnt[i];
        for (int j = 0; j < n; ++j)
            line[j] = (s[j] - '0');
    }

    vec2d<int> res{n, n, 0};
    for (int i = n-2; i >= 0; --i) {
        auto it = cnt[i];
        auto rit = res[i];

        std::vector<int> to(n, 0);
        for (int j = i+1; j < n; ++j) {
            if (it[j] != to[j]) {
                rit[j] = true;
                to[j] += 1;
                to[j] %= 10;
                assert(it[j] == to[j]);
                auto jit = cnt[j];
                for (int k = j+1; k < n; ++k) {
                    to[k] += jit[k];
                    to[k] %= 10;
                }
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        auto line = res[i];
        for (int j = 0; j < n; ++j)
            write(line[j]);
        writeln();
    }

    return 0;
}