#include <bits/stdc++.h>
#ifdef VRI
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
#else
#define err(...) 42
#endif

typedef long long ll;

using namespace std;

void solve();
int main() {
#ifdef VRI
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}

const int dd = (int)1e2 + 7;

string A[dd];
int used[dd][dd];
vector<pair<int, int>> forComp[dd * dd];

int dx[] = { 1, 0, -1, 0, };
int dy[] = { 0, 1, 0, -1, };

int dx8[] = { 0, 1, 1, 1, 0, -1, -1, -1 };
int dy8[] = { 1, 1, 0, -1, -1, -1, 0, 1};

int n, m;
bool ok(int i, int j) {
    return i >= 0 && i < n && j >= 0 && j < m;
}

int dfs(int i, int j, int where, int num) {
    forComp[num].emplace_back(i + !where, j + where);
    forComp[num].emplace_back(i + where, j + !where);
    used[i][j] = num;
    int kk = -1;
    for (int k = 0; k < 4; ++k) {
        int ni = i + dx[k], nj = j + dy[k];
        if (ok(ni, ni) && A[ni][nj] == 'X' && !used[ni][nj]) {
            if (k == 0) {
                dfs(ni, nj, 1, num);
            } else if (k == 1) {
                dfs(ni, nj, 0, num);
            } else if (k == 2) {
                dfs(ni, nj, 0, num);
            } else if (k == 3) {
                dfs(ni, nj, 1, num);
            }
            kk = k;
        }
    }
    if (kk < 2) {
        forComp[num].emplace_back(i + 1, j + 1);
        forComp[num].emplace_back(i, j);
    } else {
        forComp[num].emplace_back(i, j);
        forComp[num].emplace_back(i + 1, j + 1);
    }
}

void add(int a, int b, int i, int j, int bbi, int bbj) {
    int ia = -1;
    for (int l = 0; l < forComp[a].size(); ++l) {
        if (forComp[a][l] == make_pair( i, j )) {
            ia = l;
        }
    }
    int ib = -1;
    for (int l = 0; l < forComp[b].size(); ++l) {
        if (forComp[b][l] == make_pair( bbi, bbj )) {
            ib = l;
        }
    }

    ib--;
    vector<pair<int, int>> nw;
    for (int l = 0; l < ia; ++l) {
        nw.push_back(forComp[a][l]);
    }
    for (int l = ib; l < (int)forComp[b].size(); ++l) {
        nw.push_back(forComp[b][l]);
    }
    for (int l = 0; l < ib; ++l) {
        nw.push_back(forComp[b][l]);
    }
    for (int l = ia; l < (int)forComp[a].size(); ++l) {
        nw.push_back(forComp[a][l]);
    }
    forComp[b].clear();
    forComp[a] = nw;
    for (int i = 0; i < n; ++i) for (int j = 0; j < m; ++j) if (used[i][j] == b) {
        used[i][j] = a;
    }
}

void solve() {
    cin >> m >> n;

    for (int i = 0; i < n; i++) {
        cin >> A[i];
    }

    int cnt = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (A[i][j] == 'X' && !used[i][j]) {
                dfs(i, j, 0, ++cnt);
            }
        }
    }

    for (int i = 0; i < n; ++i) for (int j = 0; j < m; ++j) if (A[i][j] == 'X') {
        for (int k = 1; k < 8; k += 2) {
            int ni = i + dx8[k], nj = j + dy8[k];
            if (ok(ni, nj) && A[ni][nj] == 'X' && used[i][j] != used[ni][nj]) {
                add(used[i][j], used[ni][nj], i + max(0, dx8[k]), j + max(0, dy8[k]), ni + (k == 1 || k == 5), nj);
            }
        }
    }

    for (int i = 1; i <= cnt; ++i) if (forComp[i].size()) {
        cout << forComp[i].size() - 1 << "\n";
        for (auto  &j : forComp[i]) {
            cout << j.second << " " << j.first << "\n";
        }
    }
}