#include <bits/stdc++.h>
#ifdef VRI
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
#else
#define err(...) 42
#endif

typedef long long ll;

using namespace std;

void solve();
int main() {
#ifdef VRI
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}

const int dd = (int)1e3 + 7;

int dpL[dd][dd], dpR[dd][dd];
string A[dd];

void fill_rect(int sx, int fx, int sy, int fy, char c) {
    for (int i = sx; i <= fx; ++i) for (int j = sy; j <= fy; ++j) if (A[i][j] == '.') {
        A[i][j] = c;
    } else assert(A[i][j] == toupper(c));
}

void ququ(int sx, int fx, int sy, int fy) {
    int curj = sy;
    vector<pair<char, int>> cur;
    for (int j = sy; j <= fy; ++j) {
        vector<pair<char, int>> C;
        for (int i = sx; i <= fx; ++i) if (A[i][j] != '.') {
            C.emplace_back(A[i][j], i);
        }
        if (!C.empty()) {
            for (int l = 0; l < (int)C.size(); ++l) {
                fill_rect(l == 0 ? sx : C[l - 1].second + 1, l == (int)C.size() - 1 ? fx : C[l].second, curj, j, tolower(C[l].first));
            }
            cur = C;
            curj = j + 1;
        }
    }
    if (curj != fy + 1) {
        vector<pair<char, int>> C = cur;
        for (int l = 0; l < (int)C.size(); ++l) {
            fill_rect(l == 0 ? sx : C[l - 1].second + 1, l == (int)C.size() - 1 ? fx : C[l].second, curj, fy, tolower(C[l].first));
        }
    }
}

void solve() {
    int n, m; cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        cin >> A[i];
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) if (A[i][j] == '.' || A[i][j] == 'A') {
            dpL[i][j] = (j ? dpL[i][j - 1] : -1);
        } else {
            dpL[i][j] = j;
        }
        for (int j = m - 1; j >= 0; --j) if (A[i][j] == '.' || A[i][j] == 'A') {
            dpR[i][j] = (j == m - 1 ? m : dpR[i][j + 1]);
        } else {
            dpR[i][j] = j;
        }
    }

    int posi = -1, posj = -1;
    for (int i = 0; i < n; ++i) for (int j = 0; j < m; ++j) if (A[i][j] == 'A') {
        posi = i, posj = j;
    }

    int ans = -1;
    int mnx, mxx, mny, mxy;
    for (int i = 0; i < n; ++i) {
        int mn = m, mx = -1;
        for (int j = i; j < n; ++j) {
            mn = min(mn, dpR[j][posj]);
            mx = max(mx, dpL[j][posj]);
            if (i <= posi && posi <= j) {
                int tmp;
                if (ans < (tmp = (j - i + 1) * (mn - mx - 1))) {
                    ans = tmp;
                    mnx = i, mxx = j, mny = mx + 1, mxy = mn - 1;
                }
            }
        }
    }
    assert(ans != -1);

    fill_rect(mnx, mxx, mny, mxy, 'a');
    ququ(0, mnx - 1, 0, m - 1);
    ququ(mnx, mxx, 0, mny - 1);
    ququ(mnx, mxx, mxy + 1, m - 1);
    ququ(mxx + 1, n - 1, 0, m - 1);

    for (int i = 0; i < n; ++i) {
        cout << A[i] << "\n";
    }
}