#include <bits/stdc++.h>

using namespace std;

const int maxn = 2 * 1e5 + 1;
vector<int> edges[maxn];
int teams[maxn];
int dist[maxn];
vector<int> path;
vector<bool> was;

bool dfs(int cur, int target) {
    was[cur] = true;
    path.push_back(cur);

    if (cur == target) {
        return true;
    }

    for (const auto& next : edges[cur]) {
        if (!was[next]) {
            if (dfs(next, target)) {
                return true;
            }
        }
    }

    path.pop_back();
    return false;
}

int main()
{
    // freopen("test.in", "r", stdin);
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n, m, x, y;
    cin >> n >> m;
    for (int i = 0; i < n - 1; i++) {
        cin >> x >> y;
        edges[x - 1].push_back(y - 1);
        edges[y - 1].push_back(x - 1);
    }

    for (int i = 0; i < m; i++) {
        cin >> teams[i];
        teams[i]--;
    }

    if (m == 1) {
        cout << "YES" << endl << teams[0] + 1;
        return 0;
    }

    was.resize(n);
    for (int i = 0; i < n; i++) {
        was[i] = false;
    }

    dfs(teams[0], teams[1]);

    if (path.size() % 2 == 0) {
        cout << "NO";
        return 0;
    }

    int ans = path[path.size() / 2];
    queue<int> q;
    for (int i = 0; i < n; i++) {
        was[i] = false;
    }
    q.push(ans);
    was[ans] = true;
    while (q.size() > 0) {
        int cur = q.front();
        q.pop();
        for (const auto& next : edges[cur]) {
            if (!was[next]) {
                was[next] = true;
                q.push(next);
                dist[next] = dist[cur] + 1;
            }
        }
    }

    int ans_dist = path.size() / 2;
    bool all_equal = true;
    for (int i = 0; i < m; i++) {
        if (dist[teams[i]] != ans_dist) {
            all_equal = false;
            break;
        }
    }

    if (!all_equal) {
        cout << "NO";
    } else {
        cout << "YES" << endl << ans + 1;
    }
    return 0;
}
