#include <bits/stdc++.h>

using namespace std;

const long double PI = 3.1415926535897932384626433;

const int maxn = 1001;

int n;

int x[maxn];
int y[maxn];
int h[maxn];

pair<pair<long long, long long>, pair<long long, long long>> get_inter(long long mid) {
    long long lx = x[0] - (mid - h[0]);
    long long ly = y[0] - (mid - h[0]);
    long long rx = x[0] + (mid - h[0]);
    long long ry = y[0] + (mid - h[0]);

    for (int i = 1; i < n; i++) {
        lx = max(lx, x[i] - (mid - h[i]));
        ly = max(ly, y[i] - (mid - h[i]));
        rx = min(rx, x[i] + (mid - h[i]));
        ry = min(ry, y[i] + (mid - h[i]));
    }

    return {{lx, ly}, {rx, ry}};
}

bool inter(long long mid) {
    for (int i = 0; i < n; i++) {
        if (mid < h[i])
            return false;
    }
    auto points = get_inter(mid);
    return (points.first.first <= points.second.first) && (points.first.second <= points.second.second);
}

int main()
{
    // freopen("test.in", "r", stdin);
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> n;

    for (int i = 0; i < n; i++) {
        cin >> x[i] >> y[i] >> h[i];
    }

    long long l = 0;
    long long r = 1e13;

    while (l + 1 < r) {
        long long mid = (l + r) / 2;

        if (inter(mid)) {
            r = mid;
        } else {
            l = mid;
        }
    }

    auto points = get_inter(r);
    cout << points.first.first << " " << points.first.second << " " << r;

    return 0;
}
