#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>

using namespace std;
using vint = vector <int>;

const int INF = 0x3f3f3f3f;

vint used, teams, dist;
vector <vint> d;

int main() {
	// ...
	ios::sync_with_stdio(false);
	int n, m, a, b, mn(INF), id(-1);
	cin >> n >> m;

	d.resize(n);
	dist.resize(n);
	used.resize(n);
	teams.resize(m);

	for (int i(0); i < n - 1; i++) {
		cin >> a >> b;

		--a, --b;
		d[a].push_back(b);
		d[b].push_back(a);
	}

	for (auto& i : teams) {
		cin >> i;
		--i;
	}

	// refr
	for (int i(0); i < n; i++) {
		fill(used.begin(), used.end(), 0);
		fill(dist.begin(), dist.end(), 0);

		// bfs
		queue <int> q;
		q.push(i);
		dist[i] = 0;

		while (!q.empty()) {
			int curr = q.front(); q.pop();
			used[curr] = true;

			for (auto next : d[curr]) {
				if (!used[next]) {
					dist[next] = dist[curr] + 1;
					q.push(next);
				}
			}
		}

		int num = dist[teams[0]];
		bool is = true;
		for (int j(1); j < teams.size(); j++) {
			int t = teams[j];

			if (!used[t] || dist[t] != num) {
				is = false;
				break;
			}
		}

		if (is) {
			id = i;
			mn = num;
		}
	}

	if (id != -1) {
		cout << "YES\n" << id+1;
	}
	else
		cout << "NO";

}

