#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>

using namespace std;
using vint = vector <int>;

const int INF = 0x3f3f3f3f;

vint used, teams, dist;
vector <vint> d;

int main() {
	// ...
	ios::sync_with_stdio(false);
	int n, m, a, b, mx(-1), id(-1);
	cin >> n >> m;

	d.resize(n);
	dist.resize(n);
	used.resize(n);
	teams.resize(m);

	for (int i(0); i < n - 1; i++) {
		cin >> a >> b;

		--a, --b;
		d[a].push_back(b);
		d[b].push_back(a);
	}

	for (auto& i : teams) {
		cin >> i;
		--i;
	}

	//
	if (m == 1) {
		cout << "YES\n" << 1;
		return 0;
	}

	// refr
	queue <int> q;
	
	for (auto i : teams) {
		q.push(i); 
		used[i] = true;
	}
	
	while (!q.empty()) {
		int curr = q.front(); q.pop();
		used[curr] = true;

		for (auto next : d[curr]) {
			if (!used[next]) {

				if (dist[next] && dist[next] != dist[curr] + 1) {
					cout << "NO";
					return 0;
				}
				else
					dist[next] = dist[curr] + 1;

				if (mx < dist[next]) {
					id = next;
					mx = dist[next];
				}

				q.push(next);
			}
		}
	}

	if (id == -1)
		cout << "NO";
	else
		cout << "YES\n" << id+1;
}

