#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>
#include <map>

using namespace std;
using vint = vector <int>;

const int INF = 0x3f3f3f3f;

vint used, teams, dist;
vector <vint> d;

map <int, bool> rel;

int main() {
	// ...
	ios::sync_with_stdio(false);
	int n, m, a, b, id(-1);
	cin >> n >> m;

	d.resize(n);
	dist.resize(n);
	used.resize(n);
	teams.resize(m);

	for (int i(0); i < n - 1; i++) {
		cin >> a >> b;

		--a, --b;
		d[a].push_back(b);
		d[b].push_back(a);
	}

	for (auto& i : teams) {
		cin >> i;
		--i;
		rel[i] = true;
	}

	//
	if (m == 1) {
		cout << "YES\n" << 1;
		return 0;
	}

	// refr
	id = teams.front();
	int i = id;

	queue <int> q;
	q.push(i);
	dist[i] = 0;

	while (!q.empty()) {
		int curr = q.front(); q.pop();
		used[curr] = true;

		for (auto next : d[curr]) {
			if (!used[next]) {
				dist[next] = dist[curr] + 1;
				q.push(next);
			}
		}
	}

	queue <int> s;
	s.push(id);
	fill(used.begin(), used.end(), 0);

	while (!s.empty()) {
		int curr = s.front(); s.pop();
		used[curr] = 1;

		// 
		bool is = true;

		if (curr == 3) {
			int c(0);
			c++;
		}

		for (int j(1); j < teams.size(); j++) {
			if (rel[curr]) {
				is = false;
				break;
			}

			int t = teams[j], to(0);

			if (dist[t] <= dist[curr])
				to = dist[t];
			else
				to = dist[t] - dist[curr];

			if (to != dist[id] + dist[curr])
				is = false;
		}

		if (is) {
			cout << "YES\n" << curr + 1;
			return 0;
		}

		for (auto next : d[curr]) {
			if (!used[next]) {
				s.push(next);
			}
		}
	}

	cout << "NO";
}

