#include <bits/stdc++.h>

using namespace std;

#define forn(i,n) for(int i = 0; i < (n); i++)
#define fornr(i,n) for(int i = (n) - 1; i >= 0; i--)
#define forab(i,a,b) for(int i = (a); i < (b); i++)
#define mp make_pair
#define pb push_back
#define sz(X) int((X).size())
#define all(X) (X).begin(),(X).end()
#define fst first
#define snd second

using ll = long long;
using pii = pair<int,int>;
using vi = vector<int>;

const int N = 1005;

char c[N][N], ans[N][N];
int pref[N][N];

bool check(int y1, int y2, int x1, int x2) {
	x2--, y2--;
	return pref[x2][y2] - pref[x1][y2] - pref[x2][y1] + pref[x1][y1] == 0;
}

void colorize(int x1, int x2, int y1, int y2, char cc) {
	forab(i, x1 + 1, x2) {
		forab(j, y1 + 1, y2) {
			if (ans[i][j] == '.') ans[i][j] = cc;
		}
	}
}


int main() {
#ifdef LOCAL
	freopen(".in", "r", stdin);
	freopen(".out", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, m;
	cin >> n >> m;
	int x, y;
	set<int> low, up, l, r;
	up.insert(0);
	low.insert(n + 1);
	l.insert(0);
	r.insert(m + 1);
	forab(i, 1, n + 1) {
		forab(j, 1, m + 1) {
			cin >> c[i][j];
			if (c[i][j] == 'A') x = i, y = j;
			ans[i][j] = c[i][j];
		}
	}
	forab(i, 1, n + 1) {
		forab(j, 1, m + 1) {
			int cnt = 0;
			if (c[i][j] != 'A' && c[i][j] != '.') cnt = 1;
			pref[i][j] = cnt + pref[i - 1][j] + pref[i][j - 1] - pref[i - 1][j - 1];
		}
	}
//	cerr << pref[n][m] << '\n';
	forab(i, 1, n + 1) {
		forab(j, 1, m + 1) {
			if (c[i][j] != 'A' && c[i][j] != '.') {
				if (i < x) up.insert(i);
				else if (i > x) low.insert(i);
				
				if (j < y) l.insert(j);
				else if (j > y) r.insert(j);
			}
		}
	}
	int best = 0;
	int lB, rB, upB, lowB;
	for (int lC : l) {
		for (int rC : r) {
			for (int upC : up) {
				for (int lowC : low) {
					if (check(lC, rC, upC, lowC)) {
						int sq = (rC - lC - 1) * (lowC - upC - 1);
						if (sq > best) {
							best = sq;
							lB = lC, rB = rC, upB = upC, lowB = lowC;
						}
					}
				}
			}
		}
	}
	colorize(upB, lowB, lB, rB, 'a');
//	cerr << upB << " " << lowB << " " << lB << " " << rB << '\n';
	vector<pair<pii, char>> upBlock, lBlock, rBlock, lowBlock; 
	forab(i, 1, n + 1) {
		forab(j, 1, m + 1) {
			if (c[i][j] != '.' && c[i][j] != 'A') {
				pair<pii, char> symb = mp(mp(i, j), c[i][j]);
				if (i <= upB) upBlock.pb(symb);
				else if (i >= lowB) lowBlock.pb(symb);
				else if (j <= lB) lBlock.pb(symb);
				else {
					//cerr << i << " " << j << " " << c[i][j] << '\n';
					assert(j >= rB);
					rBlock.pb(symb);
			 	}
			}
		}
	}
	sort(all(upBlock));
	sort(all(lBlock));
	sort(all(rBlock));
	sort(all(lowBlock));
	int lastUp = 0;
	int lastL = 0;
	
	int maxLow = 0, maxR = 0;
	for(auto symb : upBlock) {
		maxLow = max(maxLow, symb.fst.fst);
		maxR = max(maxR, symb.fst.snd);
	}
	
	
	forn(i, sz(upBlock)) {
		int x = upBlock[i].fst.fst, y = upBlock[i].fst.snd;
		char cc = upBlock[i].snd;
		int myUp = x, myL = y, nextUp = lastUp, nextL = y;
		if (i == sz(upBlock) - 1 || upBlock[i + 1].fst.fst > x) {
			myL = m;
			nextL = 0;
			nextUp = x; 
		}
		
		if (x == maxLow) {
			myUp = upB;
	 	}
		colorize(lastUp, myUp + 1, lastL, myL + 1, cc - 'A' + 'a');
		lastL = nextL;
		lastUp = nextUp;
	}
	
	maxLow = 0, maxR = 0;
	for(auto symb : lBlock) {
		maxLow = max(maxLow, symb.fst.fst);
		maxR = max(maxR, symb.fst.snd);
	}
	lastUp = upB - 1;
	lastL = 0;
	forn(i, sz(lBlock)) {
		int x = lBlock[i].fst.fst, y = lBlock[i].fst.snd;
		char cc = lBlock[i].snd;
		int myUp = x, myL = y, nextUp = lastUp, nextL = y;
		if (i == sz(lBlock) - 1 || lBlock[i + 1].fst.fst > x) {
			myL = maxR;
			nextL = 0;
			nextUp = x; 
		}
		if (x == maxLow) {
			myUp = lowB - 1;
	 	}
		colorize(lastUp, myUp + 1, lastL, myL + 1, cc - 'A' + 'a');
		lastL = nextL;
		lastUp = nextUp;
	}
	lastL = rB - 1;
	lastUp = upB - 1;
	maxLow = 0;
	for(auto symb : rBlock) {
		maxLow = max(maxLow, symb.fst.fst);
	}
	
	forn(i, sz(rBlock)) {
		int x = rBlock[i].fst.fst, y = rBlock[i].fst.snd;
		char cc = rBlock[i].snd;
		int myUp = x, myL = y, nextUp = lastUp, nextL = y;
		if (i == sz(rBlock) - 1 || rBlock[i + 1].fst.fst > x) {
			myL = m;
			nextL = rB - 1;
			nextUp = x; 
		}
		if (x == maxLow) {
			myUp = lowB - 1;
	 	}
		colorize(lastUp, myUp + 1, lastL, myL + 1, cc - 'A' + 'a');
		lastL = nextL;
		lastUp = nextUp;
	}

	lastUp = lowB - 1;
	lastL = 0;
	maxLow = 0;
	for(auto symb : lowBlock) {
		maxLow = max(maxLow, symb.fst.fst);
	}
	
	forn(i, sz(lowBlock)) {
		int x = lowBlock[i].fst.fst, y = lowBlock[i].fst.snd;
		char cc = lowBlock[i].snd;
		int myUp = x, myL = y, nextUp = lastUp, nextL = y;
		if (i == sz(lowBlock) - 1 || lowBlock[i + 1].fst.fst > x) {
			myL = m;
			nextL = 0; 
			nextUp = x;
		}
		if (x == maxLow) {
			myUp = n;
	 	}
		colorize(lastUp, myUp + 1, lastL, myL + 1, cc - 'A' + 'a');
		lastL = nextL;
		lastUp = nextUp;
	}

	
	forab(i, 1, n + 1) {
		forab(j, 1, m + 1) {
			cout << ans[i][j];
		}
		cout << '\n';
	}
	return 0;
}