#include <bits/stdc++.h>

using namespace std;

#define forn(i,n) for(int i = 0; i < (n); i++)
#define fornr(i,n) for(int i = (n) - 1; i >= 0; i--)
#define forab(i,a,b) for(int i = (a); i < (b); i++)
#define mp make_pair
#define pb push_back
#define sz(X) int((X).size())
#define all(X) (X).begin(),(X).end()
#define fst first
#define snd second

using ll = long long;
using pii = pair<int,int>;
using vi = vector<int>;
using ull = unsigned long long;

const int N = 2e5 + 100;
const int P = 239;

int mod[2];

bool isPrime(int x) {
	for (int i = 2; i * i <= x; i++) {
		if (x % i == 0) return false;
	}
	return true;
} 

void initPrimes() {
	int x = 1e9 + 11;
	for(int i = 0; i < 2; x++) {
		if (isPrime(x)) {
			mod[i++] = x;
		}
	}
}

int mult(int a, int b, int m) {
	return int((a * 1ll * b) % m);
}

int add(int a, int b, int m) {
	a += b;
	return a >= m ? a - m : a;
}

int sub(int a, int b, int m) {
	a -= b;
	return a < 0 ? a + m : a;
}

int toPower(int a, int d, int m) {
	if (d == 0) return 1;
	int t = toPower(a, d / 2, m);
	t = mult(t, t, m);
	if (d & 1) t = mult(t, a, m);
	return t;
}

struct Hash {
	int val1 = 0, val2 = 0;
	
	Hash() {}
	Hash(int v1, int v2) : val1(v1), val2(v2) {}
	
	Hash mul(int power) {
		return Hash(mult(val1, toPower(P, power, mod[0]), mod[0]),
				    mult(val2, toPower(P, power, mod[1]), mod[1]));
	}
	
	bool operator ==(const Hash& h) const {
		return val1 == h.val1 && val2 == h.val2;
	}
	
	Hash operator -(const Hash &h) const {
		return Hash(sub(val1, h.val1, mod[0]), sub(val2, h.val2, mod[1]));
	}
	
	Hash operator +(const Hash &h) const {
		return Hash(add(val1, h.val1, mod[0]), add(val2, h.val2, mod[1]));
	}
};

Hash h[N];
int n;

Hash getHash(int l, int r) {
	return (h[r] - h[l].mul(r - l));
}

int maxPref(int pos1, int pos2) {
	int l = 0, r = min(pos2 - pos1 + 1, n - pos2 + 1);
	while(r - l > 1) {
		int m = (l + r) / 2;
		if (getHash(pos1, pos1 + m) == getHash(pos2, pos2 + m)) {
			l = m;
		} else {
			r = m;
		}
	}
	return l;
}

int maxSuf(int pos1, int pos2) {
	int l = 0, r = min(pos2 - pos1 + 1, pos1 + 1);
	while(r - l > 1) {
		int m = (l + r) / 2;
		if (getHash(pos1 - m, pos1) == getHash(pos2 - m, pos2)) {
			l = m;
		} else {
			r = m;
		}
	}
	return l;
}

pii maxRatio(pii a, pii b) {
	int g = __gcd(b.fst, b.snd);
	b.fst /= g;
	b.snd /= g;
	if (a.fst * 1ll * b.snd < b.fst *  1ll * a.snd) {
		return b;
	}
	return a;
}

int main() {
#ifdef LOCAL
	freopen(".in", "r", stdin);
	freopen(".out", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	
	initPrimes();
	
	string s;
	cin >> s;
	n = sz(s);

	forn(i, n) {
		h[i + 1] = h[i].mul(1) + Hash(s[i], s[i]);
	}
	pii best = mp(1, 1);
	for (int d = 1; d < n; d++) {
		int start = 0;
		int pos = d;
		int totalLen = d;
		while(pos < n) {
			//cerr << pos << '\n';
			int len = maxPref(start, pos);
			if (len == d) {
				pos += d;
				totalLen += d;
				best = maxRatio(best, mp(totalLen, d));
			} else {
				best = maxRatio(best, mp(totalLen + len, d));
				start = pos + len;
				pos = start + d;
				if (pos >= n) {
					break;
				}
				totalLen = d + maxSuf(start, start + d);
				best = maxRatio(best, mp(totalLen, d));
			}
		}
	}
	cout << best.fst << '/' << best.snd << '\n';
	return 0;
}