#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <bitset>
#include <cstring>
#include <string>
#include <ctime>
#include <random>
#include <numeric>
#include <iomanip>
#include <unordered_set>
#include <unordered_map>
#include <utility>
#include <cmath>

#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define eb emplace_back
#define mp make_pair
#define X first
#define Y second

using namespace std;  using ll = long long; using pii = pair<int, int>; using vi = vector<int>; using ld = long double;

const int di[] = { 0, 0, 1,-1 };
const int dj[] = { 1,-1, 0, 0 };

int n, m;
char a[100][100];

vector<vi> g;

void stitch(int x, int y, vector<vector<bool>>& vis, vector<pair<int, int>> &stitches, int rot, bool rev) {
	if (x < 0 || x >= n || y < 0 || y >= m || vis[x][y] || a[x][y] == '.') return;
	vis[x][y] = true;

	if (rot == 0 && !rev) {
		stitch(x - 1, y - 1, vis, stitches, 2, false);
		stitch(x - 1, y, vis, stitches, 3, false);
		stitch(x, y - 1, vis, stitches, 1, false);
		stitches.eb(y + 1, x + 1);
		stitch(x + 1, y + 1, vis, stitches, 0, true);
		stitch(x + 1, y, vis, stitches, 1, true);
		stitch(x, y + 1, vis, stitches, 3, true);
		stitches.eb(y + 1, x);
		stitch(x - 1, y + 1, vis, stitches, 3, false);
		stitches.eb(y, x + 1);
		stitch(x + 1, y - 1, vis, stitches, 1, true);
		stitches.eb(y, x);
	}
	if (rot == 0 && rev) {
		stitch(x - 1, y - 1, vis, stitches, 2, true);
		stitch(x - 1, y, vis, stitches, 3, true);
		stitch(x, y - 1, vis, stitches, 1, true);
		stitches.eb(y, x + 1);
		stitch(x + 1, y - 1, vis, stitches, 1, false);
		stitches.eb(y + 1, x);
		stitch(x - 1, y + 1, vis, stitches, 3, true);
		stitches.eb(y + 1, x + 1);
		stitch(x + 1, y + 1, vis, stitches, 0, false);
		stitch(x + 1, y, vis, stitches, 1, false);
		stitch(x, y + 1, vis, stitches, 3, false);
		stitches.eb(y, x);
	}

	if (rot == 1 && !rev) {
		stitch(x - 1, y + 1, vis, stitches, 3, false);
		stitches.eb(y, x + 1);
		stitch(x + 1, y - 1, vis, stitches, 1, true);
		stitches.eb(y, x);
		stitch(x - 1, y - 1, vis, stitches, 2, false);
		stitch(x - 1, y, vis, stitches, 3, false);
		stitch(x, y - 1, vis, stitches, 1, false);
		stitches.eb(y + 1, x + 1);
		stitch(x + 1, y + 1, vis, stitches, 0, true);
		stitch(x + 1, y, vis, stitches, 1, true);
		stitch(x, y + 1, vis, stitches, 3, true);
		stitches.eb(y + 1, x);
	}
	if (rot == 1 && rev) {
		stitch(x - 1, y + 1, vis, stitches, 3, true);
		stitches.eb(y + 1, x + 1);
		stitch(x + 1, y + 1, vis, stitches, 0, false);
		stitch(x + 1, y, vis, stitches, 1, false);
		stitch(x, y + 1, vis, stitches, 3, false);
		stitches.eb(y, x);
		stitch(x - 1, y - 1, vis, stitches, 2, true);
		stitch(x - 1, y, vis, stitches, 3, true);
		stitch(x, y - 1, vis, stitches, 1, true);
		stitches.eb(y, x + 1);
		stitch(x + 1, y - 1, vis, stitches, 1, false);
		stitches.eb(y + 1, x);
	}

	if (rot == 2 && rev) {
		stitch(x + 1, y + 1, vis, stitches, 0, true);
		stitch(x + 1, y, vis, stitches, 1, true);
		stitch(x, y + 1, vis, stitches, 3, true);
		stitches.eb(y + 1, x);
		stitch(x - 1, y + 1, vis, stitches, 3, false);
		stitches.eb(y, x + 1);
		stitch(x + 1, y - 1, vis, stitches, 1, true);
		stitches.eb(y, x);
		stitch(x - 1, y - 1, vis, stitches, 2, false);
		stitch(x - 1, y, vis, stitches, 3, false);
		stitch(x, y - 1, vis, stitches, 1, false);
		stitches.eb(y + 1, x + 1);
	}
	if (rot == 2 && !rev) {
		stitch(x + 1, y + 1, vis, stitches, 0, false);
		stitch(x + 1, y, vis, stitches, 1, false);
		stitch(x, y + 1, vis, stitches, 3, false);
		stitches.eb(y, x);
		stitch(x - 1, y - 1, vis, stitches, 2, true);
		stitch(x - 1, y, vis, stitches, 3, true);
		stitch(x, y - 1, vis, stitches, 1, true);
		stitches.eb(y, x + 1);
		stitch(x + 1, y - 1, vis, stitches, 1, false);
		stitches.eb(y + 1, x);
		stitch(x - 1, y + 1, vis, stitches, 3, true);
		stitches.eb(y + 1, x + 1);
	}

	if (rot == 3 && rev) {
		stitch(x + 1, y - 1, vis, stitches, 1, true);
		stitches.eb(y, x);
		stitch(x - 1, y - 1, vis, stitches, 2, false);
		stitch(x - 1, y, vis, stitches, 3, false);
		stitch(x, y - 1, vis, stitches, 1, false);
		stitches.eb(y + 1, x + 1);
		stitch(x + 1, y + 1, vis, stitches, 0, true);
		stitch(x + 1, y, vis, stitches, 1, true);
		stitch(x, y + 1, vis, stitches, 3, true);
		stitches.eb(y + 1, x);
		stitch(x - 1, y + 1, vis, stitches, 3, false);
		stitches.eb(y, x + 1);
	}
	if (rot == 3 && !rev) {
		stitch(x + 1, y - 1, vis, stitches, 1, false);
		stitches.eb(y + 1, x);
		stitch(x - 1, y + 1, vis, stitches, 3, true);
		stitches.eb(y + 1, x + 1);
		stitch(x + 1, y + 1, vis, stitches, 0, false);
		stitch(x + 1, y, vis, stitches, 1, false);
		stitch(x, y + 1, vis, stitches, 3, false);
		stitches.eb(y, x);
		stitch(x - 1, y - 1, vis, stitches, 2, true);
		stitch(x - 1, y, vis, stitches, 3, true);
		stitch(x, y - 1, vis, stitches, 1, true);
		stitches.eb(y, x + 1);
	}

}

int32_t main() {
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
	cin >> m >> n;

	int x = -1, y = -1;

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> a[i][j];
			if (a[i][j] == 'X') x = i, y = j;
		}
	}
	
	if (x == -1) cout << 0 << endl;
	else {
		vector<pair<int, int>> stitches;
		stitches.eb(y, x);

		vector<vector<bool>> vis(n, vector<bool>(m));
		stitch(x, y, vis, stitches, 0, false);

		stitches.pop_back();

		cout << sz(stitches) - 1 << endl;
		for (auto el : stitches) {
			cout << el.X << ' ' << el.Y << '\n';
		}
	}
}