#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <bitset>
#include <cstring>
#include <string>
#include <ctime>
#include <random>
#include <numeric>
#include <iomanip>
#include <unordered_set>
#include <unordered_map>
#include <utility>
#include <cmath>

#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define eb emplace_back
#define mp make_pair
#define X first
#define Y second

using namespace std;  using ll = long long; using pii = pair<int, int>; using vi = vector<int>; using ld = long double;

int32_t main() {
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
	
	int n, m;
	cin >> n >> m;

	vector<string> board(n);

	for (int i = 0; i < n; i++) cin >> board[i];

	vector<pair<pair<int, int>, char>> lsr_cstls;
	int ax, ay;

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (board[i][j] == 'A') ax = i, ay = j;
			else if (board[i][j] != '.') lsr_cstls.eb(mp(i, j), board[i][j] + 'a' - 'A');
		}
	}

	int opt_sqr = 0;
	int opt_l, opt_r, opt_t, opt_b;

	for (int t = 0; t <= ax; t++) {
		for (int b = ax; b < n; b++) {
			bool has_top = (t == 0), has_bottom = (b == n - 1);
			int lb = 0, rb = m - 1;

			for (auto pt : lsr_cstls) {
				if (pt.X.X < t) has_top = true;
				else if (pt.X.X > b) has_bottom = true;
				else {
					if (pt.X.Y <= ay) lb = max(lb, pt.X.Y + 1);
					if (pt.X.Y >= ay) rb = min(rb, pt.X.Y - 1);
				}
			}

			if (has_top && has_bottom && opt_sqr < (b - t + 1) * (rb - lb + 1)) {
				opt_sqr = (b - t + 1) * (rb - lb + 1);
				opt_l = lb;
				opt_r = rb;
				opt_t = t;
				opt_b = b;
			}
		}
	}

	for (int i = opt_t; i <= opt_b; i++) {
		for (int j = opt_l; j <= opt_r; j++) {
			if (board[i][j] == '.')
				board[i][j] = 'a';
		}
	}

	// TOP

	vector<pair<pair<int, int>, char>> cstls;
	for (auto pt : lsr_cstls) {
		if (pt.X.X < opt_t) cstls.pb(pt);
	}

	sort(all(cstls));

	for (int k = 0; k < sz(cstls); k++) {
		int rb = cstls[k].X.Y;
		if (k == sz(cstls) - 1 || cstls[k].X.X != cstls[k + 1].X.X) rb = m - 1;

		for (int i = 0; i <= cstls[k].X.X; i++) {
			for (int j = 0; j <= rb; j++) {
				if (board[i][j] == '.') board[i][j] = cstls[k].Y;
			}
		}
	}

	// BOTTOM

	cstls.clear();

	for (auto pt : lsr_cstls) {
		if (pt.X.X > opt_b) cstls.pb(pt);
	}

	sort(all(cstls));
	reverse(all(cstls));

	for (int k = 0; k < sz(cstls); k++) {
		int lb = cstls[k].X.Y;
		if (k == sz(cstls) - 1 || cstls[k].X.X != cstls[k + 1].X.X) lb = 0;

		for (int i = cstls[k].X.X; i < n; i++) {
			for (int j = lb; j < m; j++) {
				if (board[i][j] == '.') board[i][j] = cstls[k].Y;
			}
		}
	}

	// LEFT

	cstls.clear();

	for (auto pt : lsr_cstls) {
		if (pt.X.X >= opt_t && pt.X.X <= opt_b && pt.X.Y < opt_l) cstls.pb(pt);
	}

	sort(all(cstls));
	reverse(all(cstls));

	for (int k = 0; k < sz(cstls); k++) {
		int lb = cstls[k].X.Y;
		if (k == sz(cstls) - 1 || cstls[k].X.X != cstls[k + 1].X.X) lb = 0;

		for (int i = cstls[k].X.X; i < n; i++) {
			for (int j = lb; j < opt_l; j++) {
				if (board[i][j] == '.') board[i][j] = cstls[k].Y;
			}
		}
	}

	if (!cstls.empty()) {
		for (int i = cstls.back().X.X - 1; i >= opt_t; i--) {
			for (int j = 0; j < opt_l; j++) {
				board[i][j] = board[i + 1][j];
				if (board[i][j] >= 'A' && board[i][j] <= 'Z') board[i][j] += 'a' - 'A';
			}
		}
	}

	// RIGHT

	cstls.clear();

	for (auto pt : lsr_cstls) {
		if (pt.X.X >= opt_t && pt.X.X <= opt_b && pt.X.Y > opt_r) cstls.pb(pt);
	}

	sort(all(cstls));
	reverse(all(cstls));

	for (int k = 0; k < sz(cstls); k++) {
		int lb = cstls[k].X.Y;
		if (k == sz(cstls) - 1 || cstls[k].X.X != cstls[k + 1].X.X) lb = opt_r + 1;

		for (int i = cstls[k].X.X; i < n; i++) {
			for (int j = lb; j < m; j++) {
				if (board[i][j] == '.') board[i][j] = cstls[k].Y;
			}
		}
	}

	if (!cstls.empty()) {
		for (int i = cstls.back().X.X - 1; i >= opt_t; i--) {
			for (int j = opt_r + 1; j < m; j++) {
				board[i][j] = board[i + 1][j];
				if (board[i][j] >= 'A' && board[i][j] <= 'Z') board[i][j] += 'a' - 'A';
			}
		}
	}

	for (int i = 0; i < n; i++) {
		cout << board[i] << endl;
	}

	/*
6 8
......X.
.F......
...A....
........
.....P..
..L.....
	*/

	//cerr << (ld)clock() / CLOCKS_PER_SEC << endl;
}