/*#include <iostream>
#include <vector>
#include <unordered_map>
#include <algorithm>

using namespace std;
#define BIG 1000000


long long solve(vector<int> v) {
    long long res = 0;
    vector<pair<int, int> > p;
    for(int i = 0; i < v.size(); i++) {
        p.push_back(make_pair(v[i], i));
    }
    sort(p.begin(), p.end());
    for(int i = 0; i < v.size(); i++) {
        vector<int> l, h;
        for(int j = 0; j < v.size(); j++) {
            if(p[j].second < i) {
                l.push_back(v[i] - p[j].first);
            }
            if(p[j].second > i) {
                h.push_back(p[j].first - v[i]);
            }
        }
        if(l.size() == 0 || h.size() == 0) {
            continue;
        }
        vector<pair<int, int>> lg, hg;
        lg.push_back(make_pair(l[0], 1));
        hg.push_back(make_pair(h[0], 1));
        for(int j = 1; j < l.size(); j++) {
            if(l[j] == lg.back().first)
                lg.back().second++;
            else
                lg.push_back(make_pair(l[j], 1));
        }
        for(int j = 1; j < h.size(); j++) {
            if(h[j] == hg.back().first)
                hg.back().second++;
            else
                hg.push_back(make_pair(h[j], 1));
        }
        int ph = 0;
        for(int j = 0; j < lg.size(); j++) {
            while(ph < hg.size() && hg[ph].first > lg[j].first)
                ph++;
            if(ph < hg.size() && hg[ph].first == lg[j].first) {
                res += hg[ph].second * lg[j].second;
            }
        }
    }
    return res;
}

int main() {
    freopen("input", "r", stdin);
    ios::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    for(int test = 0; test < t; test++) {
        int n;
        cin >> n;
        vector<int> t(n);
        for(int i = 0; i < n; i++)
            cin >> t[i];
        cout << solve(t) << "\n";
    }
    return 0;
}*/

#include <iostream>
#include <vector>
#include <unordered_map>
#include <algorithm>

using namespace std;
#define BIG 1000000


long long solve(vector<int> v) {
    long long res = 0;
    vector<pair<int, int> > p;
    for(int i = 0; i < v.size(); i++) {
        p.push_back(make_pair(v[i], i));
    }
    sort(p.begin(), p.end());
    for(int i = 1; i < v.size() - 1; i++) {
        vector<int> l, h;
        for(int j = 0; j < v.size(); j++) {
            if(p[j].second < i) {
                l.push_back(v[i] - p[j].first);
            }
            if(p[j].second > i) {
                h.push_back(p[j].first - v[i]);
            }
        }
        if(l.size() == 0 || h.size() == 0) {
            continue;
        }
        reverse(h.begin(), h.end());
        vector<pair<int, int>> lg, hg;
        lg.push_back(make_pair(l[0], 1));
        hg.push_back(make_pair(h[0], 1));
        for(int j = 1; j < l.size(); j++) {
            if(l[j] == lg.back().first)
                lg.back().second++;
            else
                lg.push_back(make_pair(l[j], 1));
        }
        for(int j = 1; j < h.size(); j++) {
            if(h[j] == hg.back().first)
                hg.back().second++;
            else
                hg.push_back(make_pair(h[j], 1));
        }
        int ph = 0;
        for(int j = 0; j < lg.size(); j++) {
            while(ph < hg.size() && hg[ph].first > lg[j].first)
                ph++;
            if(ph < hg.size() && hg[ph].first == lg[j].first) {
                res += hg[ph].second * lg[j].second;
            }
        }
    }
    return res;
}

int main() {
    freopen("input", "r", stdin);
    ios::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    for(int test = 0; test < t; test++) {
        int n;
        cin >> n;
        vector<int> t(n);
        for(int i = 0; i < n; i++)
            cin >> t[i];
        cout << solve(t) << "\n";
    }
    return 0;
}