#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());

int dr[] = {-1, -1, -1, 0, 0, 1, 1, 1};
int dc[] = {-1, 0, 1, -1, 1, -1, 0, 1};

#define maxn 111
int n, m;
string s[maxn];
list<pair<int, int>> ans;
list<pair<int, int>>::iterator list_pos[maxn][maxn];
bool vis[maxn][maxn] = {0};
bool has[maxn][maxn] = {0};

void process(int r, int c, bool start) {
    int down_r = r, up_r = r + 1;
    int cur_c = c, next_c = c + 1;
    if (r & 1) swap(down_r, up_r);

    list<pair<int, int>>::iterator insert_pos;
    if (start) insert_pos = ans.end();
    else {
        for (int _ = 0; _ < 2; ++_) {
            if (has[up_r][cur_c]) break;
            swap(cur_c, next_c);
        }
        assert(has[up_r][cur_c]);
        insert_pos = list_pos[up_r][cur_c];
    }

    list<pair<int, int>> cur_ans = {{up_r, cur_c}, {down_r, next_c}, {up_r, next_c}, {down_r, cur_c}};

    has[up_r][cur_c] = has[up_r][next_c] = 1;
    list_pos[up_r][cur_c] = cur_ans.begin();
    list_pos[up_r][next_c] = next(next(cur_ans.begin()));
    ans.splice(insert_pos, cur_ans);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout.setf(cout.fixed);
    cout.precision(8);

//    cin >> n >> m;
    cin >> m >> n;
    for (int i = 0; i < n; ++i) cin >> s[i];

    queue<pair<int, int>> qu;
    bool found = 0;
    int start_r = 0, start_c = 0;
    for (; start_r < n; ++start_r) {
        for (start_c = 0; start_c < m; ++start_c) {
            if (s[start_r][start_c] == '.') continue;
            found = 1;
            break;
        }
        if (found) break;
    }
    if (!found) {
        cout << 0;
        return 0;
    }

    for (vis[start_r][start_c] = 1, qu.emplace(start_r, start_c); qu.size(); qu.pop()) {
        auto [r, c] = qu.front();
        process(r, c, ans.empty());
        for (int dir = 0; dir < 8; ++dir) {
            int nr = r + dr[dir], nc = c + dc[dir];
            if (nr < 0 or nr >= n) continue;
            if (nc < 0 or nc >= m) continue;
            if (s[nr][nc] == '.') continue;
            if (vis[nr][nc]) continue;
            vis[nr][nc] = 1;
            qu.emplace(nr, nc);
        }
    }

    cout << ans.size() - 1 << '\n';
    for (auto [r, c]: ans) {
        cout << c << ' ' << r << '\n';
    }

    return 0;
}

/**
3 2
.XX
..X
 */