#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());

#define maxn 1010
int n, m;
string a[maxn];

void solve_sub_area(int r1, int c1, int r2, int c2) {
    if (r1 > r2) return ;
    if (c1 > c2) return ;
    bool has = 0;
    for (int i = r2; i >= r1; --i) {
        for (int f = c1; f <= c2; ++f) {
            if (a[i][f] != '.') {
                has = 1;
                break;
            }
        }
        if (has and i != r2) {
            for (int f = c1; f <= c2; ++f) {
                a[r2][f] = tolower(a[i][f]);
            }
        }
        if (has) break;
    }
    assert(has);

    for (int i = r2; i >= r1; --i) {
        vector<int> pos;
        for (int f = c1; f <= c2; ++f)
            if (a[i][f] != '.') {
                pos.push_back(f);
            }
        if (pos.empty()) {
            assert(i != r2);
            for (int f = c1; f <= c2; ++f) a[i][f] = tolower(a[i + 1][f]);
            continue;
        }
        int prev = c1;
        for (int f: pos) {
            for (int g = prev; g < f; ++g) {
                a[i][g] = tolower(a[i][f]);
            }
            prev = f + 1;
        }
        for (int f = prev; f <= c2; ++f) a[i][f] = tolower(a[i][pos.back()]);
    }
}

struct rect {
    int r1, c1, r2, c2;
    rect(int a, int b, int c, int d) : r1(a), c1(b), r2(c), c2(d) {}
    int area() {
        return (r2 - r1 + 1) * (c2 - c1 + 1);
    }
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout.setf(cout.fixed);
    cout.precision(8);

    cin >> n >> m >> ws;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    //clog << "ok" << endl;
    int ra = 0, ca = 0;
    bool found = false;
    for (ra = 0; ra < n; ++ ra) {
        for (ca = 0; ca < m; ++ca) {
            if (a[ra][ca] == 'A') {
                found = 1;
                break;
            }
        }
        if (found) break;
    }
    //clog << "ok" << endl;
    vector<pair<int, int>> limits(n, {0, m-1});
    int min_a = ra - 1, max_a = ra + 1;
    for (; min_a >= 0 and a[min_a][ca] == '.'; --min_a);
    for (; max_a < n and a[max_a][ca] == '.'; ++max_a);
    for (int i = min_a + 1; i < max_a; ++i) {
        for (int f = ca - 1; f >= 0; --f)
            if (a[i][f] != '.') {
                limits[i].first = f + 1;
                break;
            }
        for (int f = ca + 1; f < m; ++f)
            if (a[i][f] != '.') {
                limits[i].second = f - 1;
                break;
            }
    }
    //clog << "ok" << endl;
    rect max_rect(ra, ca, ra, ca);
    for (int lower_a = ra; lower_a > min_a; --lower_a) {
        if (lower_a != ra) {
            limits[lower_a].first = max(limits[lower_a].first, limits[lower_a + 1].first);
            limits[lower_a].second = min(limits[lower_a].second, limits[lower_a + 1].second);
        }
        for (int upper_a = ra; upper_a < max_a; ++upper_a) {
            if (upper_a != ra) {
                limits[upper_a].first = max(limits[upper_a].first, limits[upper_a - 1].first);
                limits[upper_a].second = min(limits[upper_a].second, limits[upper_a - 1].second);
            }
            int left = max(limits[lower_a].first, limits[upper_a].first);
            int right = min(limits[lower_a].second, limits[upper_a].second);
            rect cur_rect(lower_a, left, upper_a, right);
            if (cur_rect.area() <= max_rect.area()) continue;
            max_rect = cur_rect;
        }
    }
    //clog << "ok" << endl;
    solve_sub_area(0, 0, max_rect.r1 - 1, m - 1);
    solve_sub_area(max_rect.r2 + 1, 0, n - 1, m - 1);
    solve_sub_area(max_rect.r1, 0, max_rect.r2, max_rect.c1 - 1);
    solve_sub_area(max_rect.r1, max_rect.c2 + 1, max_rect.r2, m - 1);

    for (int i = 0; i < n; ++i) for (int f = 0; f < m; ++f)
        if (a[i][f] == '.') a[i][f] = 'a';

    for (int i = 0; i < n; ++i) cout << a[i] << '\n';

    return 0;
}

/*
 *
6 8
......X.
.F......
...A....
........
.....P..
..L.....

3 3
A..
..B
...
 */