#include <iostream>
#include <vector>
#include <algorithm>

int n;
std::vector<std::vector<int>> G;
std::vector<int> checked, dist;
int ans = -1;

int dfs_fast_down(int v, int len, int pred = -1){
    if(len <= 0){
        return v;
    }
    int was_marked = 0, marked = -1;
    for(auto& it:G[v]){
        if(it == pred){
            continue;
        }
        if(dist[it] != -1){
            was_marked++;
            marked = it;
        }
    }
    if(was_marked != 1){
        std::cout<<"NO";
        exit(0);
    }
    return dfs_fast_down(marked, len-1, v);
}

void dfs1(int v, int p=-1){
    int k, cnt_k=0, other=-1, way = -1;
    if (checked[v] == 1) {
        dist[v] = 0;
        k = 0;
        cnt_k = 1;
    } else {
        k = -1;
    }
    for (auto &it: G[v]) {
        if(it == p){
            continue;
        }
        dfs1(it, v);
        if(ans != -1){
            return;
        }
        if (dist[it] != -1) {
            if (k == -1) {
                k = dist[it];
                cnt_k = 1;
                way = it;
            } else {
                if (dist[it] != k) {
                    if (other == -1) {
                        other = dist[it];
                        if (k > other) {
                            if (cnt_k > 1) {
                                std::cout << "NO";
                                exit(0);
                            }
                            std::swap(k, other);
                        } else {
                            way = it;
                        }
                    } else {
                        std::cout << "NO";
                        exit(0);

                    }
                } else {
                    ++cnt_k;
                }
            }
        }
    }
    if(k != -1) {
        if (other == -1) {
            if(dist[v] != 0) {
                dist[v] = k + 1;
            }
        } else {
            if(k == 0){
                k = -1;
            }
            int u = dfs_fast_down(way, (other - k)/2 -1, v);
            if (ans != -1 && ans != u) {
                std::cout << "NO";
                exit(0);
            }
            ans = u;
        }
    }
}

bool dfs2(int v, int p=-1){
    if(checked[v] == 1){
        dist[v] = 0;
    }
    for(auto& it: G[v]){
        if(it == p){
            continue;
        }
        if(!dfs2(it, v)){
            return false;
        }
        if(dist[it]== -1){
            continue;
        }
        if(dist[v] == -1){
            dist[v] = dist[it] + 1;
        }
        if(dist[v] != dist[it] + 1) {
            return false;
        }
    }
    return true;
}

int main() {
    int s;
    std::cin>>n>>s;
    G.resize(n);
    checked.resize(n,0);
    dist.resize(n, -1);
    for(int i=1;i<n;++i){
        int a,b;
        std::cin>>a>>b;
        G[a-1].push_back(b-1);
        G[b-1].push_back(a-1);
    }
    if(s == 1){
        int a = 0;
        std::cin>>a;
        std::cout<<"YES\n"<<a;
        return 0;
    }
    for(int i=0;i<s;++i){
        int a;
        std::cin>>a;
        checked[a-1]= 1;
    }
    dfs1(0);
    if(ans == -1){
        ans =0;
    }
    for(auto& it: dist){
        it= -1;
    }
    if(dfs2(ans)){
        std::cout<<"YES\n"<<ans+1;
    }
    else{
        std::cout<<"NO";
    }
}

/*
6 3
1 2
2 3
3 4
4 5
4 6
1 5 6

15 7
1 2
 1 4
 2 5
 2 6
 6 10
 3 7
 3 8
 8 11
 8 12
 8 13
 4 9
 7 14
 1 15
 15 3
 5 6 14 11 12 13 9
 */