#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>
#include <set>

using namespace std;


bool cmp(pair<int, int> a, pair<int, int> b)
{
    return a.second < b.second;
}

void bfs(vector< vector<int> >* vecc,
         int k,
         bool* fired,
         int* dist,
         queue<int>* q)
{
    q->pop();
    fired[k]=true;
    for(size_t i=0; i<(*vecc)[k].size(); ++i)
    {
        if(!fired[(*vecc)[k][i]])
        {
            dist[(*vecc)[k][i]] = dist[k]+1;
            q->push((*vecc)[k][i]);
        }
    }
    while(!q->empty())
    {
        bfs(vecc,
            q->front(),
            fired,
            dist,
            q);
    }
}

int main()
{
    int n,m;
    cin >> n >> m;

    vector< vector<int> > vec(n);
    int dist1[n], dist2[n];
    bool fired[n];
    queue<int>* q = new queue<int>;
    int dist[n];
    int cities[m];

    for(int i=0; i<n-1; ++i)
    {
        int k,l;
        cin >> k >> l;
        vec[k-1].push_back(l-1);
        vec[l-1].push_back(k-1);
        fired[i] = false;
        //cout << "got\n";
    }
    for(int i=0; i<m; ++i)
    {
        int k;
        cin >> k;
        cities[i] = k-1;
    }

    if(m==1){
        cout <<"YES\n"<< cities[0]+1;
        return 0;
    }

    q->push(cities[0]);
    dist[cities[0]]=0;
    bfs(&vec,
        cities[0],
        fired,
        dist,
        q);


    for(int i=0; i<n; ++i)
    {
        dist1[i]=dist[i];
        //cout << dist[i] << " ";
    }


    pair<int, int> p[m];
    for(int i=0; i<m; ++i)
    {
        p[i].first = cities[i];
        p[i].second = dist[cities[i]];
    }


    sort(p,p+m,cmp);


    for(int i=1; i<m; ++i)
    {
        if(dist[cities[i]]%2!=0)
        {
            cout << "NO";
            return 0;
        }
    }


    int len = p[m-1].second/2;


    set<int> s1, sM;

    for(int i=0; i<n; ++i)
    {
        fired[i] = false;
        if(dist[i]==len)
        {
            s1.insert(i);
        }
        dist[i] = 0;
    }
    delete q;
    q = new queue<int>;
    q->push(p[m-1].first);
    bfs(&vec,
        p[m-1].first,
        fired,
        dist,
        q);


    for(int i=0; i<n; ++i)
    {
        dist2[i]=dist[i];
        //cout << dist[i] << " ";
    }

    for(int i=0; i<n; ++i)
    {
        if(dist1[i]==dist2[i]){
            cout << "YES\n" << i+1;
            return 0;
        }
    }

    return 0;
}
