#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <unordered_map>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <limits>
#include <queue>

#define pb push_back
#define mp make_pair
#define fs first
#define sc second
#define fori(i,s,n) for (int i = (s); i < (n); ++i)

using namespace std;

typedef long long LL;

void set_precise(int n) {
	cout << setprecision(n);
	cout << fixed;
}

int const N = 200003;

vector <int> g[N];
vector <int> si;
int bfs_dist[N];
int used[N] = { 0 };

void clear_used() {
	fori(i, 0, N) {
		used[i] = 0;
	}
}

void bfs(int v) {
	clear_used();
	queue <pair <int, int> > q;
	q.push(mp(v, 0));
	used[v] = 1;
	while (!q.empty()) {
		int cur = q.front().fs;
		int d = q.front().sc;
		bfs_dist[cur] = d;
		q.pop();
		fori(i, 0, g[cur].size()) {
			int next = g[cur][i];
			if (!used[next]) {
				q.push(mp(next, d + 1));
				used[next] = 1;
			}
		}
	}
}

int find_farest() {
	int res = -1;
	int max_dist = 0;
	fori(i, 0, si.size()) {
		int v = si[i];
		if (bfs_dist[v] > max_dist) {
			max_dist = bfs_dist[v];
			res = v;
		}
	}
	return res;
}

int dfs_middle(int x, int v, vector <int>& path) {
	used[x] = 1;
	path.pb(x);
	if (x == v) {
		if (path.size() % 2 == 0) {
			path.pop_back();
			return -1;
		}
		int ans = path[path.size() / 2];
		path.pop_back();
		return ans;
	}
	int ans = -1;
	fori(i, 0, g[x].size()) {
		int next = g[x][i];
		if (!used[next]) {
			int cur_ans = dfs_middle(next, v, path);
			if (ans == -1) {
				ans = cur_ans;
			}
		}
	}
	path.pop_back();
	return ans;
}

int find_middle(int u, int v) {
	vector <int> path;
	clear_used();
	return dfs_middle(u, v, path);
}

int main() {
#ifdef _DEBUG
	freopen("inputE.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n, m;
	cin >> n >> m;
	fori(i, 0, n - 1) {
		int a, b;
		cin >> a >> b;
		--a;
		--b;
		g[a].pb(b);
		g[b].pb(a);
	}
	fori(i, 0, m) {
		int x;
		cin >> x;
		si.pb(x - 1);
	}
	if (m == 1) {
		cout << "YES" << endl;
		cout << si[0] + 1;
		return 0;
	}
	bfs(si[0]);
	int si_far1 = find_farest();
	bfs(si_far1);
	int si_far2 = find_farest();
	int poss_ans = find_middle(si_far1, si_far2);
	if (poss_ans == -1) {
		cout << "NO";
		return 0;
	}
	bfs(poss_ans);
	int dist = bfs_dist[si[0]];
	fori(i, 1, m) {
		int v = si[i];
		if (bfs_dist[v] != dist) {
			cout << "NO";
			return 0;
		}
	}
	cout << "YES" << endl;
	cout << poss_ans + 1;
	return 0;
}