#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <unordered_map>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <limits>

#define pb push_back
#define mp make_pair
#define fs first
#define sc second
#define fori(i,s,n) for (int i = (s); i < (n); ++i)

using namespace std;

typedef long long LL;

void set_precise(int n) {
	cout << setprecision(n);
	cout << fixed;
}

LL n;
LL x[1001];
LL y[1001];
LL h[1001];
LL h0 = numeric_limits<LL>::min();
LL h0y = numeric_limits<LL>::min();
LL xmin = numeric_limits<LL>::max();
LL xmax = numeric_limits<LL>::min();
LL ymin = numeric_limits<LL>::max();
LL ymax = numeric_limits<LL>::min();

LL h1(LL x, LL x0) {
	return (x - x0) + h0;
}

LL h2(LL x, LL x0) {
	return -(x - x0) + h0;
}

LL dx(LL i, LL x0) {
	return min(h1(x[i], x0), h2(x[i], x0)) - h[i];
}

LL fx(LL x0) {
	LL result = numeric_limits<LL>::max();
	for (LL i = 0; i < n; ++i) {
		result = min(result, dx(i, x0));
	}
	return result;
}

LL h1y(LL y, LL y0) {
	return (y - y0) + h0y;
}

LL h2y(LL y, LL y0) {
	return -(y - y0) + h0y;
}

LL dy(LL i, LL y0) {
	return min(h1y(y[i], y0), h2y(y[i], y0)) - h[i];
}

LL fy(LL y0) {
	LL result = numeric_limits<LL>::max();
	for (LL i = 0; i < n; ++i) {
		result = min(result, dy(i, y0));
	}
	return result;
}

LL ternary(LL(*f)(LL x), LL left, LL right) {
	if (right - left < 8) {
		LL xmax = left;
		LL maxVal = f(xmax);
		for (LL i = left + 1; i < right; ++i) {
			LL t = f(i);
			if (t > maxVal) {
				maxVal = t;
				xmax = i;
			}
		}
		return xmax;
	}
	else {
		LL x1 = left + (right - left) / 3;
		LL fx1 = f(x1);
		LL x2 = left + (right - left) / 3 * 2;
		LL fx2 = f(x2);
		if (fx1 > fx2) {
			return ternary(f, left, x2);
		}
		else {
			return ternary(f, x1, right);
		}
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	set_precise(10);
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	for (LL i = 0; i < n; ++i) {
		cin >> x[i] >> y[i] >> h[i];
		xmin = min(xmin, x[i]);
		ymin = min(ymin, y[i]);
		xmax = max(xmax, x[i]);
		ymax = max(ymax, y[i]);
	}
	for (LL i = 0; i < n; ++i) {
		h0 = max(h0, h[i] + x[i] - xmin);
		h0y = max(h0y, h[i] + y[i] - ymin);
	}
	h0 = max(h0, h0y);
	h0y = h0;
	LL xok = ternary(fx, xmin, xmax);
	LL yok = ternary(fy, ymin, ymax);
	LL hok = h0 - min(fx(xok), fy(yok));
	cout << xok << ' ' << yok << ' ' << hok << endl;
	return 0;
}