#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <unordered_map>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <limits>
#include <queue>
#include <string>

#define pb push_back
#define mp make_pair
#define fs first
#define sc second
#define fori(i,s,n) for (int i = (s); i < (n); ++i)

using namespace std;

typedef long long LL;

void set_precise(int n) {
	cout << setprecision(n);
	cout << fixed;
}

int n, m;
char as[1000][1000];
unordered_map<char, pair<int, int>> letters;
int area[1000][1000];
int ai;
int aj;
int integral[1001][1001];

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> m;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			cin >> as[i][j];
			if (as[i][j] != '.' && as[i][j] != 'A') {
				letters[as[i][j]] = make_pair(i, j);
			}
			if (as[i][j] == 'A') {
				ai = i;
				aj = j;
			}
		}
	}
	for (auto p : letters) {
		int i = p.second.first;
		int j = p.second.second;
		int li = 0, ri = 0, lj = 0, rj = 0;
		if (i < ai) {
			li = 0;
			ri = i;
		}
		else if (i == ai) {
			li = 0;
			ri = n;
		}
		else {
			li = i;
			ri = n;
		}
		if (j < aj) {
			lj = 0;
			rj = j;
		}
		else if (j == aj) {
			lj = 0;
			rj = m;
		}
		else {
			lj = j;
			rj = m;
		}
		for (int x = li; x <= ri; ++x) {
			for (int y = lj; y <= rj; ++y) {
				area[x][y] = 1;
			}
		}
		//cout << p.first << endl;
		//for (int i = 0; i < n; ++i) {
		//	for (int j = 0; j < m; ++j) {
		//		cout << area[i][j];
		//	}
		//	cout << endl;
		//}
		//cout << endl;
	}
	for (int i = 0; i < n; ++i) {
		integral[i][0] = 0;
	}
	for (int j = 0; j < m; ++j) {
		integral[0][j] = 0;
	}
	for (int i = 1; i <= n; ++i) {
		for (int j = 1; j <= m; ++j) {
			integral[i][j] = integral[i - 1][j] + integral[i][j - 1] - integral[i - 1][j - 1] + area[i - 1][j - 1];
		}
	}
	vector<pair<int, int>> edge;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (!area[i][j] && (i == 0 || i == (n - 1) || j == 0 || j == (m - 1)
				|| area[i - 1][j - 1] || area[i - 1][j] || area[i - 1][j + 1] 
				|| area[i][j - 1]                       || area[i][j + 1] 
				|| area[i + 1][j + 1] || area[i + 1][j] || area[i + 1][j + 1])) {
				edge.push_back(make_pair(i, j));
			}
		}
	}
	int maxarea = numeric_limits<int>::min();
	int maxr0 = 0;
	int maxc0 = 0;
	int maxr1 = 0;
	int maxc1 = 0;
	for (int i = 0; i < edge.size(); ++i) {
		for (int j = i + 1; j < edge.size(); ++j) {
			int r0 = edge[i].first;
			int c0 = edge[i].second;
			int r1 = edge[j].first;
			int c1 = edge[j].second;
			if (r1 < r0) {
				swap(r1, r0);
			}
			if (c1 < c0) {
				swap(c1, c0);
			}
			if (ai < r0 || ai > r1) {
				continue;
			}
			if (aj < c0 || aj > c1) {
				continue;
			}
			int s = integral[r1 + 1][c1 + 1] - integral[r1 + 1][c0] - integral[r0][c1 + 1] + integral[r0][c0];
			if (s) continue;
			int area = (r1 - r0 + 1) * (c1 - c0 + 1);
			if (area > maxarea) {
				maxarea = area;
				maxr0 = r0;
				maxc0 = c0;
				maxr1 = r1;
				maxc1 = c1;
			}
		}
	}
	vector<pair<int, int>> upper, lower, middleLeft, middleRight;
	for (auto p : letters) {
		int r = p.second.first;
		int c = p.second.second;
		if (r < maxr0) {
			upper.push_back(p.second);
		}
		else if (r > maxr1) {
			lower.push_back(p.second);
		}
		else if (c < maxc0) {
			middleLeft.push_back(p.second);
		}
		else {
			middleRight.push_back(p.second);
		}
	}
	struct Part {
		vector<pair<int, int>> & part;
		int top;
		int left;
		int bottom;
		int right;
	};
	Part parts[] = {
		{ upper, 0, 0, maxr0, m },
		{ middleLeft, maxr0, 0, maxr1 + 1, maxc0 },
		{ middleRight, maxr0, maxc1 + 1, maxr1 + 1, m },
		{ lower, maxr1 + 1, 0, n, m },
	};

	for (Part p : parts) {
		sort(p.part.begin(), p.part.end(), [](auto p1, auto p2) { return p2 < p1; });
		int left = p.left;
		int top = p.top;
		for (int i = 0; i < p.part.size(); ++i) {
			int y = p.part[i].first;
			int x = p.part[i].second;
			if (i + 1 == p.part.size() || p.part[i + 1].second != x) {
				for (int yy = top; yy < p.bottom; ++yy) {
					for (int xx = left; xx <= (i + 1 == p.part.size() ? p.right : x); ++xx) {
						if (as[yy][xx] == '.') {
							as[yy][xx] = tolower(as[y][x]);
						}
					}
				}
				left = x + 1;
				top = p.top;
			}
			else {
				for (int yy = top; yy <= y; ++yy) {
					for (int xx = left; xx <= x; ++xx) {
						if (as[yy][xx] == '.') {
							as[yy][xx] = tolower(as[y][x]);
						}
					}
				}
				top = y + 1;
			}
		}
	}
	for (int i = maxr0; i != maxr1 + 1; ++i) {
		for (int j = maxc0; j != maxc1 + 1; ++j) {
			as[i][j] = 'a';
		}
	}
	as[ai][aj] = 'A';



	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			cout << as[i][j];
		}
		cout << endl;
	}
	return 0;
}