#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

const int MX = 100 + 7;
char a[MX][MX];

vector<vector<int>> used(MX, vector<int>(MX));
vector<pair<int, int>> path;

int m, n;

vector<pair<int, int>> go_tp0 = {
        {0, 0},
        {1, 1},
        {1, 0},
        {0, 1},
        {0, 0}
};
vector<pair<int, int>> go_tp1 = {
        {0, 0},
        {1, 0},
        {0, 1},
        {1, 1},
        {0, 0}
};

void dfs(int xx, int yy, int tp, int pos_x, int pos_y) {
    used[xx][yy] = 1;

    vector<pair<int, int>> to_do;

    if (tp) to_do = go_tp1;
    else to_do = go_tp0;

    for (auto& x : to_do) {
        x.first = (x.first + pos_x) % 2 + xx;
        x.second = (x.second + pos_y) % 2 + yy;
    }
    for (int k = 1; k < (int)to_do.size(); k++) {
        pair<int, int> now = to_do[k];
        path.push_back(now);
        for (int i = -1; i < 1; i++) {
            for (int j = -1; j < 1; j++) {
                int to_x = now.first + i;
                int to_y = now.second + j;

                if (to_x < 0 || to_y < 0) continue;
                if (to_x >= n || to_y >= m) continue;

                if (!used[to_x][to_y] && a[to_x][to_y] == 'X') {
                    dfs(to_x, to_y, tp ^ (k % 2), now.first - to_x, now.second - to_y);
                }
            }
        }
    }
}


void solve(int x, int y) {
    path.push_back({x, y});
    dfs(x, y, 0, 0, 0);
    path.pop_back();
    cout << (int)path.size() - 1 << '\n';
    for (const pair<int, int>& x : path) {
        cout << x.second << ' ' << x.first << '\n';
    }
}

int main() {

    iostream::sync_with_stdio(false);
    cin.tie(0);

#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif


    cin >> m >> n;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
        }
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] == 'X') {
                solve(i, j);
                return 0;
            }
        }
    }


    return 0;
}
