#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll INF = 4e18 + 179;

ll gcd(ll a, ll b, ll& x, ll& y) {
    if (!a) {
        x = 0;
        y = 1;
        return b;
    }
    ll g, x1, y1;
    g = gcd(b % a, a, x1, y1);
    x = y1 - (b / a) * x1;
    y = x1;
    return g;
}

ll solve5(ll nw_st, ll step, ll mod, ll bound) {
    bound--;
    if (bound < 0) {
        return INF;
    }
    if (bound == 0) {
        return nw_st;
    }

    ll ld, rd, lc, rc;

    ld = mod;
    rd = step;
    lc = 0;
    rc = 1;

    ll pos = nw_st;

    while (bound > 0) {
        {
            ll t = min(bound, pos / ld);
            pos -= t * ld;
            bound -= t;
        }

        ll next_ld = ld % rd;
        ll next_lc = lc + (ld / rd) * rc;

        ll next_rd = rd % next_ld;
        ll next_rc = rd / next_ld + rc;

        ld = next_ld;
        lc = next_lc;

        rd = next_rd;
        rc = next_rc;
    }
    return pos;
}

ll solve4(ll nw_st, ll step, ll mod, ll bound) {
    ll ans = INF;
    for (ll k = 0; k < bound; k++) {
        ans = min(ans, (step * k + nw_st) % mod);
    }
    return ans;
}

ll solve3(ll C, ll l, ll r, ll w, ll h) {
    ll a = 1, b = 0;
    ll d = gcd(2 * w, 2 * h, a, b);

    while (a < 0) {
        a += (2 * h) / d;
        b -= (2 * w) / d;
    }
    if (l <= C && C <= r) return 0;
    if (C > r) l += 2 * h, r += 2 * h;

    ll k1 = (l - 1 - C + d) / d;
    ll k2 = (r - C) / d;

    ll ans = INF;

    ll lcm = (4 * w * h) / d;

    ll nw_st = (k1 * 2 * a) % lcm;
    nw_st = (nw_st * w) % lcm;
    return solve5(nw_st, 2 * a * w, lcm, k2 - k1 + 1);
}

ll solve2(int x_st, int y_st, int xx, int y1, int y2, int w, int h) {
    int C = xx - x_st;
    if (C < 0) C += 2 * w;
    ll ans = C;

    y1 -= y_st;
    y2 -= y_st;
    if (y1 < 0) y1 += 2 * h, y2 += 2 * h;

    ll res = solve3(C % (2 * h), y1, y2, w, h);
    return min(INF, res + ans);
}

ll solve(int x_st, int y_st, int x, int y1_, int y2_, int w, int h) {
    ll ans = INF;
    int y1 = min(y1_, y2_);
    int y2 = max(y1_, y2_);

    ans = min(ans, solve2(x_st, y_st, x, y1, y2, w, h));
    ans = min(ans, solve2(x_st, y_st, 2 * w - x, y1, y2, w, h));
    ans = min(ans, solve2(x_st, y_st, x, 2 * h - y2, 2 * h - y1, w, h));
    ans = min(ans, solve2(x_st, y_st, 2 * w - x, 2 * h - y2, 2 * h - y1, w, h));
    return ans;
}

ll stupid(int x_st, int y_st, int x, int y1, int y2, int w, int h) {
    return INF;
}

void print_ans(ll x, ll y, ll ans, ll w, ll h) {
    if (ans == INF) {
        cout << "-1\n";
        return;
    }

    x = (x + ans) % (2 * w);
    if (x > w) x = 2 * w - x;

    y = (y + ans) % (2 * h);
    if (y > h) y = (2 * h - y);

    cout << ans << ' ' << x << ' ' << y << '\n';
}

int main() {
    iostream::sync_with_stdio(false);
    cin.tie(0);

#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif
    int w, h;
    cin >> w >> h;

    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }
    a.push_back(a[0]);

    int tests;
    cin >> tests;
    while (tests--) {
        int x_st, y_st;
        cin >> x_st >> y_st;

        ll ans = INF;
        for (int i = 0; i < n; i++) {
            if (a[i].first == a[i + 1].first) {
                ans = min(ans, solve(x_st, y_st, a[i].first,
                        a[i].second, a[i + 1].second, w, h));
            } else {
                ans = min(ans, solve(y_st, x_st, a[i].second,
                        a[i].first, a[i + 1].first, h, w));
            }
        }

        print_ans(x_st, y_st, ans, w, h);
    }


    return 0;
}