#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

const int inf = 1e9;

const int N = 1005;

int n, m;
char s[N][N];
char res[N][N];

void read() {
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }
}

void solve(int LI, int RI, int LJ, int RJ) {
    if (LJ > RJ || LI > RI) return;
    for (int j = LJ; j <= RJ; j++) {
        vector<int> pos;
        pos.push_back(LI - 1);
        for (int i = LI; i <= RI; i++) {
            if (s[i][j] != '.') {
                pos.push_back(i);
            }
        }
        for (int it = 1; it < (int) pos.size(); it++) {
            int li = pos[it - 1] + 1;
            int ri = it + 1 == (int) pos.size() ? RI : pos[it];
            char symb = s[pos[it]][j] - 'A' + 'a';
            for (int i = li; i <= ri; i++) {
                res[i][j] = symb;
            }
        }
    }

    for (int j = LJ + 1; j <= RJ; j++) {
        int any = 0;
        for (int i = LI; i <= RI; i++) {
            if (s[i][j] != '.') {
                any = 1;
                break;
            }
        }
        if (any) {
            continue;
        }
        for (int i = LI; i <= RI; i++) {
            res[i][j] = res[i][j - 1];
        }
    }

    for (int j = RJ - 1; j >= LJ; j--) {
        int any = 0;
        for (int i = LI; i <= RI; i++) {
            if (s[i][j] != '.') {
                any = 1;
                break;
            }
        }
        if (any) {
            continue;
        }
        for (int i = LI; i <= RI; i++) {
            res[i][j] = res[i][j + 1];
        }
    }
}

void fast() {
    vector<int> ls, rs, us, ds;
    ls.push_back(0);
    rs.push_back(m - 1);
    us.push_back(0);
    ds.push_back(n - 1);
    int ai, aj;
    vector<pii> ps;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (s[i][j] == '.') continue;
            if (s[i][j] == 'A') {
                ai = i;
                aj = j;
                continue;
            }
            ls.push_back(j + 1);
            rs.push_back(j - 1);
            us.push_back(i + 1);
            ds.push_back(i - 1);
            ps.emplace_back(i, j);
        }
    }
    int bli, bri, blj, brj;
    int best_area = 0;
    for (int lj : ls) {
        for (int rj : rs) {
            for (int li : us) {
                for (int ri : ds) {
                    if (li > ri || lj > rj) continue;
                    if (ai < li || ai > ri || aj < lj || aj > rj) continue;
                    int ok = 1;
                    for (pii p : ps) {
                        if (li <= p.first && p.first <= ri &&
                            lj <= p.second && p.second <= rj) {
                            ok = 0;
                            break;
                        }
                    }
                    if (!ok) continue;
                    int tmp_area = (rj - lj + 1) * (ri - li + 1);
                    if (tmp_area > best_area) {
                        best_area = tmp_area;
                        bli = li;
                        bri = ri;
                        blj = lj;
                        brj = rj;
                    }
                }
            }
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            res[i][j] = s[i][j];
        }
    }
    solve(0, n - 1, 0, blj - 1);
    solve(0, n - 1, brj + 1, m - 1);
    solve(0, bli - 1, blj, brj);
    solve(bri + 1, n - 1, blj, brj);
    for (int i = bli; i <= bri; i++) {
        for (int j = blj; j <= brj; j++) {
            res[i][j] = 'a';
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (s[i][j] != '.') {
                res[i][j] = s[i][j];
            }
        }
    }
}

void WORK() {
    read();
    fast();
    for (int i = 0; i < n; i++) {
        cout << res[i] << "\n";
    }
}

int main() {
    iostream::sync_with_stdio(false);
    cin.tie(0);

#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif

    WORK();

    return 0;
}