#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

const int inf = 1e9;

struct SuffixArray {
    string s;
    int n;
    vector<int> p, pn, c, cn, cnt;

    SuffixArray(string ss) {
        s = ss;
        s.push_back(0);
        n = (int) s.size();

        p.resize(n);
        pn.resize(n);
        c.resize(n);
        cn.resize(n);

        cnt.assign(300, 0);

        for (int i = 0; i < n; i++) cnt[s[i]]++;
        for (int i = 1; i < (int) cnt.size(); i++) cnt[i] += cnt[i - 1];
        for (int i = n - 1; i >= 0; i--) p[--cnt[s[i]]] = i;
        int q = 0;
        c[p[0]] = 0;
        for (int i = 1; i < n; i++) {
            if (s[p[i]] != s[p[i - 1]]) q++;
            c[p[i]] = q;
        }
        for (int len = 1; len < n; len <<= 1) {
            cnt.assign(n, 0);
            for (int i = 0; i < n; i++) {
                pn[i] = p[i] - len;
                pn[i] = (pn[i] % n + n) % n;
            }
            for (int i = 0; i < n; i++) cnt[c[pn[i]]]++;
            for (int i = 1; i < n; i++) cnt[i] += cnt[i - 1];
            for (int i = n - 1; i >= 0; i--) {
                p[--cnt[c[pn[i]]]] = pn[i];
            }
            q = 0;
            cn[p[0]] = 0;
            for (int i = 1; i < n; i++) {
                int l1 = p[i], r1 = (l1 + len) % n;
                int l2 = p[i - 1], r2 = (l2 + len) % n;
                if (c[l1] != c[l2] || c[r1] != c[r2]) q++;
                cn[p[i]] = q;
            }
            c = cn;
        }
        pn.clear();
        for (int i = 1; i < n; i++) {
            pn.push_back(p[i]);
        }
        p = pn;
        n--;
        s.pop_back();
    }
};

// s with dollar
// s$
vector<int> lcp(const vector<int>& suf, string s) {
    int n = (int)s.length();
    s += "$";
    vector<int> lcp(n);
    vector<int> back(n);
    for (int i = 0; i < n; i++) {
        back[suf[i]] = i;
    }
    for (int i = 0, k = 0; i < n; i++) {
        if (back[i] == n - 1) {
            k = 0;
            continue;
        }
        while (s[i + k] == s[suf[back[i] + 1] + k]) {
            k++;
        }
        lcp[back[i]] = k;
        k = max(0, k - 1);
    }
    return lcp;
}

void TEST() {
    int n = 100;
    mt19937 rnd(time(NULL));
    for (int it = 0; it < 100; it++) {
        string s(n, '?');
        for (int i = 0; i < n; i++) {
            s[i] = rnd() % 3 + 'a';
        }
        SuffixArray sa(s);
        for (int i = 1; i < n; i++) {
            if(s.substr(sa.p[i - 1]) >= s.substr(sa.p[i])) {
                cout << s << "\n";
                cout << s.substr(sa.p[i - 1]) << "\n";
                cout << s.substr(sa.p[i]) << "\n";
                cout << "WA\n\n";
                for (int i = 0; i < n; i++) {
                    cout << sa.p[i] << " : " << s.substr(sa.p[i]) << "\n";
                }
                exit(0);
            }
        }
        vector<int> _lcp = lcp(sa.p, s);
        for (int i = 0; i + 1 < n; i++) {
            string prv = s.substr(sa.p[i]);
            string nxt = s.substr(sa.p[i + 1]);
            int tmp = 0;
            while (tmp < (int) prv.size() && tmp < (int) nxt.size() && prv[tmp] == nxt[tmp])
                tmp++;
            // cout << tmp << " : " << _lcp[i] << "\n";
            assert(tmp == _lcp[i]);
        }
    }
    cout << "OK\n";
}

void comp(ll &p1, ll &q1, ll p2, ll q2) {
    if (p2 * q1 >= p1 * q2) {
        p1 = p2;
        q1 = q2;
    }
}

struct S {
    int mn;
    set<int> val, ind;
};

int main() {
    iostream::sync_with_stdio(false);
    cin.tie(0);

#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif

    //TEST();

    string s;
    cin >> s;
    SuffixArray sa(s);
    vector<int> _lcp = lcp(sa.p, s);

    int n = s.length();
    ll p = n, q = n;

    vector<S> v(n);
    vector<int> whr(n);
    for (int i = 0; i < n; i++) {
        whr[i] = i;
        v[i].mn = 1e9;
        v[i].val.insert(sa.p[i]);
        v[i].ind.insert(i);
    }

    auto merge = [&](int a, int b, int mn) {
        if (v[whr[a]].ind.size() < v[whr[b]].ind.size())
            swap(a, b);
        S &s1 = v[whr[a]], &s2 = v[whr[b]];
        s1.mn = min(s1.mn, s2.mn);
        s1.mn = min(s1.mn, mn);
        for (int x: s2.val) {
            auto j = s1.val.lower_bound(x);
            if (j != s1.val.end()) {
                comp(p, q, *j - x + s1.mn, *j - x);
            }
            if (j != s1.val.begin()) {
                j--;
                comp(p, q, x - *j + s1.mn, x - *j);
            }
        }
        for (int x: s2.val)
            s1.val.insert(x);
        for (int x: s2.ind) {
            whr[x] = whr[a];
            s1.ind.insert(x);
        }
    };

    vector<pair<int,int>> l;
    for (int i = 0; i < n - 1; i++)
        l.push_back({_lcp[i], i});
    sort(l.begin(), l.end());
    for (int i = n - 2; i >= 0; i--) {
        merge(l[i].second, l[i].second + 1, l[i].first);
    }

    ll g = __gcd(p, q);

    cout << p / g << '/' << q / g << '\n';

    return 0;
}
