#include <bits/stdc++.h>
using namespace std;

string to_string(bool x)
{
    return x ? "true" : "false";
}

string to_string(char x)
{
    return string(1, x);
}

string to_string(string x)
{
    return "\"" + x + "\"";
}

string to_string(const char *x)
{
    return to_string((string) x);
}

template <typename A, typename B>
string to_string(pair<A, B> p)
{
    return "(" + to_string(p.first) + ", " + to_string(p.second) + ")";
}

template <typename A>
string to_string(A arr)
{
    auto first = true;
    string result = "{";
    for (const auto &x: arr) {
        if (!first) {
            result += ", ";
        }
        result += to_string(x);
        first = false;
    }
    result += "}";
    return result;
}

void debug_out() {
    cerr << endl;
}

template <typename Head, typename ... Tail>
void debug_out(Head head, Tail ...tail) {
    cerr << to_string(head);
    debug_out(tail...);
}

#ifdef LOCAL
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]: "; debug_out(__VA_ARGS__);
#else
#define debug(...) 42;
#endif

using ll = long long;

const ll N = 200000;
const ll INF = 1000000000;
vector<ll> g[N];
ll dist[N];
ll cnt[N];

void solve()
{
    ll n, m; cin >> n >> m;
    for (ll i = 0; i < n - 1; i++) {
        ll a, b; cin >> a >> b;
        a--; b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }

    fill(dist, dist + N, INF);

    queue<ll> q;
    for (ll i = 0; i < m; i++) {
        ll a; cin >> a;
        a--;
        q.push(a);
        dist[a] = 0;
        cnt[a] = 1;
    }

    while (!q.empty()) {
        auto u = q.front();
        q.pop();

        for (auto to : g[u]) {
            if (dist[to] == INF) {
                dist[to] = dist[u] + 1;
                cnt[to] = cnt[u];
                q.push(to);
            } else if (dist[to] == dist[u] + 1) {
                cnt[to] += cnt[u];
            }
        }
    }

    ll answer = -1;
    for (ll i = 0; i < n; i++)
        if (cnt[i] == m)
            answer = i;

    if (answer == -1)
        cout << "NO";
    else
        cout << "YES\n" << (answer + 1);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("xxx.in", "r", stdin);
    freopen("xxx.out", "w", stdout);
#endif

    solve();

    return 0;
}