#include <bits/stdc++.h>
using namespace std;

string to_string(bool x)
{
    return x ? "true" : "false";
}

string to_string(char x)
{
    return string(1, x);
}

string to_string(string x)
{
    return "\"" + x + "\"";
}

string to_string(const char *x)
{
    return to_string((string) x);
}

template <typename A, typename B>
string to_string(pair<A, B> p)
{
    return "(" + to_string(p.first) + ", " + to_string(p.second) + ")";
}

template <typename A>
string to_string(A arr)
{
    auto first = true;
    string result = "{";
    for (const auto &x: arr) {
        if (!first) {
            result += ", ";
        }
        result += to_string(x);
        first = false;
    }
    result += "}";
    return result;
}

void debug_out() {
    cerr << endl;
}

template <typename Head, typename ... Tail>
void debug_out(Head head, Tail ...tail) {
    cerr << " " << to_string(head);
    debug_out(tail...);
}

#ifdef LOCAL
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]: "; debug_out(__VA_ARGS__);
#else
#define debug(...) 42;
#endif

using ll = long long;
using vi = vector < int >;

int N;
vi A;
vi ans;

int get_ans(int t) {
	int sum = 0, res = 0;
	for (int i = 0; i < N; i++) {
		if (sum + A[i] > t) {
			sum = 0;
			res++;
		}
		sum += A[i];
	}
	if (sum)
		res++;
	return res;
}

void calc(int l, int r, int al, int ar) {
	debug(l, r, al, ar);
	if (r <= l)
		return;
	if (al == ar - 1 || al == ar) {
		for (int i = l; i < r; i++)
			ans[i] = al;
		return;	
	}
	int mid = (l + r) / 2;
	int mid_val = get_ans(mid);
	calc(l, mid, mid_val + 1, ar);
	calc(mid, r, al, mid_val);
}

void solve() {
	cin >> N;
	A.resize(N);
	int sum = 0;
	int mx = -1;
	for (int i = 0; i < N; i++) {
		cin >> A[i];
		mx = max(mx, A[i]);	
		sum += A[i];
	}
	ans.resize(sum + 1, -1);
	calc(mx, sum + 1, 1, sum);
	int q;
	cin >> q;
	debug(ans);
	debug(get_ans(4));
	for (int i = 0; i < q; i++) {
		int t;
		cin >> t;
		if (ans[t] < 0)
			cout << "Impossible\n";
		else
			cout << ans[t] << "\n";
	}
}                               

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("xxx.in", "r", stdin);
    freopen("xxx.out", "w", stdout);
#endif
	solve();
    return 0;
}