#include <bits/stdc++.h>
using namespace std;

string to_string(bool x)
{
    return x ? "true" : "false";
}

string to_string(char x)
{
    return string(1, x);
}

string to_string(string x)
{
    return "\"" + x + "\"";
}

string to_string(const char *x)
{
    return to_string((string) x);
}

template <typename A, typename B>
string to_string(pair<A, B> p)
{
    return "(" + to_string(p.first) + ", " + to_string(p.second) + ")";
}

template <typename A>
string to_string(A arr)
{
    auto first = true;
    string result = "{";
    for (const auto &x: arr) {
        if (!first) {
            result += ", ";
        }
        result += to_string(x);
        first = false;
    }
    result += "}";
    return result;
}

void debug_out() {
    cerr << endl;
}

template <typename Head, typename ... Tail>
void debug_out(Head head, Tail ...tail) {
    cerr << to_string(head);
    debug_out(tail...);
}

#ifdef LOCAL
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]: "; debug_out(__VA_ARGS__);
#else
#define debug(...) 42;
#endif

using ll = long long;

const ll N = 1000;
ll n, x[N], y[N], h[N];

ll bestH, bestX, bestY;

ll updateXY(ll curX, ll curY)
{
    ll result = (ll) 0;
    for (ll i = 0; i < n; i++) {
        ll dx = abs(curX - x[i]);
        ll dy = abs(curY - y[i]);
        if (dx >= dy) {
            result = max(result, dx + h[i]);
        } else {
            result = max(result, dy + h[i]);
        }
    }

    if (result < bestH)
    {
        bestH = result;
        bestX = curX;
        bestY = curY;
    }

    return result;
}

ll updateX(ll curX)
{
    ll yL = *min_element(y, y + n);
    ll yR = *max_element(y, y + n);
    ll result = (ll) 1e18;
    while (yR - yL > 7) {
        ll yM1 = (yL * 2 + yR) / 3;
        ll yM2 = (yL + 2 * yR) / 3;

        ll h1 = updateXY(curX, yM1);
        ll h2 = updateXY(curX, yM2);

        result = min(result, h1);
        result = min(result, h2);

        if (h1 < h2) {
            yR = yM2;
        } else {
            yL = yM1;
        }
    }

    for (ll curY = yL; curY <= yR; curY++) {
        ll h1 = updateXY(curX, curY);
        result = min(result, h1);
    }

    return result;
}

void solve()
{
    cin >> n;
    for (ll i = 0; i < n; i++)
        cin >> x[i] >> y[i] >> h[i];

    bestH = (ll) 1e18;
    bestX = 0;
    bestY = 0;

    ll xL = *min_element(x, x + n);
    ll xR = *max_element(x, x + n);
    while (xR - xL > 7) {
        ll xM1 = (xL * 2 + xR) / 3;
        ll xM2 = (xL + 2 * xR) / 3;

        ll h1 = updateX(xM1);
        ll h2 = updateX(xM2);
        if (h1 < h2) {
            xR = xM2;
        } else {
            xL = xM1;
        }
    }

    for (ll curX = xL; curX <= xR; curX++) {
        updateX(curX);
    }

    cout << bestX << " " << bestY << " " << bestH << endl;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("xxx.in", "r", stdin);
    freopen("xxx.out", "w", stdout);
#endif

    solve();

    return 0;
}