#include <bits/stdc++.h>
using namespace std;

string to_string(bool x)
{
    return x ? "true" : "false";
}

string to_string(char x)
{
    return string(1, x);
}

string to_string(string x)
{
    return "\"" + x + "\"";
}

string to_string(const char *x)
{
    return to_string((string) x);
}

template <typename A, typename B>
string to_string(pair<A, B> p)
{
    return "(" + to_string(p.first) + ", " + to_string(p.second) + ")";
}

template <typename A>
string to_string(A arr)
{
    auto first = true;
    string result = "{";
    for (const auto &x: arr) {
        if (!first) {
            result += ", ";
        }
        result += to_string(x);
        first = false;
    }
    result += "}";
    return result;
}

void debug_out() {
    cerr << endl;
}

template <typename Head, typename ... Tail>
void debug_out(Head head, Tail ...tail) {
    cerr << " " << to_string(head);
    debug_out(tail...);
}

#ifdef LOCAL
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]: "; debug_out(__VA_ARGS__);
#else
#define debug(...) 42;
#endif

using ll = long long;

const ll N = 1000;
const ll ALPHA = 'Z' - 'A' + 1;
const ll FAV_INDEX = 0;
ll n, m;
ll row[ALPHA];
ll col[ALPHA];
char w[N][N];

void solve()
{
    cin >> n >> m;

    vector<ll> available;
    for (ll i = 0; i < n; i++) {
        string str; cin >> str;
        for (ll j = 0; j < m; j++) {
            w[i][j] = str[j];
            if (w[i][j] != '.') {
                ll index = w[i][j] - 'A';
                row[index] = i;
                col[index] = j;
                available.push_back(index);
            }
        }
    }
    available.push_back(ALPHA);

    ll bestArea = -1;
    ll bestTopRow = -1;
    ll bestBotRow = -1;
    ll bestLeftCol = -1;
    ll bestRightCol = -1;

    for (ll top : available) {
        ll topRow = top == ALPHA ? -1 : row[top];

        for (ll bot : available) {
            ll botRow = bot == ALPHA ? n : row[bot];

            if (topRow > botRow)
                continue;

            for (ll left : available) {
                ll leftCol = left == ALPHA ? -1 : col[left];

                for (ll right : available) {
                    ll rightCol = right == ALPHA ? m : col[right];

                    if (rightCol < leftCol)
                        continue;

                    auto rows = botRow - topRow - 1;
                    auto cols = rightCol - leftCol - 1;
                    auto area = rows * cols;

                    auto valid = rows >= 0 && cols >= 0;
                    for (ll i : available) {
                        if (i == ALPHA)
                            continue;

                        if (i == FAV_INDEX) {
                            valid &= topRow < row[i] && row[i] < botRow &&
                                     leftCol < col[i] && col[i] < rightCol;
                        } else {
                            valid &= !(topRow < row[i] && row[i] < botRow &&
                                       leftCol < col[i] && col[i] < rightCol);
                        }
                    }
                    if (valid) {
                        if (area > bestArea) {
                            bestArea = area;
                            bestTopRow = topRow;
                            bestBotRow = botRow;
                            bestLeftCol = leftCol;
                            bestRightCol = rightCol;
                        }
                    }
                }
            }
        }
    }

    for (ll i = bestTopRow + 1; i < bestBotRow; i++) {
        for (ll j = bestLeftCol + 1; j < bestRightCol; j++) {
            if (w[i][j] == 'A')
                continue;
            w[i][j] = 'a';
        }
    }

    available.pop_back();
    for (ll x : available) {
        if (x == FAV_INDEX)
            continue;

        ll r = row[x];
        ll c = col[x];

        for (ll j = c - 1; j >= 0; j--) {
            if (w[r][j] == '.')
                w[r][j] = 'a' + x;
            else
                break;
        }

        for (ll j = c + 1; j < m; j++) {
            if (w[r][j] == '.')
                w[r][j] = 'a' + x;
            else
                break;
        }
    }

    debug(bestBotRow, bestTopRow, bestLeftCol, bestRightCol);

    for (ll i = bestBotRow - 1; i >= bestTopRow + 2; i--) {
        ll iPrev = i - 1;
        for (ll j = 0; j <= bestLeftCol; j++) {
            char x = w[i][j];
            if (x >= 'A' && x <= 'Z')
                x = (x - 'A') + 'a';

            if (x != 'a' && w[i][j] != '.' && w[iPrev][j] == '.') {
                w[iPrev][j] = x;
            }
        }
    }

    for (ll i = bestTopRow + 1; i <= bestBotRow - 2; i++) {
        ll iPrev = i + 1;
        for (ll j = 0; j <= bestLeftCol; j++) {
            char x = w[i][j];
            if (x >= 'A' && x <= 'Z')
                x = (x - 'A') + 'a';

            if (x != 'a' && w[i][j] != '.' && w[iPrev][j] == '.') {
                w[iPrev][j] = x;
            }
        }
    }

    for (ll i = bestBotRow - 1; i >= bestTopRow + 2; i--) {
        ll iPrev = i - 1;
        for (ll j = bestRightCol; j < m; j++) {
            char x = w[i][j];
            if (x >= 'A' && x <= 'Z')
                x = (x - 'A') + 'a';

            if (x != 'a' && w[i][j] != '.' && w[iPrev][j] == '.') {
                w[iPrev][j] = x;
            }
        }
    }

    for (ll i = bestTopRow + 1; i <= bestBotRow - 2; i++) {
        ll iPrev = i + 1;
        for (ll j = bestRightCol; j < m; j++) {
            char x = w[i][j];
            if (x >= 'A' && x <= 'Z')
                x = (x - 'A') + 'a';

            if (x != 'a' && w[i][j] != '.' && w[iPrev][j] == '.') {
                w[iPrev][j] = x;
            }
        }
    }

    for (ll i = n - 1; i >= 1; i--) {
        ll iPrev = i - 1;
        for (ll j = 0; j < m; j++) {
            char x = w[i][j];
            if (x >= 'A' && x <= 'Z')
                x = (x - 'A') + 'a';

            if (x != 'a' && w[i][j] != '.' && w[iPrev][j] == '.') {
                w[iPrev][j] = x;
            }
        }
    }

    for (ll i = 0; i < n - 1; i++) {
        ll iPrev = i + 1;
        for (ll j = 0; j < m; j++) {
            char x = w[i][j];
            if (x >= 'A' && x <= 'Z')
                x = (x - 'A') + 'a';

            if (x != 'a' && w[i][j] != '.' && w[iPrev][j] == '.') {
                w[iPrev][j] = x;
            }
        }
    }

    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < m; j++) {
            //assert(w[i][j] != '.');
            cout << w[i][j];
        }
        cout << "\n";
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("xxx.in", "r", stdin);
    freopen("xxx.out", "w", stdout);
#endif

    solve();

    return 0;
}