#include <iostream>
#include <vector>
#include <unordered_map>
#include <cmath>

using namespace std;

int solve(vector<int>& pos, vector<int>& a, vector<int>& b, int n, int t) {
	int cur = 0;
	int ans = 0;
	while (cur < n) {
		int batch = 0;
		int nxt = pos[cur];
		if (b[cur] - b[nxt] <= t) {
			batch += b[cur] - b[pos[cur]];
			cur = pos[cur];
		}
		while (cur < n && batch + a[cur] <= t) {
			batch += a[cur];
			cur++;
		}
		ans++;
	}
	return ans;
}

int main() {
	int n;
	cin >> n;
	vector<int> a(n);
	int mx = 0;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		mx = max(a[i], mx);
	}
	vector<int> b(n + 1);
	b[n] = 0;
	for (int i = n - 1; i >= 0; i--) {
		b[i] = b[i + 1] + a[i];
	}
	vector<int> pos(n);
	int l = n;
	const int r = 1000;
	int step = max(mx, r);
	for (int i = n - 1; i >= 0; i--) {
		while (b[i] - b[l] > step) {
			l--;
		}
		pos[i] = l;
	}
	vector<int> ans(step - mx);
	for (int i = mx; i < step; i++) {
		ans[i - mx] = solve(pos, a, b, n, i);
	}
	int q;
	cin >> q;
	for (int i = 0; i < q; i++) {
		int t;
		cin >> t;
		if (t < mx) {
			cout << "Impossible\n";
			continue;
		}
		if (t < step) {
			cout << ans[t - mx] << '\n';
		} else {
			cout << solve(pos, a, b, n, t) << '\n';
		}	
	}
}
