#include <iostream>
#include <vector>
#include <unordered_map>
#include <cmath>

using namespace std;

const int maxN = 2e5 + 9;

int pos[maxN];
int a[maxN];
int b[maxN];

int solve(int n, int t) {
	int cur = 0;
	int ans = 0;
	while (cur < n) {
		int batch = 0;
		while (cur < n && batch + b[cur] - b[pos[cur]] <= t) {
			//cout << cur << endl;
			batch += b[cur] - b[pos[cur]];
			cur = pos[cur];
		}
		while (cur < n && batch + a[cur] <= t) {
			batch += a[cur];
			cur++;
		}
		ans++;
	}
	return ans;
}

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(false);
	int n;
	cin >> n;
	int mx = 0;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		mx = max(a[i], mx);
	}
	b[n] = 0;
	for (int i = n - 1; i >= 0; i--) {
		b[i] = b[i + 1] + a[i];
	}
	int l = n;
	const int r = 4;
	int step = max(mx, r);
	for (int i = n - 1; i >= 0; i--) {
		while (b[i] - b[l] > step) {
			l--;
		}
		pos[i] = l;
	}
	vector<int> ans(step - mx, -1);
	int q;
	cin >> q;
	for (int i = 0; i < q; i++) {
		int t;
		cin >> t;
		if (t < mx) {
			cout << "Impossible\n";
			continue;
		}
		if (t < step) {
			if (ans[t - mx] == -1) {
				ans[t - mx] = solve(n, t);
			}
			cout << ans[t - mx] << '\n';
		} else {
			cout << solve(n, t) << '\n';
		}
	}
}
