#include <iostream>
#include <vector>
#include <unordered_map>
#include <cmath>

using namespace std;

const int maxN = 1000 + 9;
const long long INF = 4e16;

long long x[maxN];
long long y[maxN];
long long h[maxN];

tuple<long long, long long, long long> bin(int n) {
	long long need = 0;
	for (int i = 0; i < n; i++) {
		need = max(need, h[i]);
	}
	long long l = need - 1, r = INF;
	while (l + 1 != r) {
		long long m = (l + r) / 2;
		long long mxx = -INF, mxy = -INF, mnx = INF, mny = INF;
		for (int i = 0; i < n; i++) {
			mnx = min(x[i] + m - h[i], mnx);
			mny = min(y[i] + m - h[i], mny);
			mxx = max(x[i] - m + h[i], mxx);
			mxy = max(y[i] - m + h[i], mxy);
		}
		if (mnx >= mxx && mny >= mxy) {
			r = m;
		} else {
			l = m;
		}
	}
	long long mnx = INF, mny = INF;
	for (int i = 0; i < n; i++) {
		mnx = min(x[i] + r - h[i], mnx);
		mny = min(y[i] + r - h[i], mny);
	}
	return {r, mnx, mny};
}

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(false);
	int n;
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> x[i] >> y[i] >> h[i];
	}
	auto t = bin(n);
	cout << get<1>(t) << ' ' << get<2>(t) << ' ' << get<0>(t) << endl;
}
