#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
using namespace std;

long long h0(long long x1, long long y1, long long h1, long long x0, long long y0) {
    return h1 + max(abs(x0 - x1), abs(y0 - y1));
}

int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    long long n;
    cin >> n ;
    vector<long long> x(n), y(n), h(n);
    for (long long i = 0; i < n; ++i) {
        cin >> x[i] >> y[i] >> h[i];
    }

    long long l = -100000000, r = 100000000, b = -100000000, t = 100000000;

    long long cur_x = 0, cur_y = 0;
    long long max_h_l, max_h_r, max_h_b, max_h_t, cur_h;
    bool save_x = false, save_y = false;
    while ((r - l > 1 || t - b > 1) && (save_x == false || save_y == false)) {
        save_x = false, save_y = false;
//        cout << l << " " << r << " " << b << " " << t << endl;
        max_h_l = 0, max_h_r = 0, max_h_b = 0, max_h_t = 0;
        cur_x = l + (r - l) / 2;
        cur_y = b + (t - b) / 2;

        for (long long i = 0; i < n; ++i) {
            cur_h = h0(x[i], y[i], h[i], cur_x, cur_y);
            if (x[i] < cur_x) {
                if (max_h_l < cur_h) {
                    max_h_l = cur_h;
                }
            }
            if (x[i] > cur_x) {
                if (max_h_r < cur_h) {
                    max_h_r = cur_h;
                }
            }
            if (y[i] < cur_y) {
                if (max_h_b < cur_h) {
                    max_h_b = cur_h;
                }
            }
            if (y[i] > cur_y) {
                if (max_h_t < cur_h) {
                    max_h_t = cur_h;
                }
            }
        }

        if (max_h_t > max_h_b) {
            b = cur_y;
        } else if (max_h_t < max_h_b) {
            t = cur_y;
        } else {
            save_y = true;
        }
        if (max_h_r > max_h_l) {
            l = cur_x;
        } else if (max_h_r < max_h_l) {
            r = cur_x;
        } else {
            save_x = true;
        }
    }
    if (save_x) {
        l = cur_x;
        r = cur_x;
    }
    if (save_y) {
        b = cur_y;
        t = cur_y;
    }

    long long min_max_h = 4000000000, ans_x, ans_y;
    for (cur_x = l - 1; cur_x <= r + 1; ++cur_x) {
        for (cur_y = b - 1; cur_y <= t + 1; ++cur_y) {
            long long max_h = 0;
            for (long long i = 0; i < n; ++i) {
                cur_h = h0(x[i], y[i], h[i], cur_x, cur_y);
                if (max_h < cur_h) {
                    max_h = cur_h;
                }
            }
            if (min_max_h > max_h) {
                min_max_h = max_h;
                ans_x = cur_x;
                ans_y = cur_y;
            }
        }
    }

    cout << ans_x << " " << ans_y << " " << min_max_h << endl;

    return 0;
}