#include <bits/stdc++.h>

using namespace std;
#define pt pair <int, int>
#define ff first
#define ss second
#define mp make_pair
#define pb push_back

bool in(int u, int d, int l, int r, int i, int j) {
    return l < j && j < r && u < i && i < d;
}

int area(int u, int d, int l, int r) {
    return (d - u - 1) * (r - l - 1);
}

char norm(char c) {
    if ('a' <= c && c <= 'z') return c;
    return 'a' + (c - 'A');
}

int main()
{
    ios_base::sync_with_stdio(0);
    int n, m;
    cin >> n >> m;
    vector <string> f(n);
    for (int i = 0; i < n; ++i)
        cin >> f[i];

    /// get point coordinates
    map <char, pt> get;

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (f[i][j] != '.') get[f[i][j]] = mp(i, j);
        }
    }

    int ai = get['A'].ff, aj = get['A'].ss;

    /// find max rectangle

    vector <int> up(1, -1);
    vector <int> down(1, n);
    vector <int> left(1, -1);
    vector <int> right(1, m);

    for (auto p : get) {
        if (ai >= p.ss.ff) up.pb(p.ss.ff);
        else down.pb(p.ss.ff);
        if (aj >= p.ss.ss) left.pb(p.ss.ss);
        else  right.pb(p.ss.ss);
    }

    int mu = 0, md = 0, ml = 1, mr = 1;
    for (auto uu : up) {
        for (auto dd : down) {
            for (auto ll : left) {
                for (auto rr : right) {
                    bool is_ok = true;
                    for (auto p : get) {
                        if ((p.ff == 'A') !=
                                   in(uu, dd, ll, rr, p.ss.ff, p.ss.ss)) {
                                       is_ok = false; break;
                                   }
                    }
                    if (is_ok && area(uu, dd, ll, rr) > area(mu, md, ml, mr)) {
                        mu = uu; md = dd; ml = ll; mr = rr;
                    }
                }
            }
        }
    }
    mu++; md--; ml++; mr--;

    /// color it

    for (int i = mu; i <= md; ++i) {
        for (int j = ml; j <= mr; ++j) {
            if (f[i][j] == '.') f[i][j] = 'a';
        }
    }

    /// recursive solving

    for (int j = mr + 1; j < m; ++j) {
        char is_col = 0;
        for (int i = mu; !is_col && i <= md; ++i) {
            if (f[i][j] != '.') is_col = f[i][j];
        }
        if (is_col) {
            for (int i = mu; i <= md; ++i) {
                char sss = f[i][j];
                f[i][j] = (f[i][j] != '.') ? f[i][j] : norm(is_col);
                if (sss != '.') is_col = sss;
            }
        }
        else {
             for (int i = mu; i <= md; ++i) f[i][j] = norm(f[i][j - 1]);
        }
    }

    for (int j = ml - 1; j >= 0; --j) {
        char is_col = 0;
        for (int i = mu; !is_col && i <= md; ++i) {
            if (f[i][j] != '.') is_col = f[i][j];
        }
        if (is_col) {
            for (int i = mu; i <= md; ++i) {
                char sss = f[i][j];
                f[i][j] = (f[i][j] != '.') ? f[i][j] : norm(is_col);
                if (sss != '.') is_col = sss;
            }
        }
        else {
             for (int i = mu; i <= md; ++i) f[i][j] = norm(f[i][j + 1]);
        }
    }

    for (int i = md + 1; i < n; ++i) {
        char is_col = 0;
        for (int j = 0; !is_col && j < m; ++j) {
            if (f[i][j] != '.') is_col = f[i][j];
        }
        if (is_col) {
            for (int j = 0; j < m; ++j) {
                char sss = f[i][j];
                f[i][j] = (f[i][j] != '.') ? f[i][j] : norm(is_col);
                if (sss != '.') is_col = sss;
            }
        }
        else {
             for (int j = 0; j < m; ++j) f[i][j] = norm(f[i - 1][j]);
        }
    }

    for (int i = mu - 1; i >= 0; --i) {
        char is_col = 0;
        for (int j = 0; !is_col && j < m; ++j) {
            if (f[i][j] != '.') is_col = f[i][j];
        }
        if (is_col) {
            for (int j = 0; j < m; ++j) {
                char sss = f[i][j];
                f[i][j] = (f[i][j] != '.') ? f[i][j] : norm(is_col);
                if (sss != '.') is_col = sss;
            }
        }
        else {
             for (int j = 0; j < m; ++j) f[i][j] = norm(f[i + 1][j]);
        }
    }


    for (int i = 0; i < n; ++i) {
        cout << f[i] << '\n';

    }

}


/*
6 8
........
......Q.
...A....
........
........
........
*/
