#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const int mod = 998244353;

template<class T>
T sqr(T x)
{
	return x * x;
}

ll powmod(ll x, ll y)
{
	return y ? (y & 1 ? x * powmod(x, y - 1) : sqr(powmod(x, y / 2))) % mod : 1;
}

ll h(int k, int t)
{
	return powmod(k, (t + 1) / 2);
}

vector<int> den(int n)
{
	vector<int> ret;

	if (n < 2)
		return ret;

	for (int i = 1; i * i <= n; i++)
		if (n % i == 0)
		{
			ret.push_back(i);

			if (i != 1 && i * i != n)
				ret.push_back(n / i);
		}

	return ret;
}

int mu(int n)
{
	static vector<int> dp = {0, 1};

	if (n >= dp.size())
	{
		mu(n - 1);

		for (int i = 2; i * i <= n; i++)
			if (n % i == 0)
			{
				if (n % (i * i) == 0)
					dp.push_back(0);
				else
					dp.push_back(-mu(n / i));

				return dp.back();
			}

		dp.push_back(-1);
	}

	return dp[n];
}

ll g(int k, int t)
{
	static vector<int> dp = {0, k};

	if (t >= dp.size())
	{
		g(k, t - 1);

		ll ans = h(k, t);

		for (auto d : den(t))
		{
			ans -= g(k, d);
			ans %= mod;
		}

		ans %= mod;
		if (ans < 0)
			ans += mod;

		dp.push_back(ans);
	}

	return dp[t];
}

int f(int n, int k, int t)
{
	static vector<int> dp = {0};

	if (t >= dp.size())
	{
		f(n, k, t - 1);
		dp.push_back(0);

		for (int i = 1; i <= n / t; i++)
			dp.back() += g(k, i);
	}

	return dp[t];
}


int p(int k, int t)
{
	auto m = t / 2;

	if (t % 2 == 0)
		return ((m + 1) * powmod(k, m) + m * powmod(k, m + 1)) % mod;
	return (t + 1) * powmod(k, m + 1) % mod;
}


int e(int k, int t)
{
	static vector<int> dp = {0, 0};

	if (t >= dp.size())
	{
		e(k, t - 1);

		ll ans = p(k, t);

		for (auto d : den(t))
		{
			ans -= (t / d + 1ll) * g(k, d);
			ans -= e(k, d) * (ll) (t / d);

			ans %= mod;
		}
		ans -= 2 * g(k, t);

		ans %= mod;
		if (ans < 0)
			ans += mod;

		dp.push_back(ans);
	}

	return dp[t];
}


int foo(int k, int t)
{
	static vector<int> dp = {0};

	if (t >= dp.size())
	{
		foo(k, t - 1);

		ll ans = e(k, t);

		for (auto d : den(t))
		{
			ans += g(k, d);
			ans += e(k, d);

			ans %= mod;
		}

		ans += g(k, t);
		ans %= mod;
		if (ans < 0)
			ans += mod;

		dp.push_back(ans);
	}

	return dp[t];
}


void solve(istream &cin = std::cin, ostream &cout = std::cout)
{
	int n, k;

	cin >> n >> k;

	ll ans = 0;

	for (int i = 1; i <= n; i++)
	{
		ans += foo(k, i);

		ans %= mod;
		if (ans < 0)
			ans += mod;
	}

	cout << ans << endl;

#ifdef LOCAL
	cout << n << ' ' << k << endl;


	cout << "h ";
	for (int i = 1; i <= n; i++)
		cout << h(k, i) << ' ';
	cout << endl;
	cout << "p ";
	for (int i = 1; i <= n; i++)
		cout << p(k, i) << ' ';
	cout << endl;
	cout << "g ";
	for (int i = 1; i <= n; i++)
		cout << g(k, i) << ' ';
	cout << endl;
	for (int i = 1; i <= n; i++)
		cout << f(n, k, i) << ' ';
	cout << endl;
	for (int i = 1; i <= n; i++)
		cout << e(k, i) << ' ';
	cout << endl;
	for (int i = 1; i <= n; i++)
		cout << foo(k, i) << ' ';
	cout << endl;
#endif
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

#ifdef LOCAL
	time_t st = clock();

	ifstream fin("../input.txt");

	solve(fin);

	cout << "clock: " << (clock() - st) / (double) CLOCKS_PER_SEC << endl;
#else
	solve();
#endif
	return 0;
}
