#include <bits/stdc++.h>

using namespace std;

using ll = long long;

vector<int> bfs (int s, const vector<vector<int>> &g)
{
	const int n = int(g.size());

	queue<int> q;
	vector<int> dist(n, -1);

	dist[s] = 0;
	q.push(s);

	while (!q.empty())
	{
		const int cur = q.front(); q.pop();

		for (int dest : g[cur])
		{
			if (dist[dest] == -1)
			{
				dist[dest] = dist[cur] + 1;
				q.push(dest);
			}
		}
	}

	return dist;
}

void solve(istream &cin = std::cin, ostream &cout = std::cout)
{
	int n, m;
	cin >> n >> m;

	vector<vector<int>> g(n);

	for (int i = 0; i < n - 1; i++)
	{
		int x, y;
		cin >> x >> y;
		--x, --y;
		g[x].push_back(y);
		g[y].push_back(x);
	}

	vector<int> teams(m);
	for (auto &x : teams)
	{
		cin >> x;
		--x;
	}

	int ans = -1;

	if (m == 1)
		ans = teams[0];
	else
	{
		assert(teams[0] != teams[1]);

		auto d0 = bfs(teams[0], g);
		auto d1 = bfs(teams[1], g);

		for (int i = 0; i < n; i++)
		{
			if (d0[i] == d1[i])
			{
				assert(ans == -1);
				ans = i;
			}
		}

		if (ans != -1)
		{
			auto center = bfs(ans, g);
			bool ok = true;
			for (auto x : teams)
				ok &= (center[x] == d0[ans]);

			if (!ok)
				ans = -1;
		}
	}

	if (ans != -1)
	{
		cout << "YES" << endl;
		cout << ans + 1 << endl;
	}
	else
		cout << "NO" << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

#ifdef LOCAL
	time_t st = clock();

	ifstream fin("../input.txt");

	solve(fin);

	cout << "clock: " << (clock() - st) / (double) CLOCKS_PER_SEC << endl;
#else
	solve();
#endif
	return 0;
}
