#include <bits/stdc++.h>

using namespace std;

using ll = long long;

vector<int> bfs (const vector<int> &starts, const vector<vector<int>> &g)
{
	const int n = int(g.size());

	queue<int> q;
	vector<int> dist(n, -1);
	vector<int> cnt(n);

	for (int s : starts)
	{
		dist[s] = 0;
		cnt[s] = 1;
		q.push(s);
	}

	while (!q.empty())
	{
		const int cur = q.front(); q.pop();

		for (int dest : g[cur])
		{
			if (dist[dest] == -1)
			{
				dist[dest] = dist[cur] + 1;
				cnt[dest] = cnt[cur];
				q.push(dest);
			}
			else if (dist[dest] == dist[cur] + 1)
				cnt[dest] += cnt[cur];
		}
	}

	return cnt;
}

void solve(istream &cin = std::cin, ostream &cout = std::cout)
{
	int n, m;
	cin >> n >> m;

	vector<vector<int>> g(n);

	for (int i = 0; i < n - 1; i++)
	{
		int x, y;
		cin >> x >> y;
		--x, --y;
		g[x].push_back(y);
		g[y].push_back(x);
	}

	vector<int> teams(m);
	for (auto &x : teams)
	{
		cin >> x;
		--x;
	}

	vector<int> cnt = bfs(teams, g);

	int ans = find(cnt.begin(), cnt.end(), m) - cnt.begin();
	if (ans == n)
		ans = -1;

	if (ans != -1)
	{
		cout << "YES" << endl;
		cout << ans + 1 << endl;
	}
	else
		cout << "NO" << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

#ifdef LOCAL
	time_t st = clock();

	ifstream fin("../input.txt");

	solve(fin);

	cout << "clock: " << (clock() - st) / (double) CLOCKS_PER_SEC << endl;
#else
	solve();
#endif
	return 0;
}
