#include <iostream>
#include <vector>
#include <cmath>
#include <set>

using namespace std;

int n;
vector<vector<int>> a;
vector<bool> colored;
vector<int> depth;
vector<int> c;
vector<vector<int>> jump;
int max_jump = (int) log2(200001) + 3;

void dfs(int u, int d, int pr) {
    jump[u][0] = pr;
    depth[u] = d;
    for (auto v : a[u]) {
        if (v != pr) {
            dfs(v, d + 1, u);
        }
    }
}

int lca(int u, int v) {
    while (jump[u][0] != jump[v][0]) {
        int i = 0;
        while (jump[u][i] != jump[v][i]) {
            i++;
        }
        u = jump[u][i - 1];
        v = jump[v][i - 1];
    }
    return jump[u][0];
}

int jmp(int u, int len) {
    if (len == 0) {
        return u;
    } else {
        int i = 0;
        while (depth[jump[u][i]] + len >= depth[u]) {
            i++;
        }
        return jmp(jump[u][i - 1], len - (depth[u] - depth[jump[u][i - 1]]));
    }
}

int main() {
    int m;
    cin >> n >> m;
    a.resize(n);
    depth.resize(n);
    jump.resize(n, vector<int>(max_jump));
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        a[u - 1].push_back(v - 1);
        a[v - 1].push_back(u - 1);
    }
    colored.resize(n, false);
    int s = 0;
    for (int i = 0; i < m; i++) {
        int u;
        cin >> u;
        colored[u - 1] = true;
        if (i == 0) {
            s = u - 1;
        } else {
            c.push_back(u - 1);
        }
    }
    m--;
    dfs(s, 0, -1);
    int d = depth[c[0]];
    for (int i = 1; i < m; i++) {
        if (d != depth[c[i]]) {
            cout << "NO";
            return 0;
        }
    }
    if (d % 2 == 1) {
        cout << "NO";
        return 0;
    }
    for (int i = 0; i < n; i++) {
        for (int j = 1; j < max_jump; j++) {
            if (jump[i][j - 1] != -1) {
                jump[i][j] = jump[jump[i][j - 1]][j - 1];
            } else {
                jump[i][j] = -1;
            }
        }
    }
    set<int> ans;
    for (int k = 1; k < m; k *= 2) {
        for (int i = pow(2, k) - 1; i < m; i += pow(2, k)) {
            int u = lca(c[i], c[i - pow(2, k - 1)]);
            if (depth[u] * 2 < d) {
                cout << "NO";
                return 0;
            } else {
                u = jmp(u, depth[u] - d / 2);
                ans.insert(u);
            }
        }
    }
    if (m % 2 == 1) {
        int u = jmp(c[m - 1], depth[c[m - 1]] - d / 2);
        ans.insert(u);
    }
    if (ans.size() == 1) {
        cout << "YES\n";
        for (auto i : ans) {
            cout << i + 1;
        }
    } else {
        cout << "NO";
        return 0;
    }
    return 0;
}