#include <iostream>
#include <vector>
#include <cmath>
#include <set>

using namespace std;

int n;
vector<vector<int>> a;
vector<bool> colored;
vector<int> depth;
vector<int> c;
int max_len = -1;
pair<int, int> max_path;

int dfs(int u, int d, int pr) {
    depth[u] = d;
    int mx1 = -1;
    int mx2 = -1;
    int v1 = -1;
    int v2 = -1;
    if (colored[u]) {
        v1 = u;
        mx1 = d;
    }
    for (auto v : a[u]) {
        if (v != pr) {
            auto w = dfs(v, d + 1, u);
            if (w != -1) {
                if (depth[w] >= mx1) {
                    v2 = v1;
                    mx2 = mx1;
                    v1 = w;
                    mx1 = depth[v1];
                } else if (depth[w] > mx2) {
                    mx2 = depth[w];
                    v2 = w;
                }
            }
        }
    }
    if (v2 == -1 && v1 == -1) {
        return -1;
    }
    if (v2 == -1) {
        return v1;
    }
    int len = depth[v1] + depth[v2] - 2 * depth[u];
    if (len > max_len) {
        max_path = make_pair(v1, v2);
        max_len = len;
    }
    return v1;
}

int ans;

bool dfs1(int u, int d, int pr) {
    bool flag = false;
    if (u == max_path.second) {
        flag = true;
    }
    for (auto v : a[u]) {
        if (v != pr) {
            if (dfs1(v, d + 1, u)) {
                flag = true;
            }
        }
    }
    if (flag && d * 2 == max_len) {
        ans = u;
    }
    return flag;
}

vector<int> dep;

void dfs2(int u, int d, int pr) {
    dep[u] = d;
    for (auto v : a[u]) {
        if (v != pr) {
            dfs2(v, d + 1, u);
        }
    }
}


int main() {
    int m;
    cin >> n >> m;
    a.resize(n);
    depth.resize(n);
    dep.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        a[u - 1].push_back(v - 1);
        a[v - 1].push_back(u - 1);
    }
    colored.resize(n, false);
    int s = 0;
    for (int i = 0; i < m; i++) {
        int u;
        cin >> u;
        colored[u - 1] = true;
        c.push_back(u - 1);
    }
    if (m == 1) {
        cout << "YES\n" << c[0] + 1;
        return 0;
    }
    dfs(s, 0, -1);
    if (max_len % 2 == 1) {
        cout << "NO";
        return 0;
    }
    dfs1(max_path.first, 0, -1);
    dfs2(ans, 0, -1);
    int q;
    q = dep[c[0]];
    for (int i = 1; i < m; i++) {
        if (dep[c[i]] != q) {
            cout << "NO";
            return 0;
        }
    }
    cout << "YES\n" << ans + 1;
    return 0;
}