#include <iostream>
#include <vector>
#include <cmath>
#include <set>
#include <algorithm>

using namespace std;

//struct point {
//    int64_t x, y;
//
//    point(int64_t w, int64_t h) : x(w), y(h) {}
//
//    point() : x(-1), y(-1) {}
//};

struct obelisk {
    int64_t x, y, h;

    obelisk(int64_t x, int64_t y, int64_t h) : x(x), y(y), h(h) {}
};

struct event {
    int64_t x;
    bool open;

    event(int64_t x, bool open) : x(x), open(open) {}
};

bool operator<(event &a, event &b) {
    if (a.x < b.x) return true;
    if (a.x > b.x) return false;
    return (a.open && !b.open);
}

size_t n;
int64_t l, r;
vector<obelisk> a;
int64_t a_x, a_y;

bool test(int64_t m) {
    vector<event> c_x;
    vector<event> c_y;
    size_t opened;

    c_x.reserve(n * 2);
    for (auto p : a) {
        c_x.emplace_back(p.x - (m - p.h), true);
        c_x.emplace_back(p.x + (m - p.h), false);
    }

    sort(c_x.begin(), c_x.end());
    opened = 0;
    for (auto e : c_x) {
        if (e.open) {
            ++opened;
            if (opened == n) {
                a_x = e.x;
            }
        } else {
            if (opened < n) {
                return false;
            }
        }
    }

    c_y.reserve(n * 2);
    for (auto p : a) {
        c_y.emplace_back(p.y - (m - p.h), true);
        c_x.emplace_back(p.y + (m - p.h), false);
    }

    sort(c_y.begin(), c_y.end());
    opened = 0;
    for (auto e : c_y) {
        if (e.open) {
            ++opened;
            if (opened == n) {
                a_y = e.x;
            }
        } else {
            if (opened < n) {
                return false;
            }
        }
    }

    return true;
}

int main() {
    cin >> n;

    l = 0;
    r = 1000000001;

    for (size_t i = 0; i < n; ++i) {
        int64_t x, y, h;
        cin >> x >> y >> h;
        a.emplace_back(x, y, h);
        l = max(l, h);
    }
    --l;

    while (r - l > 1) {
        int64_t m = (r + l) / 2;
        if (test(m)) {
            r = m;
        } else {
            l = m;
        }
    }

    cout << a_x << " " << a_y << " " << r << '\n';
}