#include <iostream>
#include<algorithm>
#include<vector>
#include<set>
#include<map>
#include<unordered_map>
using namespace std;
int used[200001];
int dist[200001];
int p[200001];
vector <vector <int> > g;
int n, m;
int teams[200001];
int good[200001];

void clear_used()
{
	for (int i = 0; i < n; i++) {
		used[i] = 0;
		dist[i] = 0;
	}
}

void dfs_graph_clear(int v)
{
	used[v] = 1;
	for (int i = 0; i < g[v].size(); i++)
	{
		int u = g[v][i];
		if (used[u] == 0) {
			dfs_graph_clear(u);
			if (good[u])
				good[v] = 1;
		}
	}
}


void dfs_is_ok(int v, int d)
{
	used[v] = 1;
	dist[v] = d;
	for (int i = 0; i < g[v].size(); i++)
	{
		int u = g[v][i];
		if (used[u] == 0) {
			dfs_is_ok(u, d + 1);
		}
	}
}


void dfs_f_dist(int v, int d)
{
	used[v] = 1;
	dist[v] = d;
	for (int i = 0; i < g[v].size(); i++)
	{
		int u = g[v][i];
		if (used[u] == 0) {
			p[u] = v;
			dfs_f_dist(u, d + 1);
		}
	}
}

vector <vector <int> > fix_g()
{
	vector <vector <int> > g1 = {};
	g1.resize(n);
	for (int i = 0; i < n; i++)
	{
		if (good[i]) 
		{
			for (int j = 0; j < g[i].size(); j++)
			{
				if (good[g[i][j]])
					g1[i].push_back(g[i][j]);
			}
		}
	}
	return g1;
}

int main()
{
	ios::ios_base::sync_with_stdio();
	cin.tie(0); cout.tie(0);

	
	cin >> n >> m;
	g.resize(n);
	for (int i = 0; i < n - 1; i++)
	{
		int x, y;
		cin >> x >> y;
		x--;
		y--;
		g[x].push_back(y);
		g[y].push_back(x);
	}
	int team0 = -1;

	for (int i = 0; i < m; i++)
	{
		int x;
		cin >> x;
		x--;
		team0 = x;
		teams[x] = 1;
		good[x] = 1;
	}
	if (m == 1)
	{
		cout << "YES" << endl;
		cout << team0 + 1;
		return 0;
	}
	dfs_graph_clear(team0);
	clear_used();
	g = fix_g();

	/*for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < g[i].size(); j++)
			cout << g[i][j] << ' ';
		cout << endl;
	}*/

	bool isleafs = true;
	int badv = -1;
	for (int i = 0; i < n; i++)
	{
		if (teams[i] == 1 && g[i].size() > 1) {
			isleafs = false;
			badv = i;
		}
	}

	if (isleafs == false)
	{
		clear_used();
		dfs_is_ok(badv, 0);
		bool flag = true;
		set <int> dists = {};
		for (int i = 0; i < n; i++)
		{
			if  (teams[i] == 1)
				dists.insert(dist[i]);
		}
		if (dists.size() >= 2)
		{
			cout << "NO";
			return 0;
		}
		else
		{
			cout << "YES" << endl;
			cout << badv + 1;
			return 0;
		}
	}
	else
	{
		clear_used();
		dfs_f_dist(team0, 0);
		int maxd = -1;
		int maxpos = -1;
		for (int i = 0; i < n; i++)
		{
			if (i != team0 && dist[i] > maxd && teams[i] == 1)
			{
				if (dist[i] > maxd)
				{
					maxd = dist[i];
					maxpos = i;
				}
			}
		}
		/*for (int i = 0; i < n; i++)
			cout << p[i] << ' ';
		cout << endl;*/
		if (maxd % 2 == 1)
		{
			cout << "NO";
			return 0;
		}
		else
		{
			//cout << "aaaa" << maxpos << ' ' << maxd << endl;
			for (int i = 0; i < maxd / 2; i++) {
				maxpos = p[maxpos];
				//cout << maxpos << endl;
			}
			clear_used();
			dfs_is_ok(maxpos, 0);
			bool flag = true;
			set <int> dists = {};
			for (int i = 0; i < n; i++)
			{
				if ( teams[i] == 1)
					dists.insert(dist[i]);
			}
			if (dists.size() >= 2)
			{

				cout << "NO";
				//cout << maxpos << endl;
				return 0;
			}
			else
			{
				cout << "YES" << endl;
				cout << maxpos + 1;
				return 0;
			}

		}

	}





}
