#include <iostream>
#include <vector>
using namespace std;

vector <vector <int> > g;
vector <int> dist;

void dfs(int v) {
    for (int u : g[v]) {
        if (dist[u] > dist[v]) {
            dist[u] = dist[v] + 1;
            dfs(u);
        }
    }
}

int main() {
    int n, m;
    cin >> n >> m;
    g.resize(n + 1);

    for (int i = 1; i < n; i++) {
        int v, u;
        cin >> v >> u;
        g[v].push_back(u);
        g[u].push_back(v);
    }

    int c[m];
    for (int i = 0; i < m; i++) {
        cin >> c[i];
    }

    int city = -1;
    for (int i = 1; i <= n; i++) {
        dist.assign(n + 1, 1000000);
        dist[i] = 0;
        dfs(i);
        int cur = dist[c[0]];
        bool f = true;
        for (int i = 0; i < m && f; i++)
            if (dist[c[i]] != cur) {
                f = false;
            }
        if (f) {
            city = i;
            break;
        }
    }

    if (city == -1) cout << "NO";
    else cout << "YES\n" << city;
}

/*
6 3
1 2
2 3
3 4
4 5
4 6
1 5 6
 */