#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

const int MAX = 100000000;

struct obelisk {
    int x, y, h;
};
vector <obelisk> obels;

double dist(double x, double y, obelisk ob) {
    return max(abs(x - ob.x), abs(y - ob.y)) + ob.h;
}

double countHeight(double x, double y) {
    double hei = 0;
    for (auto i : obels) {
        hei = max(hei, dist(x, y, i));
    }
    return hei;
};

pair <double, double> ternY(double x) {
    double a = -MAX;
    double b = MAX;
    while (b - a > 0.0001) {
        double tri = (b - a) / 3;
        double m1 = a + tri;
        double m2 = b - tri;
        double tmp1 = countHeight(x, m1);
        double tmp2 = countHeight(x, m2);
        if (tmp1 < tmp2)
            b = m2;
        else a = m1;
    }
    return {a, countHeight(x, a)};
}

pair <double, double> ternX() {
    double a = -MAX;
    double b = MAX;
    while (b - a > 0.0001) {
        double tri = (b - a) / 3;
        double m1 = a + tri;
        double m2 = b - tri;

        if (ternY(m1).second < ternY(m2).second)
            b = m2;
        else a = m1;
    }
    return {a, ternY(a).first};
}

int main() {
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        int x, y, h;
        cin >> x >> y >> h;
        obels.push_back({x, y, h});
    }
    auto p = ternX();

    pair <double, pair <int, int> > ans[4];

    ans[0] = {countHeight(floor(p.first), floor(p.second)), {floor(p.first), floor(p.second)}};
    ans[1] = {countHeight(floor(p.first), ceil(p.second)), {floor(p.first), ceil(p.second)}};
    ans[2] = {countHeight(ceil(p.first), floor(p.second)), {ceil(p.first), floor(p.second)}};
    ans[3] = {countHeight(ceil(p.first), ceil(p.second)), {ceil(p.first), ceil(p.second)}};

    sort(ans, ans + 4);
    cout << ans[0].second.first << " " << ans[0].second.second << " " << (int)ceil(ans[0].first);



}