#include <bits/stdc++.h>
#define ff first
#define ss second
#define bend(x) (x).begin(), (x).end()
#define szof(x) ((int) (x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;

template <typename T>
T input() {
    T res;
    cin >> res;
    return res;
}

template <typename T>
void input_seq(T a, T b) {
    std::generate(a, b, input<typename std::remove_reference<decltype(*a)>::type>);
}

#define SZ(A) int((A).size())
#define ALL(A) bend(A)
#define TYPEMAX(A) std::numeric_limits<A>::max()
#define TYPEMIN(A) std::numeric_limits<A>::min()

int dx[8] = {1, 1, 1, 0, -1, -1, -1, 0};
int dy[8] = {-1, 0, 1, 1, 1, 0, -1, -1};

void solve() {
	int w, h;
	cin >> w >> h;
	vector<vector<int>> field(h, vector<int>(w));
	for (int i = 0; i < h; ++i) {
		string s;
		cin >> s;
		for (int j = 0; j < w; ++j) {
			field[i][j] = s[j] == 'X';
		}
	
	}
	
	vector<vector<bool>> used(h, vector<bool>(w));
	list<pii> path;
	map<pii, pair<list<pii>::iterator, bool>> where;
	
	auto add_cell = [&](int x, int y) {
		vector<pii> cur = {{x, y}, {x + 1, y + 1}, {x + 1, y}, {x, y + 1}};
		for (int i = 0; i < 4; ++i) {
			if (where.count(cur[0])) {
				auto tmp = where[cur[0]];
				bool next = 1;
				if (abs(cur[0].ff - cur[1].ff) + abs(cur[0].ss - cur[1].ss) == 2) {
					 next = 0;
				}
				if (tmp.ss != next) {
					reverse(cur.begin() + 1, cur.end());
				}
				auto it = tmp.ff;
				for (int j = 0; j < 4; ++j) {
					auto pos = path.insert(it, cur[j]);
					where[cur[j]] = {pos, tmp.ss ^ (j & 1)};
				}
				break;
			}
			rotate(cur.begin(), cur.begin() + 1, cur.end());
		}
	};
	
	function<void(int, int)> dfs = [&](int x, int y) {
		add_cell(x, y);
		used[x][y] = true;
		for (int d = 0; d < 8; ++d) {
			int nx = x + dx[d];
			int ny = y + dy[d];
			if (0 <= nx && nx < h && 0 <= ny && ny < w && field[nx][ny] && !used[nx][ny]) {
				dfs(nx, ny);
			}
		}
	};
	
	for (int i = 0; i < h; ++i) {
		for (int j = 0; j < w; ++j) {
			if (field[i][j] && !used[i][j]) {
				where[{i, j}] = {path.begin(), 0};
				dfs(i, j);
			}
		}
	}
	
	vector<pii> ans;
	for (auto p : path) {
		ans.push_back(p);
	}
	
	cout << szof(ans) - 1 << "\n";
	
	for (auto p : ans) {
		cout << p.ss << " " << p.ff << "\n";
	}
}


int main() {
	cin.tie(0);
	cout.tie(0);
	ios::sync_with_stdio(false);
	int test_count = 1;
	//cin >> test_count;
	for (int i = 0; i < test_count; i++) {
		solve();
	}
#ifdef LOCAL
	cerr << "time: " << clock() * 1000 / CLOCKS_PER_SEC << endl;
#endif
	return 0;
}
