#include <bits/stdc++.h>
#define ff first
#define ss second
#define bend(x) (x).begin(), (x).end()
#define szof(x) ((int) (x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;

template <typename T>
T input() {
    T res;
    cin >> res;
    return res;
}

template <typename T>
void input_seq(T a, T b) {
    std::generate(a, b, input<typename std::remove_reference<decltype(*a)>::type>);
}

#define SZ(A) int((A).size())
#define ALL(A) bend(A)
#define TYPEMAX(A) std::numeric_limits<A>::max()
#define TYPEMIN(A) std::numeric_limits<A>::min()

const ll INFL = 1e18 + 1e6;

ll smart_calc(int a, int b, int l, int p) {
	assert(b < a && l < a && p < a && 0 < b && 0 <= l && 0 <= p && 0 < a);
	if (p < l) {
		return 0;
	}
	int d = (a - p + b - 1) / b;
	int np = (p + d * b) % a;
	if (np < l) {
		return d;
	}
	return d + smart_calc(b, a % b, l, l + b - 1 - np) * (a / b);
}

ll calc_steps(int a, int b, int p, int l, int r) {
	p %= a;
	if (l <= p && p <= r) {
		return 0;
	}
	l = l - p + a;
	r = r - p + a;
	p = a;
	int g = __gcd(a, b);
	l = (l + g - 1) / g;
	r = r / g;
	if (l > r) {
		return -1;	
	}
	a /= g;
	b /= g;
	int q = (r - l + 1);
	int pos = ((a - l) % a + a) % a;
	ll ret = 0;
	b %= a;
	if (b == 0) {
		return -1;
	}
	/*
	while (pos >= q) {
		pos = (pos + b) % a;
		++ret;
	}
	*/
	ret = smart_calc(a, b, q, pos);
	return ret;
}

void solve() {
	int w, h;
	cin >> w >> h;
	int n;
	cin >> n;
	vector<pii> poly;
	for (int i = 0; i < n; ++i) {
		int x, y;
		cin >> x >> y;
		poly.push_back({x, y});
	}
	
	vector<pair<pii, pii>> segs;
	
	for (int i = 0; i < n; ++i) {
		int next = (i + 1) % n;
		pii p1 = poly[i];
		pii p2 = poly[next];
		segs.push_back({p1, p2});
		p1.ff = w * 2 - p1.ff;
		p2.ff = w * 2 - p2.ff;
		segs.push_back({p1, p2});
		p1.ss = h * 2 - p1.ss;
		p2.ss = h * 2 - p2.ss;
		segs.push_back({p1, p2});
		p1.ff = w * 2 - p1.ff;
		p2.ff = w * 2 - p2.ff;
		segs.push_back({p1, p2});
	}
	
	for (auto& s : segs) {
		if (s.ff.ff > s.ss.ff || s.ff.ss > s.ss.ss) {
			swap(s.ff, s.ss);
		}
	}
	
	int t;
	cin >> t;
	for (int i = 0; i < t; ++i) {
		int x, y;
		cin >> x >> y;
		ll d = INFL;
		for (auto s : segs) {
			if (s.ff.ff == s.ss.ff) {
				int cx = s.ff.ff;
				if (cx < x) {
					cx += w * 2;
				}
   				int dd = cx - x;
   				int ny = y + dd;
   				ll res = calc_steps(h * 2, w * 2, ny, s.ff.ss, s.ss.ss);
   				//cerr << s.ff.ff << " " << s.ff.ss << " " << s.ss.ff << " " << s.ss.ss << " " << res << endl;
   				if (res != -1) {
    				ll steps = res * w * 2 + dd;
    				d = min(d, steps);
   				}
			} else {
				int cy = s.ff.ss;
				if (cy < y) {
					cy += h * 2;
				}
				int dd = cy - y;
				int nx = x + dd;
				ll res = calc_steps(w * 2, h * 2, nx, s.ff.ff, s.ss.ff);
   				//cerr << s.ff.ff << " " << s.ff.ss << " " << s.ss.ff << " " << s.ss.ss << " " << res << endl;
				if (res != -1) {
    				ll steps = res * h * 2 + dd;
    				d = min(d, steps);
				}
			}
		}
		
		if (d == INFL) {
			cout << "-1\n";
		} else {
			ll rx = x + d;
			ll ry = y + d;
			rx %= w * 2;
			ry %= h * 2;
			if (rx > w) {
				rx = w * 2 - rx;
			}
			if (ry > h) {
				ry = h * 2 - ry;
			}
			cout << d << " " << rx << " " << ry << "\n";
		}
	}
}


int main() {
	cin.tie(0);
	cout.tie(0);
	ios::sync_with_stdio(false);
	int test_count = 1;
	//cin >> test_count;
	for (int i = 0; i < test_count; i++) {
		solve();
	}
#ifdef LOCAL
	cerr << "time: " << clock() * 1000 / CLOCKS_PER_SEC << endl;
#endif
	return 0;
}
