#include <bits/stdc++.h>
#define ff first
#define ss second
#define bend(x) (x).begin(), (x).end()
#define szof(x) ((int) (x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;

template <typename T>
T input() {
    T res;
    cin >> res;
    return res;
}

template <typename T>
void input_seq(T a, T b) {
    std::generate(a, b, input<typename std::remove_reference<decltype(*a)>::type>);
}

#define SZ(A) int((A).size())
#define ALL(A) bend(A)
#define TYPEMAX(A) std::numeric_limits<A>::max()
#define TYPEMIN(A) std::numeric_limits<A>::min()

string s;
vector<vector<int>> graph;
vector<int> edge_len;
vector<char> is_term;

struct the_set {
    set<int> suffixes;
    int closest = TYPEMAX(int) / 2;

    void add(int x) {
	auto it = suffixes.lower_bound(x);
	
	if (it != suffixes.end())
	    closest = min(closest, *it - x);
	if (it != suffixes.begin())
	    closest = min(closest, x - *std::prev(it));

	suffixes.insert(x);
    }
};

void merge(the_set& a, the_set& b) {
    if (not (a.suffixes.size() >= b.suffixes.size()))
	swap(a, b);

    for (int elem: b.suffixes)
	a.add(elem);
}

pair<int, int> best_ans = {1, 1};

void relax_ans(int common, int diff) {
    pair<int, int> ans = {common + diff, diff};
    int g = std::__gcd(ans.first, ans.second);
    ans.first /= g;
    ans.second /= g;

    if (ans.first * int64_t(best_ans.second) > best_ans.first *  int64_t(ans.second))
	best_ans = ans;
}

the_set dfs(int v, int cur_len = 0) {
    the_set st;
    for (int u: graph[v]) {
	auto rs = dfs(u, cur_len + edge_len[u]);

	merge(st, rs);
    }

    if (is_term[v])
	st.add(SZ(s) - cur_len);

    if (v != 0 and st.closest < TYPEMAX(int) / 2)
	relax_ans(cur_len, st.closest);

    return st;
}

vector<int> sufarr() {
    vector<int> arr(SZ(s));
    std::iota(ALL(arr), 0);

    std::sort(ALL(arr), [&](int i, int j) {
			    return s[i] < s[j];
			});

    vector<int> cls(SZ(s));
    for (int i = 1; i < SZ(arr); ++i)
	cls[arr[i]] = cls[arr[i - 1]] + int(s[arr[i - 1]] != s[arr[i]]);
    
    for (int k = 1; k < SZ(s); k *= 2) {	
	int numcls = cls[arr.back()] + 1;

	vector<int> cnt(numcls);
	for (int x: cls)
	    cnt[x] += 1;
	
	for (int i = 1; i < numcls; ++i)
	    cnt[i] += cnt[i - 1];
		
	for (int& elem: arr) {
	    elem -= k;
	    if (elem < 0)
		elem += SZ(s);
	}
	
	vector<int> newarr(SZ(s), -1);
	for (int i = SZ(arr) - 1; i >= 0; --i) {
	    int cc = cls[arr[i]];

	    newarr[--cnt[cc]] = arr[i];
	}

	vector<int> ncls(SZ(s));

	for (int i = 1; i < SZ(newarr); ++i) {
	    int A = newarr[i - 1];
	    int B = newarr[i];

	    ncls[B] = ncls[A] + int(cls[A] != cls[B]
        			    or cls[(A + k) % SZ(s)] != cls[(B + k) % SZ(s)]);
	}
	
	arr = std::move(newarr);
	cls = std::move(ncls);
    }
    
    return arr;
}

vector<int> get_lcp(const vector<int>& sarr) {
    vector<int> res(SZ(sarr) - 1);

    vector<int> where(SZ(s));
    for (int i = 0; i < SZ(s); ++i)
	where[sarr[i]] = i;
    
    int k = 0;
    
    for (int pos = 0; pos < SZ(s); ++pos) {
	k = max(0, k - 1);

	if (where[pos] == SZ(s) - 1)
	    continue;

	int next = sarr[where[pos] + 1];
	while (s[pos + k] == s[next + k])
	    ++k;

	res[where[pos]] = k;
    }

    return res;
}


void solve() {
    s = input<string>();

    s += '$';
    auto sarr = sufarr();
    sarr.erase(sarr.begin());
    s.pop_back();
    
    auto lcp = get_lcp(sarr);
    
#define stack stck___
    vector<int> stack = {0};
    int stack_len = 0;
    vector<int> par = {0};
    
    edge_len.resize(1);
    is_term.resize(1);

    for (int i = 0; i < SZ(sarr); ++i) {
	if (i) {
	    while (stack_len > lcp[i - 1]) {
		if (stack_len - edge_len[stack.back()] >= lcp[i - 1]) {
		    stack_len -= edge_len[stack.back()];
		    stack.pop_back();
		    continue;
		}
		
		int pv = stack[stack.size() - 2];
		int v = stack.back();
		int newv = SZ(par);
		int the_len = edge_len[v];
		int excess = stack_len - lcp[i - 1];
		
		par.push_back(-1);
		edge_len.push_back(-1);
		is_term.push_back(0);
		
		par[v] = newv;
		par[newv] = pv;
		
		edge_len[newv] = the_len - excess;
		edge_len[v] = excess;
		
		stack.pop_back();
		stack.push_back(newv);
		stack_len = lcp[i - 1];
	    }
	}
	
	int the_len = SZ(s) - sarr[i];
	if (stack_len < the_len) {
	    par.push_back(stack.back());
	    edge_len.push_back(the_len - stack_len);
	    is_term.push_back(0);

	    stack.push_back(SZ(par) - 1);
	    stack_len = the_len;
	}

	is_term[stack.back()] = 1;
    }

    
    graph.resize(SZ(par));
    for (int i = 1; i < SZ(par); ++i)
	graph[par[i]].push_back(i);
    dfs(0);

    cout << best_ans.first << "/" << best_ans.second << "\n";
}


int main() {
	cin.tie(0);
	cout.tie(0);
	ios::sync_with_stdio(false);
	int test_count = 1;
	//cin >> test_count;
	for (int i = 0; i < test_count; i++) {
		solve();
	}
#ifdef LOCAL
	cerr << "time: " << clock() * 1000 / CLOCKS_PER_SEC << endl;
#endif
	return 0;
}
