#include <bits/stdc++.h>

using namespace std;

vector<int> edge[200500];
bool good[200500];

pair<int, int> far(int u, int p, int d) {
    pair<int, int> ans = {0, 0};
    for (int v: edge[u]) {
        if (v == p) continue;
        ans = max(ans, far(v, u, d + 1));
    }
    if (good[u]) {
        ans = max(ans, {d, u});
    }
    return ans;
}

int center(int a, int b, vector<int> &path, int p) {
    path.push_back(a);
    if (a == b) {
        return path[path.size() / 2];
    }
    for (int v: edge[a]) {
        if (v == p) continue;
        int k = center(v, b, path, a);
        if (k != -1) return k;
    }
    path.pop_back();
    return -1;
}

bool check_dist(int u, int p, int d, int dist) {
    if (good[u] && d != dist) return false;
    for (int v: edge[u]) {
        if (v == p) continue;
        if (!check_dist(v, u, d + 1, dist)) return false;
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    cout << fixed << setprecision(20);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        edge[a].push_back(b);
        edge[b].push_back(a);
    }
    vector<int> c(m);
    for (int i = 0; i < m; i++) {
        cin >> c[i];
        c[i]--;
        good[c[i]] = 1;
    }
    if (m == 1) {
        cout << "YES" << endl << c[0] + 1 << endl;
        return 0;
    }
    auto p = far(c[0], -1, 0);
    //cerr << p.first << " " << p.second << endl;
    auto q = far(p.second, -1, 0);
    //cerr << q.first << " " << q.second << endl;
    if (q.first % 2 == 1) {
        cout << "NO" << endl;
        return 0;
    }
    vector<int> kek;
    int cen = center(p.second, q.second, kek, -1);
    //cerr << cen << endl;
    if (check_dist(cen, -1, 0, q.first / 2)) {
        cout << "YES" << endl << cen + 1 << endl;
        return 0;
    }

    cout << "NO" << endl;
    return 0;
}