#include <bits/stdc++.h>

using namespace std;

bool contains(pair<pair<int, int>, pair<int, int>> rect, pair<int, int> point) {
    return (point.first >= rect.first.first && point.first <= rect.second.first)
        && (point.second >= rect.first.second && point.second <= rect.second.second);
}

int square(pair<pair<int, int>, pair<int, int>> rect) {
    return (rect.second.first - rect.first.first + 1) * (rect.second.second - rect.first.second + 1);
}

pair<pair<int, int>, pair<int, int>> gmx(int n, int m, vector<string> &s, int x, int y) {
    vector<int> heights[2] = {vector<int>(m, 0), vector<int>(m, 0)};
    int g = 0;
    pair<pair<int, int>, pair<int, int>> ans = {{x, y}, {x, y}};
    for (int i = 0; i < n; i++) {
        vector<pair<int, int>> hg_stack;
        for (int j = 0; j < m; j++) {
            heights[g][j] = (s[i][j] == '.' || (i == x && j == y)) ? heights[!g][j] + 1 : 0;
            while (!hg_stack.empty()) {
                if (hg_stack.back().second >= heights[g][j]) {
                    auto p = hg_stack.back();
                    hg_stack.pop_back();
                    int pr = hg_stack.empty() ? -1 : hg_stack.back().first;
                    pair<pair<int, int>, pair<int, int>> rect = {{i - p.second + 1, pr + 1}, {i, j - 1}};
                    //cerr << rect.first.first << " " << rect.first.second << " " << rect.second.first << " " << rect.second.second << endl;
                    if (contains(rect, {x, y}) && square(rect) > square(ans)) ans = rect;
                } else {
                    break;
                }
            }
            hg_stack.push_back({j, heights[g][j]});
        }
        int j = m;
        while (!hg_stack.empty()) {
            auto p = hg_stack.back();
            hg_stack.pop_back();
            int pr = hg_stack.empty() ? -1 : hg_stack.back().first;
            pair<pair<int, int>, pair<int, int>> rect = {{i - p.second + 1, pr + 1}, {i, j - 1}};
            //cerr << rect.first.first << " " << rect.first.second << " " << rect.second.first << " " << rect.second.second << endl;
            if (contains(rect, {x, y}) && square(rect) > square(ans)) ans = rect;
        }
        g = !g;
    }
    //cerr << endl;
    return ans;
}

int main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    cout << fixed << setprecision(20);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    //cerr << contains({{0, 2}, {2, 3}}, {2, 3}) << endl;

    int n, m;
    cin >> n >> m;
    vector<string> s(n);
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }

    for (char c = 'A'; c <= 'Z'; c++) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (s[i][j] == c) {
                    auto rect = gmx(n, m, s, i, j);
                    for (int i1 = rect.first.first; i1 <= rect.second.first; i1++) {
                        for (int j1 = rect.first.second; j1 <= rect.second.second; j1++) {
                            if (s[i1][j1] != c) {
                                s[i1][j1] = (c - 'A' + 'a');
                            }
                        }
                    }
                }
            }
        }
    }

    for (int i = 0; i < n; i++) {
        cout << s[i] << endl;
    }
    return 0;
}