#include <bits/stdc++.h>

using namespace std;

bool contains(pair<pair<int, int>, pair<int, int>> rect, pair<int, int> point) {
    return (point.first >= rect.first.first && point.first <= rect.second.first)
        && (point.second >= rect.first.second && point.second <= rect.second.second);
}

int square(pair<pair<int, int>, pair<int, int>> rect) {
    return (rect.second.first - rect.first.first + 1) * (rect.second.second - rect.first.second + 1);
}

pair<pair<int, int>, pair<int, int>> gmx(int n, int m, vector<string> &s, int x, int y) {
    vector<int> heights[2] = {vector<int>(m, 0), vector<int>(m, 0)};
    int g = 0;
    pair<pair<int, int>, pair<int, int>> ans = {{x, y}, {x, y}};
    for (int i = 0; i < n; i++) {
        vector<pair<int, int>> hg_stack;
        for (int j = 0; j < m; j++) {
            heights[g][j] = (s[i][j] == '.' || (i == x && j == y)) ? heights[!g][j] + 1 : 0;
            while (!hg_stack.empty()) {
                if (hg_stack.back().second >= heights[g][j]) {
                    auto p = hg_stack.back();
                    hg_stack.pop_back();
                    int pr = hg_stack.empty() ? -1 : hg_stack.back().first;
                    pair<pair<int, int>, pair<int, int>> rect = {{i - p.second + 1, pr + 1}, {i, j - 1}};
                    ////cerr << rect.first.first << " " << rect.first.second << " " << rect.second.first << " " << rect.second.second << endl;
                    if (contains(rect, {x, y}) && square(rect) > square(ans)) ans = rect;
                } else {
                    break;
                }
            }
            hg_stack.push_back({j, heights[g][j]});
        }
        int j = m;
        while (!hg_stack.empty()) {
            auto p = hg_stack.back();
            hg_stack.pop_back();
            int pr = hg_stack.empty() ? -1 : hg_stack.back().first;
            pair<pair<int, int>, pair<int, int>> rect = {{i - p.second + 1, pr + 1}, {i, j - 1}};
            ////cerr << rect.first.first << " " << rect.first.second << " " << rect.second.first << " " << rect.second.second << endl;
            if (contains(rect, {x, y}) && square(rect) > square(ans)) ans = rect;
        }
        g = !g;
    }
    ////cerr << endl;
    return ans;
}

void split_and_fill(int li, int lj, int ri, int rj, vector<string> &s) {
    //cerr << li << " " << lj <<  " " << ri << " " << rj << endl;
    if (li > ri || lj > rj) return;
    bool flag = false;
    for (int i = li; i <= ri; i++) {
        vector<pair<int, char>> level;
        for (int j = lj; j <= rj; j++) {
            if (s[i][j] != '.') {
                level.push_back({j, s[i][j]});
                flag = true;
            }
        }
        if (level.empty() && flag) {
            for (int j = lj; j <= rj; j++) {
                s[i][j] = (s[i - 1][j] >= 'a' && s[i - 1][j] <= 'z') ? s[i - 1][j] : (s[i - 1][j] - 'A' + 'a');
            }
        } else if (!level.empty()) {
            int j = lj;
            for (auto p: level) {
                for (; j < p.first; j++) {
                    s[i][j] = p.second - 'A' + 'a';
                }
                j++;
            }
            for (; j <= rj; j++) {
                s[i][j] = level.back().second - 'A' + 'a';
            }
        }
    }
    //cerr << "kek1" << endl;
    for (int i = ri; i >= li; i--) {
        for (int j = lj; j <= rj; j++) {
            if (s[i][j] == '.') {
                s[i][j] = (s[i + 1][j] >= 'a' && s[i + 1][j] <= 'z') ? s[i + 1][j] : (s[i + 1][j] - 'A' + 'a');
            }
        }
    }
    //cerr << "kek2" << endl;
}

int main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    cout << fixed << setprecision(20);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    ////cerr << contains({{0, 2}, {2, 3}}, {2, 3}) << endl;

    int n, m;
    cin >> n >> m;
    vector<string> s(n);
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (s[i][j] == 'A') {
                auto rect = gmx(n, m, s, i, j);
                for (int i1 = rect.first.first; i1 <= rect.second.first; i1++) {
                    for (int j1 = rect.first.second; j1 <= rect.second.second; j1++) {
                        if (s[i1][j1] != 'A') {
                            s[i1][j1] = 'a';
                        }
                    }
                }
                int li = rect.first.first;
                int ri = rect.second.first;
                int lj = rect.first.second;
                int rj = rect.second.second;
                //cerr << li << " " << lj << " " << ri << " " << rj << endl;
                split_and_fill(0, 0, li - 1, m - 1, s);
                split_and_fill(ri + 1, 0, n - 1, m - 1, s);
                split_and_fill(li, 0, ri, lj - 1, s);
                //cerr << "after kek" << endl;
                split_and_fill(li, rj + 1, ri, m - 1, s);
                //cerr << "after kek2" << endl;
            }
        }
    }



    for (int i = 0; i < n; i++) {
        cout << s[i] << endl;
    }
    return 0;
}