#include <bits/stdc++.h>

using namespace std;

vector<vector<int>> g;
set <int> blacks;
vector<int> used;

int dfsCheck(int v) {
    bool isBlack = blacks.count(v);
    int cnt = 0;
    for (int i = 0; i <g[v].size(); i++) {
        int to = g[v][i];
        if (used[to] == false) {
            used[to] = true;
            if (cnt > 0 && isBlack) {
                cout << "NO";
                exit(0);
            }
            cnt += dfsCheck(to);
        }
    }
    cnt += blacks.count(v);
    return cnt;
}

int maxDepth = 0;

void dfsDepth(int v, int depth) {
    if (blacks.count(v)) {
        maxDepth = max(depth, maxDepth);
    }
    for (int i = 0; i <g[v].size(); i++) {
        int to = g[v][i];
        if (used[to] == false) {
            used[to] = true;
            dfsDepth(to, depth + 1);
        }
    }
}

vector <int> path;

int dfsGetPath(int v, int depth) {
   if (blacks.count(v) && depth == maxDepth) {
        path.push_back(v);
        return true;
   }
   for (int i = 0; i <g[v].size(); i++) {
        int to = g[v][i];
        if (used[to] == false) {
            used[to] = true;
            if (dfsGetPath(to, depth + 1) == true) {
                path.push_back(v);
                return true;
            }
        }
    }
    return false;
}

int depthToBlack = -1;

void dfsCheckDistance(int v, int depth) {
    //cout << "v, depth = " << v + 1 << ' ' << depth <<  endl;
    if (blacks.count(v)) {
        if (depthToBlack == -1) {
            //cout << "set v" << " " << v + 1 << ' ' << depth << endl;
            depthToBlack = depth;
        } else if (depthToBlack != depth) {
            //cout << depthToBlack << ' ' << depth << endl;
            //cout << "v = " << v << endl;
            cout << "NO";
            exit(0);
        }
    }
    for (int i = 0; i <g[v].size(); i++) {
        int to = g[v][i];
        if (used[to] == false) {
            used[to] = true;
            dfsCheckDistance(to, depth + 1);
        }
    }
}

int main()
{
    int n, m;
    cin >> n >> m;
    used.assign(n, 0);
    g.assign(n, vector<int>());
    for (int i = 0; i < n - 1; i++) {
        int from, to;
        cin >> from >> to;
        g[from - 1].push_back(to - 1);
        g[to - 1].push_back(from - 1);
    }
    for (int i = 0; i < m; i++) {
        int x;
        cin >> x;
        blacks.insert(x - 1);
    }
    int start_node = *blacks.begin();

    used[start_node] = true;
    dfsCheck(*blacks.begin());
    fill(used.begin(), used.end(), 0);
    used[start_node] = true;
    dfsDepth(*blacks.begin(), 0);
    fill(used.begin(), used.end(), 0);
    used[start_node] = true;
    dfsGetPath(*blacks.begin(), 0);


    if (path.size() % 2 == 0) {
        cout << "NO";
        return 0;
    }

    /*cout << "blacks: ";
    for (auto x: blacks) {
        cout << x << ' ';
    }
    cout << endl;*/

    fill(used.begin(), used.end(), 0);
    //cout << "call = " << path[path.size() / 2] + 1 << endl;
    used[path[path.size() / 2]] = true;

    if (blacks.count(path[path.size() / 2])) {
        maxDepth = 0;
    }

    dfsCheckDistance(path[path.size() / 2], 0);



    cout << "YES" << endl;
    cout << path[path.size() / 2] + 1 << endl;
    return 0;
}

/**
6 3
1 2
2 3
3 4
4 5
4 6
1 5 6

6 5
1 2
1 3
1 4
1 5
1 6
2 3 4 5 6
**/
