
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define all(x) (x).begin(), (x).end();


using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;

const int MAXN = 2e5 + 30;
const int INF = 1e6 + 30;

vector <int> g[MAXN];

vector <int> dp1(MAXN, INF);
vector <int> dp2(MAXN, -INF);
vector <int> a1(MAXN, INF);
vector <int> a2(MAXN, -INF);

bool c[MAXN];

void dfs(int u, int p)
{
    if (c[u])
    {
        dp1[u] = 0;
        dp2[u] = 0;
    }
    for (int v : g[u])
    {
        if (v == p)
            continue;
        dfs(v, u);
        dp1[u] = min(dp1[u], dp1[v] + 1);
        dp2[u] = max(dp2[u], dp2[v] + 1);
    }
}

void dfs2(int u, int p, int t1, int t2)
{
    multiset <int> st1, st2;
    if (c[u])
    {
        st1.insert(0);
        st2.insert(0);
    }
    else
    {
        st1.insert(INF);
        st2.insert(-INF);
    }

    for (int v : g[u])
    {
        if (v == p)
            continue;
        st1.insert(dp1[v] + 1);
        st2.insert(dp2[v] + 1);
    }

    st1.insert(t1);
    st2.insert(t2);


    a1[u] = *st1.begin();
    a2[u] = *st2.rbegin();

    for (int v : g[u])
    {
        if (v == p)
            continue;
        st1.erase(st1.find(dp1[v] + 1));
        st2.erase(st2.find(dp2[v] + 1));

        dfs2(v, u, *st1.begin() + 1, *st2.rbegin() + 1);
        st1.insert(dp1[v] + 1);
        st2.insert(dp2[v] + 1);
    }
}

int main()
{
#ifdef PC
    freopen("in", "r", stdin);
#endif // HOME
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int n, m;
    cin >> n >> m;
    for (int i = 1; i < n; i++)
    {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    for (int i = 0; i < m; i++)
    {
        int x;
        cin >> x;
        c[x] = 1;
    }
    dfs(1, -1);
    dfs2(1, -1, INF, -INF);

    for (int i = 1; i <= n; i++)
    {
        if (a1[i] == a2[i])
        {
            return cout << "YES\n" << i, 0;
        }
    }
    cout << "NO";
    return 0;
}
