#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define all(x) (x).begin(), (x).end();
#define pb push_back
#define x first
#define y second

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;

const int MAXN = 1005;

char a[MAXN][MAXN];
char ans[MAXN][MAXN];
bool used[MAXN][MAXN];
vector<int> p, best;
int s_ans = 0;

int n, m;

int filling_left(int x, int y)
{
    int ans = 0;
    for (int j = y - 1; j > 0 && ans == 0; j--)
    {
        for (int i = 1; i <= n; i++)
            if (!used[i][j] && a[i][j] != '.')
            {
                ans = j;
                break;
            }
    }
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= ans; j++)
            used[i][j] = 1;
    return ans;
}

int filling_right(int x, int y)
{
    int ans = m + 1;
    for (int j = y + 1; j <= m && ans == m + 1; j++)
    {
        for (int i = 1; i <= n; i++)
            if (!used[i][j] && a[i][j] != '.')
            {
                ans = j;
                break;
            }
    }
    for (int i = 1; i <= n; i++)
        for (int j = ans; j <= m; j++)
            used[i][j] = 1;
    return ans;
}

int filling_up(int x, int y)
{
    int ans = 0;
    for (int i = x - 1; i > 0 && ans == 0; i--)
    {
        for (int j = 1; j <= m; j++)
            if (!used[i][j] && a[i][j] != '.')
            {
                ans = i;
                break;
            }
    }
    for (int i = 1; i <= ans; i++)
        for (int j = 1; j <= m; j++)
            used[i][j] = 1;
    return ans;
}

int filling_down(int x, int y)
{
    int ans = n + 1;
    for (int i = x + 1; i <= n && ans == n + 1; i++)
    {
        for (int j = 1; j <= m; j++)
            if (!used[i][j] && a[i][j] != '.')
            {
                //cerr << i << ' ' << j << endl;
                ans = i;
                break;
            }
    }
    for (int i = ans; i <= n; i++)
        for (int j = 1; j <= m; j++)
            used[i][j] = 1;
    //exit(0);
    return ans;
}

void fills(int x1, int y1, int x2, int y2)
{
    //cerr << "&&&& " << x1 << ' ' << y1 << ' ' << x2 << ' ' << y2 << endl;
    vector<pair<int, int>> v;
    v.clear();
    for (int i = x1; i <= x2; i++)
        for (int j = y1; j <= y2; j++)
            if (a[i][j] != '.')
                v.pb({i, j});
    sort(v.begin(), v.end());
    for (auto p : v)
    {
        for (int i = p.x - 1; i >= x1; i--)
            if (a[i][p.y] == '.')
                a[i][p.y] = a[p.x][p.y] + 'a' - 'A';
            else
                break;
        for (int i = p.x + 1; i <= x2; i++)
            if (a[i][p.y] == '.')
                a[i][p.y] = a[p.x][p.y] + 'a' - 'A';
            else
                break;
    }
    for (int j = y1; j <= y2; j++)
        for (int i = x1; i <= x2; i++)
        {
            if (a[i][j] == '.' && j > y1)
                if (a[i][j - 1] >= 'A' && a[i][j - 1] <= 'Z')
                    a[i][j] = a[i][j - 1] + 'a' - 'A';
                else
                    a[i][j] = a[i][j - 1];
        }
    for (int j = y2; j >= y1; j--)
        for (int i = x1; i <= x2; i++)
        {
            if (a[i][j] == '.' && j < y2)
                if (a[i][j + 1] >= 'A' && a[i][j + 1] <= 'Z')
                    a[i][j] = a[i][j + 1] + 'a' - 'A';
                else
                    a[i][j] = a[i][j + 1];
        }
}

int main()
{
#ifdef PC
    freopen("in", "r", stdin);
#endif // HOME
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    cin >> n >> m;
    int x, y;

    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= m; j++)
        {
            cin >> a[i][j];
            if (a[i][j] == 'A')
            {
                x = i;
                y = j;
            }
        }
    for (int i = 0; i < 4; i++)
        p.pb(i);
    //p = {3, 0, 2, 1};
    do
    {
        for (int i = 1; i <= n; i++)
            for (int j = 1; j <= m; j++)
                used[i][j] = 0;
        int lx, ly, rx, ry;
        lx = ly = rx = ry = -1;
        for (int i = 0; i < 4; i++) {
            if (p[i] == 0)
                lx = filling_left(x, y);
            if (p[i] == 1)
                rx = filling_right(x, y);
            if (p[i] == 2)
                ly = filling_up(x, y);
            if (p[i] == 3)
                ry = filling_down(x, y);
            //cerr << "! " << lx << ' ' << rx << ' ' << ly << ' ' << ry << endl;
        }

        int s = (ry - ly - 1) * (rx - lx - 1);
        if (s > s_ans)
        {
            s_ans = s;
            best = p;
        }
        //return 0;

    }
    while (next_permutation(p.begin(), p.end()));
    p = best;
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= m; j++)
            used[i][j] = 0;
    int lx, ly, rx, ry;
    lx = ly = rx = ry = -1;
    for (int i = 0; i < 4; i++) {
        if (p[i] == 0)
            lx = filling_left(x, y);
        if (p[i] == 1)
            rx = filling_right(x, y);
        if (p[i] == 2)
            ly = filling_up(x, y);
        if (p[i] == 3)
            ry = filling_down(x, y);
    }
    //cerr << lx << ' ' << ly << ' ' << rx << ' ' << ry << endl;
    for (int i = ly + 1; i < ry; i++)
        for (int j = lx + 1; j < rx; j++)
            if (a[i][j] == '.')
                a[i][j] = 'a';
    /*for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j <= m; j++)
            cout << a[i][j];
        cout << '\n';
    }
    cout << '\n';
    return 0;*/
    /*for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j <= m; j++)
            cout << a[i][j];
        cout << endl;
    }*/
    //return 0;
    int x1 = 1, y1 = 1, x2 = n, y2 = m;
    p = best;
    for (int i = 0; i < 4; i++)
    {
        //cerr << "? " << p[i] << endl;
        //cerr << "! " << x1 << ' ' << y1 << ' ' << x2 << ' ' << y2 << endl;
        if (p[i] == 0)
        {
            fills(x1, y1, x2, lx);
            y1 = lx + 1;
        }
        if (p[i] == 1)
        {
            fills(x1, rx, x2, y2);
            y2 = rx - 1;
        }
        if (p[i] == 2)
        {
            fills(x1, y1, ly, y2);
            x1 = ly + 1;
        }
        if (p[i] == 3)
        {
            fills(ry, y1, x2, y2);
            x2 = ry - 1;
        }

    }
    for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j <= m; j++)
            cout << a[i][j];
        cout << '\n';
    }
    cout << '\n';
    return 0;
}
