#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

typedef long long ll;
typedef pair <int, int> pii;

int n, m;
vector<vector<int>> rebr;
vector<int> part;
vector<int> used;
vector<int> from;
//vector<int> res;

void dfs1(int v) {
    for (int i : rebr[v]) {
        if (used[i] == 0) {
            from[i] = v;
            used[i] = used[v] + 1;
            dfs1(i);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cout.tie(0); cin.tie(0);

    cin >> n >> m;
    rebr = vector<vector<int>>(n);

    for (int i = 0; i < n-1; i++) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        rebr[a].push_back(b);
        rebr[b].push_back(a);
    }

    part = vector<int>(m);
    used = vector<int>(n, 0);
    from = vector<int>(n, 0);
//    res = vector<int>(n, 0);

    for (int i = 0; i < m; i++) {
        cin >> part[i];
        part[i]--;
    }

    if (m == 1) {
        cout << part[0] + 1;
        return 0;
    }

    used[part[0]] = 1;
    dfs1(part[0]);

    int resi = 1;
//    int length = used[part[1]];

    for (int i = 2; i < m; i++) {
        if (used[part[i]] > used[part[resi]]) {
            resi = i;
        }
    }

    int res = part[resi];

    for (int i = 1; i * 2 < used[part[resi]]; i++) {
        res = from[res];
    }

    used = vector<int>(n, 0);

    used[res] = 1;
    dfs1(res);

    for (int i = 1; i < m; i++) {
        if (used[part[i]] != used[part[i-1]]) {
            cout << "NO\n";
            return 0;
        }
    }

    cout << "YES\n" << res + 1;

    return 0;
}

/*
6 3
1 2
2 3
3 4
4 5
4 6
1 5 6

2 2
1 2
1 2

11 4
1 2
2 3
3 4
4 5
3 6
3 7
7 8
2 9
9 10
9 11
1 9 5 8

11 2
1 2
2 3
3 4
4 5
3 6
3 7
7 8
2 9
9 10
9 11
2 5

11 2
1 2
2 3
3 4
4 5
3 6
3 7
7 8
2 9
9 10
9 11
3 5

11 1
1 2
2 3
3 4
4 5
3 6
3 7
7 8
2 9
9 10
9 11
9

11 3
1 2
2 3
3 4
4 5
3 6
3 7
7 8
2 9
9 10
9 11
2 10 11

11 3
1 2
2 3
3 4
4 5
3 6
3 7
7 8
2 9
9 10
9 11
2 9 11

11 3
1 2
2 3
3 4
4 5
3 6
3 7
7 8
2 9
9 10
9 11
1 3 9

11 2
1 2
2 3
3 4
4 5
3 6
3 7
7 8
2 9
9 10
9 11
2 1
 */