#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <set>
#include <cmath>
#include <deque>

using namespace std;

#define pb push_back
#define all(a) a.begin(), a.end()
#define read(a) for (int i = 0; i < a.size(); ++i) cin >> a[i];
#define printv(a, text) cout << text << " = "; for (auto e : a) cout << e << ' '; cout << endl;
#define printm(a, text) cout << text << " =\n"; for (auto e : a) cout << e.first << ' ' << e.second << endl; cout << endl;

typedef long long ll;
typedef pair <int, int> pii;

vector <int> x, y, h;

int main() {
    int n;
    cin >> n;

    x.resize(n);
    y.resize(n);
    h.resize(n);
    int max_h = 0;
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> y[i] >> h[i];
        max_h = max(max_h, h[i]);
    }

    int lh = 0, rh = 1e9;
    int ansx = 1e9, ansy = 1e9;
    while (lh + 1 < rh) {
        int mh = (lh + rh) / 2;
        bool fail = false;
        vector <pii> left(n), right(n);
        for (int i = 0; i < n; ++i) {
            int delta = mh - h[i];
            if (delta < 0) fail = true;
            left[i] = {x[i] - delta, y[i] - delta};
            right[i] = {x[i] + delta, y[i] + delta};
        }

        //cout << "mh = " << mh << endl;
        //printm(left, "left");
        //printm(right, "right");
        //cout << endl;


        int maxlx = -1e9, minrx = 1e9, minry = 1e9, maxly = -1e9;
        for (int i = 0; i < n; ++i) {
            maxlx = max(left[i].first, maxlx);
            maxly = max(left[i].second, maxly);
            minrx = min(right[i].first, minrx);
            minry = min(right[i].second, minry);
        }

        if (minrx < maxlx || minry < maxly) fail = true;

        if (fail) lh = mh;
        else {
            rh = mh;
            ansx = minrx;
            ansy = minry;
        }
    }

    cout << ansx << " " << ansy << " " << rh << "\n";
}


