#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <set>
#include <cmath>
#include <deque>

using namespace std;

#define pb push_back
#define all(a) a.begin(), a.end()
#define read(a) for (int i = 0; i < a.size(); ++i) cin >> a[i];
#define printv(a, text) cout << text << " = "; for (auto e : a) cout << e << ' '; cout << endl;
#define printm(a, text) cout << text << " =\n"; for (auto e : a) cout << e.first << ' ' << e.second << endl; cout << endl;

typedef long long ll;
typedef pair <int, int> pii;

vector<vector<char>> fi;

bool isempty(vector<char> a, int leftx, int rightx) {
    cout << leftx << " " << rightx << "\n";
    for (int i = leftx; i < rightx; i++)
        if (a[i] != '.') return false;
    return true;
}

void fill(int leftx, int rightx, int lefty, int righty) {
    char let = '.';
    for (int i = leftx; i < rightx; i++) {
        for (int j = lefty; j < righty; j++) {
            if (fi[i][j] != '.') {
                let = fi[i][j];
                break;
            }
        }
        if (let != '.') break;
    }

    int i;
    for (i = leftx; i < rightx; i++) {
//        cout << i << ". ";
        if (isempty(fi[i], lefty, righty)){
            for (int j = lefty; j < righty; j++) {
                fi[i][j] = let - 'A' + 'a';
            }
        } else {
//            cout << "239 ";
            break;
        }
    }

    for (; i < rightx; i++) {
//        cout << i << " ";
        if (isempty(fi[i], lefty, righty)) {
            for (int j = lefty; j < righty; j++) {
                fi[i][j] = fi[i-1][j];
            }
        } else {
            int j = lefty;
            while (fi[i][j] == '.') j++;
            let = fi[i][j];
            j = lefty;
            for (; j < righty; j++) {
                if (fi[i][j] == '.') {
                    fi[i][j] = let - 'A' + 'a';
                } else {
                    let = fi[i][j];
                }
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cout.tie(0); cin.tie(0);

    int n, m;
    cin >> n >> m;

    fi = vector<vector<char>>(n, vector<char>(m));
    int ax, ay;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> fi[i][j];
            if (fi[i][j] == 'A') {
                ax = i;
                ay = j;
            }
        }
    }

    vector<int> left(n), right(n);

    for (int i = 0; i < n; i++) {
        left[i] = ay;
        while ((left[i] > 0) && (fi[i][left[i] - 1] == '.' || fi[i][left[i] - 1] == 'A')) {
            left[i]--;
        }
        right[i] = ay;
        while ((right[i] < m-1) && (fi[i][right[i] + 1] == '.' || fi[i][right[i] + 1] == 'A')) {
            right[i]++;
        }
    }

    for (int i = ax - 1; i >= 0; i--) {
        left[i] = max(left[i], left[i+1]);
    }
    for (int i = ax + 1; i < n; i++) {
        right[i] = min(right[i], right[i-1]);
    }

    for (int i = 0; i < n; i++) {
        cout << left[i] << " " << right[i] << "\n";
    }

//    vector<int> pref(n);
//
//    pref[0] = left[0] + right[0];
//    for (int i = 1; i < n; i++) {
//        pref[i] = pref[i-1] + left[i] + right[i];
//    }

    int lx, rx, ly, ry, res = 0;

    for (int i = 0; i <= ax; i++) {
        for (int j = ax; j < n; j++) {
            int wr = min(right[i], right[j]);
            int wl = max(left[i], left[j]);
            if (res < (j - i + 1) * (wr - wl + 1)) {
                res = (j - i + 1) * (wr - wl + 1);
                lx = i;
                rx = j + 1;
                ly = wl;
                ry = wr + 1;
            }
        }
    }

    for (int i = lx; i < rx; i++) {
        for (int j = ly; j < ry; j++) {
            if (fi[i][j] != 'A')
                fi[i][j] = 'a';
        }
    }

    fill(0, lx, 0, m);
    fill(lx, rx, 0, ly);
    fill(lx, rx, ry, m);
    fill(rx, n, 0, m);

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cout << fi[i][j];
        }
        cout << "\n";
    }

    return 0;
}
/*
6 8
......X.
.F......
...A....
........
.....P..
..L.....

 */