#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <set>
#include <cmath>

using namespace std;

#define all(a) a.begin(), a.end()
#define read(a) for (int i = 0; i < a.size(); ++i) cin >> a[i];
#define printv(a, text) cout << text << " = "; for (auto e : a) cout << e << ' '; cout << endl;
#define printm(a, text) cout << text << " =\n"; for (auto e : a) cout << e.first << ' ' << e.second << endl; cout << endl;

typedef long long ll;
typedef pair <int, int> pii;

int main() {
    int T;
    cin >> T;
    for (int t = 0; t < T; ++t) {
        int n;
        cin >> n;
        vector <int> a(n);
        read(a);
        //printv(a, "a");

        map <int, int> cnt;
        for (auto e : a) cnt[e] += 1;
        //printm(cnt, "cnt");
        int m = cnt.size();

        map <int, int> left, right;
        for (auto e : cnt) {
            right[e.first] = e.second;
            left[e.first] = 0;
        }
        right[a[0]] -= 1;
        //printm(left, "left");
        //printm(right, "right");

        ll ans = 0;
        for (int i = 1; i < n - 1; ++i) {
            left[a[i - 1]] += 1;
            right[a[i]] -= 1;

            //cout << "step " << i << ":\n";
            //printm(left, "left");
            //printm(right, "right");
            //cout << endl;

            for (auto e : left) {
                int x = 2 * a[i] - e.first;
                if (right.count(x) != 0) {
                    ans += e.second * right[x];
                }
            }

            //cout << "ans = " << ans << endl;
        }

        cout << ans << endl;
    }
}

/*
1
9
3 1 4 1 5 9 2 6 5
*/
