#include <iostream>
#include <queue>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

int main()
{
	int n, m;
	cin >> n >> m;
	int** mat = new int* [n];
	int* dst = new int[n];
	bool* used = new bool[n];
	for (int i = 0; i < n; i++)
	{
		mat[i] = new int[n];
		dst[i] = -1;
		used[i] = false;
		for (int j = 0; j < n; j++)
			mat[i][j] = 0;
	}
	for (int i = 0; i < n - 1; i++)
	{
		int temp1, temp2;
		cin >> temp1 >> temp2;
		mat[temp1 - 1][temp2 - 1] = mat[temp2 - 1][temp1 - 1] = 1;
	}
	
	vector<int> parts;
	parts.resize(m);
	for (int i = 0; i < m; i++) {
		cin >> parts[i];
		parts[i]--;
	}
	sort(parts.begin(), parts.end());

	queue<int> q;
	q.push(parts[0]);
	used[parts[0]] = true;
	dst[parts[0]] = 0;
	while (!q.empty())
	{
		int curr = q.front();
		q.pop();
		for (int i=0; i<n; i++)
			if (!used[i] && mat[curr][i])
			{
				q.push(i);
				used[i] = true;
				dst[i] = dst[curr] + 1;
			}
	}
	for (int i=0; i<m; i++)
		if (!used[parts[i]])
		{
			cout << "NO";
			return 0;
		}

	for (int i = 0; i < n; i++)
	{
		bool is_correct = true;
		int max = abs(dst[parts[0]] - dst[i]);
		for (int j = 1; j < m; j++)
			if (abs(dst[parts[j]] - dst[i]) != max)
			{
				is_correct = false;
				break;
			}
		if (is_correct)
		{
			cout << "YES" << endl << i + 1;
			return 0;
		}
	}
	cout << "NO" << endl;
}
