#define _CRT_SECURE_NO_WARNINGS
#include <queue>
#include <vector>
#include <algorithm>
#include <cmath>


using namespace std;

int main()
{
	int n, m;
	scanf("%d %d", &n , &m);
	vector<vector<bool>> mat(n, vector<bool>(n, false));
	int* dst = new int[n];
	for (int i = 0; i < n; i++)
	{
		dst[i] = -1;
	}
	for (int i = 0; i < n - 1; i++)
	{
		int temp1, temp2;
		scanf("%d %d", &temp1, &temp2);
		mat[temp1 - 1][temp2 - 1] = mat[temp2 - 1][temp1 - 1] = true;
	}

	vector<int> parts;
	parts.resize(m);
	for (int i = 0; i < m; i++) {
		scanf("%d", &parts[i]);
		parts[i]--;
	}

	queue<int> q;
	q.push(parts[0]);
	dst[parts[0]] = 0;
	int maxDist = 0;
	while (!q.empty())
	{
		int curr = q.front();
		q.pop();
		for (int i = 0; i < n; i++)
			if (dst[i] == -1 && mat[curr][i])
			{
				q.push(i);
				dst[i] = dst[curr] + 1;
				maxDist = fmax(dst[i], maxDist);
			}
	}


	maxDist /= 2;

	for (int i = 1; i < m - 1; i++) {
		if (abs(dst[parts[i]] - maxDist) != abs(dst[parts[i + 1]] - maxDist)) {
			printf("NO");
			return 0;
		}
	}

	bool cool = true;
	for (int i = 0; i < n; i++)
	{
		bool is_correct = true;
		int max = abs(dst[parts[0]] - dst[i]);
		if (max != maxDist) continue;
		if (abs(dst[parts[1]] - dst[i]) != max)
		{
			printf("NO");
			return 0;
		}
		if (is_correct)
		{
			printf("YES\n%i", i + 1);
			return 0;
		}
	}
	printf("NO");
}