#include <iostream>
#include <map>
#include <queue>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n, m;
	cin >> n >> m;
	if (n > 1e3 || m > 1e3) {
		vector<vector<bool>> mat;
		mat.resize(n);
		int* dst = new int[n];
		for (int i = 0; i < n; i++)
		{
			mat[i].resize(n);
			dst[i] = -1;
			for (int j = 0; j < n; j++)
				mat[i][j] = false;
		}
		for (int i = 0; i < n - 1; i++)
		{
			int temp1, temp2;
			cin >> temp1 >> temp2;
			mat[temp1 - 1][temp2 - 1] = mat[temp2 - 1][temp1 - 1] = true;
		}

		vector<int> parts;
		map<int, bool> c;
		parts.resize(m);
		for (int i = 0; i < m; i++) {
			cin >> parts[i];
			parts[i]--;
			c[parts[i]] = true;

		}
		sort(parts.begin(), parts.end());

		queue<int> q;
		q.push(parts[0]);
		dst[parts[0]] = 0;
		int maxDist = 0;
		while (!q.empty())
		{
			int curr = q.front();
			q.pop();
			for (int i = 0; i < n; i++)
				if (dst[i] == -1 && mat[curr][i])
				{
					q.push(i);
					dst[i] = dst[curr] + 1;
					maxDist = fmax(dst[i], maxDist);
				}
		}

		if (maxDist % 2 != 0) {
			cout << "NO";
			return 0;
		}

		maxDist /= 2;
		vector<int> center;
		for (int i = 0; i < n; i++) {
			if (dst[i] == maxDist) {
				center.push_back(i);
			}
		}

		for (int i = 0; i < n; i++) {
			dst[i] = -1;
		}

		for (int i = 0; i < center.size(); i++) {
			bool good = true;
			q.push(center[i]);
			dst[center[i]] = 0;
			while (!q.empty())
			{
				int curr = q.front();
				q.pop();
				if (good) {
					for (int j = 0; j < n; j++)
						if (dst[j] == -1 && mat[curr][j])
						{
							q.push(j);
							dst[j] = dst[curr] + 1;
							if (c[j] && dst[j] != maxDist) {
								good = false;
								break;
							}
						}
				}
			}
			if (good) {
				cout << "YES" << endl;
				cout << center[i] + 1;
				return 0;
			}
		}


		cout << "NO" << endl;
	}
	else {
		vector<vector<bool>> mat;
		mat.resize(n);
		int* dst = new int[n];
		for (int i = 0; i < n; i++)
		{
			mat[i].resize(n);
			dst[i] = -1;
			for (int j = 0; j < n; j++)
				mat[i][j] = false;
		}
		for (int i = 0; i < n - 1; i++)
		{
			int temp1, temp2;
			cin >> temp1 >> temp2;
			mat[temp1 - 1][temp2 - 1] = mat[temp2 - 1][temp1 - 1] = true;
		}

		vector<int> parts;
		parts.resize(m);
		for (int i = 0; i < m; i++) {
			cin >> parts[i];
			parts[i]--;
		}
		sort(parts.begin(), parts.end());

		queue<int> q;
		q.push(parts[0]);
		dst[parts[0]] = 0;
		while (!q.empty())
		{
			int curr = q.front();
			q.pop();
			for (int i = 0; i < n; i++)
				if (dst[i] == -1 && mat[curr][i])
				{
					q.push(i);
					dst[i] = dst[curr] + 1;
				}
		}

		for (int i = 0; i < n; i++)
		{
			bool is_correct = true;
			int max = abs(dst[parts[0]] - dst[i]);
			for (int j = 1; j < m; j++)
				if (abs(dst[parts[j]] - dst[i]) != max)
				{
					is_correct = false;
					break;
				}
			if (is_correct)
			{
				cout << "YES" << endl << i + 1;
				return 0;
			}
		}
		cout << "NO" << endl;
	}
}
