#include <bits/stdc++.h>

using namespace std;

const int maxW = 105;

char arr[maxW][maxW];

bool used[maxW][maxW];

int dx[] = {1, 1, 1, 0, 0, -1, -1, -1};
int dy[] = {1, 0, -1, 1, -1, 1, 0, -1};

bool checkPoint(int x, int y, int w, int h) {
    return x >= 0 && y >= 0 && x < w && y < h;
}

pair<int, int> dfs(int x, int y, int w, int h) {
    used[y][x] = 1;

    for (int i = 0; i < 8; i++) {
        int nx = x + dx[i];
        int ny = y + dy[i];
        if (!checkPoint(nx, ny, w, h)) continue;
        if (used[ny][nx]) continue;
        if (arr[ny][nx] == '.') continue;
        return dfs(nx, ny, w, h);
    }

    return {x, y};
}

vector<pair<int, int>> solve(int w, int h) {
    int cnt = 0;
    pair<int, int> pos;
    for (int y = 0; y < h; y++) {
        for (int x = 0; x < w; x++) {
            if (arr[y][x] == 'X') {
                cnt++;
                pos = {x, y};
            }
        }
    }
    if (cnt == 1) {
        vector<pair<int, int>> res;
        int x = pos.first, y = pos.second;
        res.push_back({x, y});
        res.push_back({x + 1, y + 1});
        res.push_back({x + 1, y});
        res.push_back({x, y + 1});
        return res;
    }

    for (int y = 0; y < h; y++) {
        for (int x = 0; x < w; x++) {
            used[y][x] = 0;
        }
    }
    auto p = dfs(pos.first, pos.second, w, h);
    arr[p.second][p.first] = '.';
    int x = p.first, y = p.second;
    int x2 = x + 1, y2 = y + 1;
    auto res = solve(w, h);

    if (count(res.begin(), res.end(), pair<int, int>{x + 1, y})) {
        x2 = x;
        x = x + 1;
    }
    else if (count(res.begin(), res.end(), pair<int, int>{x, y + 1})) {
        y2 = y;
        y = y + 1;

    }
    else if (count(res.begin(), res.end(), pair<int, int>{x + 1, y + 1})) {
        x2 = x;
        y2 = y;
        x = x + 1;
        y = y + 1;
    }

    int ind = find(res.begin(), res.end(), pair<int, int>{x, y}) - res.begin();
    pair<int, int> nxt = res[(ind + 1) % res.size()];
    if (abs(x - nxt.first) + abs(y - nxt.second) == 1) {
        reverse(res.begin(), res.end());
        ind = (int)res.size() - 1 - ind;
    }
    vector<pair<int, int>> res2;
    for (int i = 0; i <= ind; i++) res2.push_back(res[i]);
    res2.push_back({x2, y2});
    res2.push_back({x, y2});
    res2.push_back({x2, y});
    res2.push_back({x, y});
    for (int i = ind + 1; i < res.size(); i++) res2.push_back(res[i]);

    return res2;
}

int main() {
    //freopen("in.in", "r", stdin);
    //freopen("in.out", "w", stdout);

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int w, h;
    cin >> w >> h;
    for (int y = 0; y < h; y++) {
        cin >> arr[y];
    }

    auto res = solve(w, h);
    cout << (int)res.size() - 1 << endl;
    for (auto p : res) {
        cout << p.first << " " << p.second << endl;
    }



    return 0;
}
