#include <bits/stdc++.h>

using namespace std;

#define ll long long

const int maxN = 200005;

vector<int> edge[maxN];
int used[maxN];

vector<int> st;
bool dfs(int v, int tgt) {
    used[v] = 1;
    st.push_back(v);

    if (v == tgt) return 1;

    for (int u : edge[v]) {
        if (used[u]) continue;
        if (dfs(u, tgt)) return 1;
    }

    st.pop_back();
    return 0;
}

int dist[maxN];
int arr[maxN];
void solve(int v, int p) {
    for (int u : edge[v]) {
        if (u == p) continue;
        dist[u] = dist[v] + 1;
        solve(u, v);
    }
}

bool check(int v, int m) {
    dist[v] = 0;
    solve(v, -1);

    int ok = 1;
    for (int i = 0; i < m; i++) {
        if (dist[arr[i]] != dist[arr[0]]) ok = 0;
    }

    return ok;
}

int main() {
    //freopen("in.in", "r", stdin);
    //freopen("in.out", "w", stdout);

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;

    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;

        edge[u].push_back(v);
        edge[v].push_back(u);
    }

    for (int i = 0; i < m; i++) {
        cin >> arr[i];
        arr[i]--;
    }

    if (m == 1) {
        cout << "YES" << endl;
        cout << arr[0] + 1 << endl;
        return 0;
    }

    dfs(arr[0], arr[1]);
    if (st.size() % 2 == 0) {
        cout << "NO" << endl;
        return 0;
    }
    int v = st[st.size() / 2];

    solve(v, -1);
    int u = arr[0];
    for (int i = 0; i < m; i++) {
        if (dist[arr[i]] > dist[u]) u = arr[i];
    }

    st.clear();
    fill(used, used + n, 0);
    dfs(arr[0], u);
    if (st.size() % 2 != 0) {
        int v = st[st.size() / 2];
        if (check(v, m)) {
            cout << "YES" << endl;
            cout << v + 1 << endl;
            return 0;
        }
    }

    st.clear();
    fill(used, used + n, 0);
    dfs(arr[1], u);
    if (st.size() % 2 != 0) {
        int v = st[st.size() / 2];
        if (check(v, m)) {
            cout << "YES" << endl;
            cout << v + 1 << endl;
            return 0;
        }
    }

    cout << "NO" << endl;
    return 0;
}
