#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1010;

char c[MAXN][MAXN];
int right_[MAXN][MAXN];

bool empty_(int i, int j1, int j2) { return right_[i][j1] >= j2 - j1 + 1; }

vector <char> parserow(int i1, int i2, int j) {
    int firsti = -1;
    for (int i = i1; i <= i2; i++) {
        if (c[i][j] != '.' && firsti == -1)
            firsti = i;
    }
    assert(firsti != -1);
    vector <char> res;
    for (int i = i1; i <= i2; i++) {
        if (c[i][j] != '.')
            firsti = i;
        res.push_back(c[firsti][j] + ('a' - 'A'));
    }
    return res;
}

void func(int i1, int j1, int i2, int j2) {
    if (i1 > i2 || j1 > j2)
        return;
    int firstj = -1;
    for (int j = j1; j <= j2; j++) {
        for (int i = i1; i <= i2; i++) {
            if (c[i][j] != '.' && firstj == -1)
                firstj = j;
        }
    }
    assert(firstj != -1);

    vector <char> v = parserow(i1, i2, firstj);

    for (int j = j1; j <= j2; j++) {
        bool has = false;
        for (int i = i1; i <= i2; i++)
            if (c[i][j] != '.')
                has = true;
        if (has)
            v = parserow(i1, i2, j);
        for (int i = i1; i <= i2; i++)
            if (c[i][j] == '.')
                c[i][j] = v[i - i1];
    }
}

int main() {
    //freopen("in.in", "r", stdin);
    //freopen("in.out", "w", stdout);

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int ai = -1, aj = -1;
    int n, m; cin >> n >> m;
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++) {
            cin >> c[i][j];
            if (c[i][j] == 'A')
                ai = i, aj = j;
        }

    for (int i = 0; i < n; i++) {
        right_[i][m] = 0;
        for (int j = m - 1; j >= 0; j--) {
            right_[i][j] = right_[i][j + 1] + 1;
            if (c[i][j] != '.' && c[i][j] != 'A')
                right_[i][j] = 0;
        }
    }

    pair <pair <int, int>, pair <int, int> > resc;
    long long res = -1;
    for (int lj = 0; lj <= aj; lj++) {
        int li = ai, ri = ai;
        for (int rj = m - 1; rj >= aj; rj--) {
            if (empty_(ai, lj, rj)) {
                while (li > 0 && empty_(li - 1, lj, rj))
                    li--;
                while (ri + 1 < n && empty_(ri + 1, lj, rj))
                    ri++;
                long long curres = (long long)(ri - li + 1) * (long long)(rj - lj + 1);
                if (res < curres) {
                    res = curres;
                    resc = make_pair(make_pair(li, ri), make_pair(lj, rj));
                }
            }
        }
    }

    for (int i = resc.first.first; i <= resc.first.second; i++)
        for (int j = resc.second.first; j <= resc.second.second; j++)
            if (c[i][j] == '.')
                c[i][j] = 'a';

    func(0, 0, resc.first.first - 1, m - 1);
    func(resc.first.first, 0, n - 1, resc.second.first - 1);
    func(resc.first.first, resc.second.second + 1, n - 1, m - 1);
    func(resc.first.second + 1, resc.second.first, n - 1, resc.second.second);

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cout << c[i][j];
        }
        cout << endl;
    }

    return 0;
}
