#include <bits/stdc++.h>

using namespace std;

const int MAXN = 2e5 + 10;

const int MOD = 1e9 + 9;
const int x = 37;
const int INF = 1e9 + 9;

int a[MAXN];
string s;
int n;

long long hashes[MAXN];
long long powx[MAXN];
int lcp[MAXN];

void init() {
    hashes[0] = 0;
    for (int i = 0; i < (int)s.length(); i++) {
        hashes[i + 1] = (hashes[i] * x % MOD + s[i]) % MOD;
    }
    powx[0] = 1;
    for (int i = 1; i < MAXN; i++)
        powx[i] = (powx[i - 1] * (long long)x) % MOD;
}

int get_hash(int i, int j) {
    return (hashes[j + 1] - (powx[j - i + 1] * (long long)hashes[i]) % MOD + MOD) % MOD;
}

string STR;
const int CCC = 2;
bool COMP(int i, int j, int m) {
    for (int k = 0; k < min(m, CCC); k++) {
        if (STR[i + k] != STR[j + k]) return 0;
    }
    return 1;
}

int kek(int i, int j) {
    int l = 0, r = min(n - i, n - j) + 1;
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (COMP(i, j, m) && get_hash(i, i + m - 1) == get_hash(j, j + m - 1))
            l = m;
        else
            r = m;
    }
    return l;
}


bool compare(int i, int j) {
    int l = kek(i, j);
    if (i + l >= (int)s.length())
        return true;
    if (j + l >= (int)s.length())
        return false;
    return s[i + l] < s[j + l];
}

int resa = 0, resb = 1;

int gcd(int a, int b) { return (b == 0) ? a : gcd(b, a % b); }

void updres(int a, int b) {
    if ((long long)resa * b < (long long)a * resb) {
        resa = a, resb = b;
    }
}

struct DSU {
    int size[MAXN];
    int parent[MAXN];

    void init(int n) {
        for (int i = 0; i < n; i++)
            size[i] = 1, parent[i] = i;
    }

    int get(int i) {
        if (parent[i] == i)
            return i;
        return parent[i] = get(parent[i]);
    }

    int merge(int u, int v) {
        if (size[u] > size[v])
            swap(u, v);
        parent[u] = v;
        size[v] += size[u];
        return v;
    }
} dsu;

struct Treap {
    Treap *left, *right;
    int val, prior;

    Treap(int val):
        left(NULL), right(NULL), val(val), prior(rand()) {}
};

Treap *merge(Treap *l, Treap *r) {
    if (l == NULL)
        return r;
    if (r == NULL)
        return l;
    if (l->prior < r->prior) {
        r->left = merge(l, r->left);
        return r;
    } else {
        l->right = merge(l->right, r);
        return l;
    }
}

pair <Treap*, Treap*> split(Treap *root, int key) {
    if (root == NULL) {
        return {0, 0};
    }
    if (root->val < key) {
        pair <Treap *, Treap *> p = split(root->right, key);
        root->right = p.first;
        return make_pair(root, p.second);
    } else {
        pair <Treap*, Treap*> p = split(root->left, key);
        root->left = p.second;
        return make_pair(p.first, root);
    }
}

void insert(Treap *&root, int val) {
    pair <Treap*, Treap*> p = split(root, val);
    Treap *z = new Treap(val);
    root = merge(merge(p.first, z), p.second);
}

vector <int> extract(Treap *root) {
    if (root == NULL)
        return {};
    vector <int> l = extract(root->left), r = extract(root->right);
    l.push_back(root->val);
    for (int i : r)
        l.push_back(i);
    return l;
}

int rightmost(Treap *root) {
    if (root == NULL)
        return INF;
    if (root->right == NULL)
        return root->val;
    return rightmost(root->right);
}

int leftmost(Treap *root) {
    if (root == NULL)
        return INF;
    if (root->left == NULL)
        return root->val;
    return leftmost(root->left);
}

pair <int, int> bounds(Treap *root, int key) {
    pair <Treap *, Treap *> p = split(root, key);
    int l = rightmost(p.first);
    int r = leftmost(p.second);
    return make_pair(l, r);
}

Treap* tr[MAXN];

int merge_(int val1, int val2) {
    int v1 = dsu.get(val1);
    int v2 = dsu.get(val2);
    if (dsu.size[v1] < dsu.size[v2])
        swap(v1, v2);
    int r = dsu.merge(v1, v2);
    // tr[r] <- tr[v1] + tr[v2]
    vector <int> all = extract(tr[v2]);
    int res = INF;
    for (int i = 0; i < (int)all.size(); i++) {
        pair <int, int> p = bounds(tr[v1], all[i]);
        res = min(res, abs(p.first - all[i]));
        res = min(res, abs(p.second - all[i]));
        insert(tr[v1], all[i]);
    }
    tr[r] = tr[v1];
    return res;
}

int main() {
    //freopen("in.in", "r", stdin);
    //freopen("in.out", "w", stdout);

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> s;
    STR = s;

    if ((int)s.length() == 1) {
        cout << "1/1" << endl;
        return 0;
    }
    init();

    n = (int)s.length();
    dsu.init(n);
    for (int i = 0; i < n; i++)
        a[i] = i;
    sort(a, a + n, compare);

    vector <pair <int, int> > v;
    for (int i = 0; i < n - 1; i++) {
        lcp[i] = kek(a[i], a[i + 1]);
        v.push_back(make_pair(-lcp[i], i));
    }

    sort(v.begin(), v.end());

    for (int i = 0; i < n; i++)
        tr[i] = new Treap(i);

    for (int k = 0; k < (int)v.size(); k++) {
        int i = v[k].second, l = -v[k].first;
        int result = merge_(a[i], a[i + 1]);
        updres(l + result, result);
    }
    int g = gcd(resa, resb);
    resa /= g;
    resb /= g;
    cout << resa << "/" << resb << endl;

    return 0;
}
