#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <cstdlib>
#include <map>
#include <unordered_map>
using namespace std;

using li = long long;
using vi = vector<li>;
using vvi = vector<vi>;
using vpi = vector<pair<li, li>>;

#define rnd() rand() + rand()*(RAND_MAX + 1) 
#define forn(i,n) for(li i = 0; i < (li)n; i++)
#define ford(i,n) for(li i = n - 1; i >= 0; i--)
#define fore(i,l,r) for(li i = l;i < r; i++)
#define all(a) a.begin(),a.end()

class Graph
{
public:
	vvi a;
	vi mark;
	int n, m;
	int root;
	int d;

	void addEdge()
	{
		int l, r;
		cin >> l >> r;
		l--, r--;
		a[l].push_back(r);
		a[r].push_back(l);
	}

	Graph()
	{
		cin >> n >> m;
		a.assign(n, vi());
		mark.assign(n, 0);
		forn(i, n - 1)
			addEdge();
		forn(i, m)
		{
			int v;
			cin >> v;
			mark[v - 1] = 1;
		}
	}

	int marked_dfs(int v, int depth, int p = -1)
	{
		if (mark[v] && p != -1)
		{
			d = depth / 2;
			return depth;
		}
		for (int to : a[v])
		{
			if (to == p)
				continue;
			int res = marked_dfs(to, depth + 1, v);
			if (res)
			{
				if (depth == res / 2)
					root = v;
				return res;
			}
		}
		return 0;
	}

	bool dfs(int v, int depth = 0, int p = -1)
	{
		if (mark[v] && depth != d)
			return 0;
		for (int to : a[v])
		{
			if (to == p)
				continue;
			if (!dfs(to, depth + 1, v))
				return 0;
		}
		return 1;
	}

	void solve()
	{
		root = -1;
		d = 0;
		forn(v,n)
			if (mark[v])
			{
				root = v;
				marked_dfs(v, 0);
				break;
			}
		if (!dfs(root))
		{
			cout << "NO" << endl;
			return;
		}
		cout << "YES" << endl;
		cout << root + 1 << endl;
	}
};

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	Graph g;
	g.solve();
}