#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <cstdlib>
#include <map>
#include <set>
#include <unordered_map>
using namespace std;

using li = long long;
using vi = vector<li>;
using vvi = vector<vi>;
using vpi = vector<pair<li, li>>;

#define rnd() rand() + rand()*(RAND_MAX + 1) 
#define forn(i,n) for(li i = 0; i < (li)n; i++)
#define ford(i,n) for(li i = n - 1; i >= 0; i--)
#define fore(i,l,r) for(li i = l;i < r; i++)
#define all(a) a.begin(),a.end()

struct Point
{
	li x, y, z;

	Point() {}

	Point(li x,li y,li z):x(x),y(y),z(z){}

	void in()
	{
		cin >> x >> y >> z;
	}

	void out()
	{
		cout << x << " " << y << " " << z << endl;
	}

	li dist(li x1,li y1)
	{
		return max(abs(x1 - x), abs(y1 - y)) + z;
	}
	
	li dist(Point v)
	{
		return max(abs(v.x - x), abs(v.y - y)) + z;
	}
};

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	vector<Point> a(n);
	forn(i, n)
		a[i].in();
	
	auto dist = [a, n](li x, li y)
	{
		li res = 0;
		for (auto p : a)
			res = max(res, p.dist(x, y));
		return res;
	};

	auto bsy = [a, n, &dist](li x)
	{
		li l = -1000000000, r = 1000000000;
		while (r - l > 2)
		{
			li m1 = l + (r - l) / 3;
			li m2 = r - (r - l) / 3;
			if (dist(x, m1) < dist(x, m2))
				r = m2;
			else
				l = m1;
		}
		li ld = dist(x, l);
		li md = dist(x, l + 1);
		li rd = dist(x, r);
		if (md < ld && md < rd)
			return Point(x, l + 1, md);
		if (ld < rd)
			return Point(x, l, ld);
		return Point(x, r, rd);
	};

	auto bs = [a, n, &dist,&bsy]()
	{
		li l = -1000000000, r = 1000000000;
		while (r - l > 2)
		{
			li m1 = l + (r - l) / 3;
			li m2 = r - (r - l) / 3;
			Point m1p = bsy(m1);
			Point m2p = bsy(m2);
			if (m1p.z < m2p.z)
				r = m2;
			else
				l = m1;
		}
		Point lp = bsy(l);
		Point mp = bsy(l+1);
		Point rp = bsy(r);
		if (mp.z < lp.z && mp.z < rp.z)
			return mp;
		if (lp.z < rp.z)
			return lp;
		else
			return rp;
	};

	Point res = bs();
	res.out();
}