#include <bits/stdc++.h>
#define ALL(s) (s).begin(), (s).end()
#define sz(s) (int)(s).size()
#define mp make_pair
using namespace std;

typedef long double ld;
typedef long long ll;
mt19937 rng(time(0));

struct rect {
    int x1, y1;
    int x2, y2;

    int get() {
        return (x2 - x1 + 1) * (y2 - y1 + 1);
    }
};

rect solve(vector<int> const& dp, int h, int x, int y) {
    int n = dp.size();
    vector<int> lsr(n, n - 1);
    stack<int> st;
    for (int i = 0; i < n; i++) {
        while (!st.empty() && dp[st.top()] > dp[i]) {
            lsr[st.top()] = i - 1;
            st.pop();
        }
        st.push(i);
    }

    vector<int> lsl(n, 0);
    while (st.size()) st.pop();
    for (int i = n - 1; i >= 0; i--) {
        while (!st.empty() && dp[st.top()] > dp[i]) {
            lsl[st.top()] = i + 1;
            st.pop();
        }
        st.push(i);
    }

    rect ans;
    ans.x1 = -1;
    for (int i = 0; i < n; i++) {
        rect now;
        now.x1 = lsl[i];
        now.y1 = h;
        now.x2 = lsr[i];
        now.y2 = h + dp[i] - 1;

        if (now.y2 >= y && now.y1 <= y) {
            if (now.x1 <= x && now.x2 >= x) {
                if (ans.x1 == -1 || ans.get() < now.get()) {
                    ans = now;
                }
            }
        }
    }
    return ans;
}

void fill_t(vector<vector<char>> &g, int x1, int y1, int x2, int y2) {
    int mn_upd = y1 - 1;
    for (int i = y1; i <= y2; i++) {
        int fst = -1;
        for (int j = x1; j <= x2; j++) {
            if (g[i][j] != '.' && fst == -1) fst = j;
        }

        if (fst == -1) {
            if (mn_upd == i - 1) {
                mn_upd = i;
            } else {
                for (int j = x1; j <= x2; j++) {
                    g[i][j] = g[i - 1][j];
                }
            }
            continue;
        }

        for (int j = x1; j <= x2; j++) {
            if (j < fst) {
                g[i][j] = g[i][fst] - 'A' + 'a';
            } else {
                if (g[i][j] != '.') continue;
                g[i][j] = g[i][j - 1];
                if ('A' <= g[i][j] && g[i][j] <= 'Z') {
                    g[i][j] = g[i][j] - 'A' + 'a';
                }
            }
        }
    }

    for (int i = mn_upd; i >= y1; i--) {
        for (int j = x1; j <= x2; j++) {
            if ('A' <= g[i + 1][j] <= 'Z') {
                g[i][j] = g[i + 1][j] - 'A' + 'a';
            } else {
                g[i][j] = g[i + 1][j];
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    //freopen("input.txt", "r", stdin);
    cout.precision(12);

    int n, m;
    cin >> n >> m;
    vector<vector<char>> g(n, vector<char>(m));

    int x = 0, y = 0;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> g[i][j];
            if (g[i][j] == 'A') {
                x = j;
                y = i;
            }
        }
    }

    vector<vector<int>> dp(n, vector<int>(m));
    for (int i = n - 1; i >= 0; i--) {
        for (int j = 0; j < m; j++) {
            if (g[i][j] == '.' || g[i][j] == 'A') {
                dp[i][j] = 1;
                if (i < n - 1) {
                    dp[i][j] += dp[i + 1][j];
                }
            }
        }
    }

    rect ans;
    ans.x1 = -1;
    for (int i = 0; i <= y; i++) {
        rect now = solve(dp[i], i, x, y);

        if (now.x1 == -1) continue;
        if (ans.x1 == -1 || ans.get() < now.get()) {
            ans = now;
        }
    }

    for (int i = ans.y1; i <= ans.y2; i++) {
        for (int j = ans.x1; j <= ans.x2; j++) {
            if (g[i][j] != 'A') g[i][j] = 'a';
        }
    }

    if (ans.y1 > 0) fill_t(g, 0, 0, m - 1, ans.y1 - 1);
    if (ans.y2 + 1 < n) fill_t(g, 0, ans.y2 + 1, m - 1, n - 1);
    if (ans.x1 > 0) fill_t(g, 0, ans.y1, ans.x1 - 1, ans.y2);
    if (ans.x2 + 1 < m) fill_t(g, ans.x2 + 1, ans.y1, m - 1, ans.y2);

    for (auto e : g) {
        for (auto ee : e) cout << ee;
        cout << endl;
    }
}
