#include <iostream>
#include <cstdlib>
#include <vector>
#include <queue>

using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    vector<int> dist(n, 100000001);
    vector<int> teams(n, 0);
    vector<vector<int> > graph(n);
    queue<int> q;

    for (int i = 1; i < n; i++) {
        int from, to;
        cin >> from >> to;
        --from;
        --to;
        graph[from].push_back(to);
        graph[to].push_back(from);
    }

    for (int i = 0; i < m; i++) {
        int team;
        cin >> team;
        team--;
        dist[team] = 0;
        teams[team] = 1;
        q.push(team);
    }

    if (m == 1) {
        cout << "YES\n" << q.front() + 1 << endl;
        return 0;
    }

    while (!q.empty()) {
        int cur = q.front();
        q.pop();
        for (int i : graph[cur]) {
            if (teams[i] == 0) {
                dist[i] = dist[cur] + 1;
                teams[i] = 1;
                q.push(i);
            }
            else if (dist[i] == dist[cur] + 1) {
                teams[i] += teams[cur];
                if (teams[i] == m) {
                    cout << "YES\n" << i + 1 << endl;
                    return 0;
                }
            }
        }
    }

    cout << "NO" << endl;
    return 0;
}
