#include <iostream>
#include <cstdlib>
#include <vector>
#include <queue>

using namespace std;

vector<vector<int> > graph;
vector<int> isTeam;
vector<int> pred;

pair<int, int> dfs(int v, int dist) {
    if (dist != 0 && isTeam[v]) {
        return make_pair(dist, v);
    }
    for (int nxt : graph[v]) {
        if (pred[nxt] == -1) {
            pred[nxt] = v;
            pair <int, int> p = dfs(nxt, dist + 1);
            if (p.first != -1) {
                return p;
            }
        }
    }

    return make_pair(-1, -1);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    pred.resize(n, -1);
    isTeam.resize(n, 0);
    vector<int> dist(n, -1);
    vector<int> teams(m);
    graph.resize(n);

    for (int i = 1; i < n; i++) {
        int from, to;
        cin >> from >> to;
        --from;
        --to;
        graph[from].push_back(to);
        graph[to].push_back(from);
    }

    for (int i = 0; i < m; i++) {
        int team;
        cin >> team;
        team--;
        isTeam[team] = 1;
        teams[i] = team;
    }

    if (m == 1) {
        cout << "YES\n" << teams[0] + 1 << endl;
        return 0;
    }

    pred[teams[0]] = -2;
    pair<int, int> kek = dfs(teams[0], 0);
    int l = kek.first;
    int v = kek.second;

    if (l & 1) {
        cout << "NO" << endl;
        return 0;
    }

    int center = v;
    for (int i = 0; i < l - i; i++) {
        center = pred[center];
    }

    queue<int> q;
    dist[center] = 0;
    q.push(center);

    while (!q.empty()) {
        int cur = q.front();
        q.pop();
        for (int i : graph[cur]) {
            if (dist[i] == -1) {
                dist[i] = dist[cur] + 1;
                q.push(i);
            }
        }
    }


    int curdist = -1;

    for (int i : teams) {
        if (curdist == -1) {
            curdist = dist[i];
        }
        else if (curdist != dist[i]) {
            cout << "NO" << endl;
            return 0;
        }
    }

    cout << "YES\n" << center + 1 << endl;

    return 0;
}
